; ======================================================
;  Fellow Amiga Emulator      
;  Host screen drawing of amiga screen            
;  (C) 1993-1998 Petter Schau 
; ======================================================


        .586p
DGROUP group _DATA,_BSS
_TEXT  segment para public use32 'CODE'
       assume cs:_TEXT, ds:DGROUP, ss:DGROUP

public drawstart_
drawstart_:                             ; Used to check code alignment
startlbl:

include defs.inc
include func\graphem.inc
include func\copper.inc

                        ALIGN32

public drawham_
drawham_:               mov     ebp,dword ptr _DIWlastvisiblepos
                        mov     edi,dword ptr _DIWfirstvisiblepos
                        sub     ebp,edi
                        mov     edx,dword ptr _screenptr
                        xor     esi,esi
                        test    ebp,ebp
                        jz      dhlexit
dhl:                    mov     cl,byte ptr _linje[edi]
                        xor     ebx,ebx
                        mov     bl,cl                     ; Pixel 1
                        test    cl,0c0h
                        jz      dhlnormal
                        and     bl,0c0h
                        cmp     bl,0c0h
                        je      dhlgreen
                        cmp     bl,80h
                        je      dhlred
                        mov     bl,cl           ; Blue component to be exchanged
                        shr     bl, 2
                        and     bl,0fh
                        mov     cl, byte ptr _HAMBluePos
                        shl     bl, cl
                        and     esi, dword ptr _HAMBlueMask   ; Mask away old blue
                        or      esi,ebx
                        shl     ebx,16
                        or      esi,ebx
                        jmp     dhldraw
dhlred:                 mov     ebx,ecx           ; Red component to be exchanged
                        shr     ebx, 2
                        and     ebx,0fh
                        mov     cl, byte ptr _HAMRedPos
                        shl     ebx, cl
                        and     esi, dword ptr _HAMRedMask ; Mask away old red
                        or      esi,ebx
                        shl     ebx,16
                        or      esi,ebx
                        jmp     dhldraw
dhlgreen:               mov     ebx,ecx           ; Green component to be exchanged
                        shr     ebx, 2
                        and     ebx,0fh
                        mov     cl, byte ptr _HAMGreenPos
                        shl     ebx, cl
                        and     esi, dword ptr _HAMGreenMask ; Mask away old green
                        or      esi,ebx
                        shl     ebx,16
                        or      esi,ebx
                        jmp     dhldraw
dhlnormal:              mov     esi,dword ptr [_shadcol + ebx]
dhldraw:                mov     dword ptr [edx],esi
                        add     edx,4
                        inc     edi
                        dec     ebp
                        jnz     dhl
			mov	ecx,dword ptr [_screenptr]
	                mov     dword ptr _screenptr,edx
			mov	edx,ecx
			jmp	mergesprites_ham_hiw_
dhlexit:		ret

#ifndef DRAW_C

;Width 320
                        ALIGN32

public drawddfline320w_
drawddfline320w_:
                        pushad
                        mov     ebp,[_ypos]
                        cmp     ebp,[_cliptop]
                        jb      drawddf320wnothing
                        cmp     ebp,[_clipbot]
                        jae     drawddf320wnothing
                        mov     dword ptr [_lineflags+4*ebp],-1
                        mov     dl,byte ptr [_configdoublebuffer]
                        mov     byte ptr [_lineflagstimes + ebp],dl
                        call    dword ptr [_decoderoutineptr]
                        test    byte ptr [_spritesonline],1
                        jz      drawddf320wnosprite
			test	byte ptr [_bplcon0 + 1],8
			jnz	drawddf320wnosprite
                        call    mergesprites
                        mov     byte ptr [_spritesonline],0
drawddf320wnosprite:    mov     eax,[_clipleftx]
                        mov     ebx,[_DIWfirstvisiblepos]
                        test    byte ptr [_bplcon0+1],080h
                        jz      drawddf320wfrontlo
                        shr     ebx,1
drawddf320wfrontlo:     sub     ebx,eax
                        jle     drawddf320wnobgf
                        call    fillbg320w_
drawddf320wnobgf:       call    dword ptr [_drawroutineptr]
                        mov     eax,[_DIWlastvisiblepos]
                        mov     ebx,[_cliprightx]
                        test    byte ptr [_bplcon0+1],080h
                        jz      drawddf320wbehindlo
                        shr     eax,1
drawddf320wbehindlo:    sub     ebx,eax
                        jle     drawddf320wnobgb
                        call    fillbg320w_
drawddf320wnobgb:       mov     eax,[_draw_scanlinemodulo]
                        add     [_screenptr],eax
                        popad
                        ret
drawddf320wnothing:     call    dummydecode_
                        popad
                        ret

                
                        ALIGN32

public drawddfline320b_
drawddfline320b_:       pushad
                        mov     ebp,[_ypos]
                        cmp     ebp,[_cliptop]
                        jb      drawddf320bnothing
                        cmp     ebp,[_clipbot]
                        jae     drawddf320bnothing
                        mov     dword ptr [_lineflags+4*ebp],-1
                        mov     dl,byte ptr [_configdoublebuffer]
                        mov     byte ptr [_lineflagstimes + ebp],dl
                        call    dword ptr [_decoderoutineptr]
                        test    byte ptr [_spritesonline],1
                        jz      drawddf320bnosprite
			test	byte ptr [_bplcon0 + 1],8
			jnz	drawddf320bnosprite
                        call    mergesprites
                        mov     byte ptr [_spritesonline],0
drawddf320bnosprite:    mov     eax,[_clipleftx]
                        mov     ebx,[_DIWfirstvisiblepos]
                        test    byte ptr [_bplcon0+1],080h
                        jz      drawddf320bfrontlo
                        shr     ebx,1
drawddf320bfrontlo:     sub     ebx,eax
                        jle     drawddf320bnobgf
                        call    fillbg320b_
drawddf320bnobgf:       call    dword ptr [_drawroutineptr]
                        mov     eax,[_DIWlastvisiblepos]
                        mov     ebx,[_cliprightx]
                        test    byte ptr [_bplcon0+1],080h
                        jz      drawddf320bbehindlo
                        shr     eax,1
drawddf320bbehindlo:    sub     ebx,eax
                        jle     drawddf320bnobgb
                        call    fillbg320b_
drawddf320bnobgb:       mov     eax,[_draw_scanlinemodulo]
                        add     [_screenptr],eax
                        popad
                        ret
drawddf320bnothing:     call    dummydecode_
                        popad
                        ret

                
                        ALIGN32

public drawddfline640w_
drawddfline640w_:       pushad
                        mov     ebp,[_ypos]
                        cmp     ebp,[_cliptop]
                        jb      drawddf640wnothing
                        cmp     ebp,[_clipbot]
                        jae     drawddf640wnothing
                        mov     dword ptr [_lineflags+4*ebp],-1
                        mov     dl,byte ptr [_configdoublebuffer]
                        mov     byte ptr [_lineflagstimes + ebp],dl
                        call    dword ptr [_decoderoutineptr]
                        test    byte ptr [_spritesonline],1
                        jz      drawddf640wnosprite
			test	byte ptr [_bplcon0 + 1],8
			jnz	drawddf640wnosprite
                        call    mergesprites
                        mov     byte ptr [_spritesonline],0
drawddf640wnosprite:    mov     eax,[_clipleftx]
                        mov     ebx,[_DIWfirstvisiblepos]
                        test    byte ptr [_bplcon0+1],080h
                        jz      drawddf640wfrontlo
                        shr     ebx,1
drawddf640wfrontlo:     sub     ebx,eax
                        jle     drawddf640wnobgf
                        call    fillbg800w_
drawddf640wnobgf:       call    dword ptr [_drawroutineptr]
                        mov     eax,[_DIWlastvisiblepos]
                        mov     ebx,[_cliprightx]
                        test    byte ptr [_bplcon0+1],080h
                        jz      drawddf640wbehindlo
                        shr     eax,1
drawddf640wbehindlo:    sub     ebx,eax
                        jle     drawddf640wnobgb
                        call    fillbg800w_
drawddf640wnobgb:       mov     eax,[_draw_scanlinemodulo]
                        add     [_screenptr],eax
                        popad
                        ret
drawddf640wnothing:     call    dummydecode_
                        popad
                        ret

                
                        ALIGN32

dummydecode_:           mov     edx,[_bplcon0]
                        shr     edx,12
                        and     edx,07h
                        mov     ecx,[_DDFnumberofwords]
                        shl     ecx,1
                        mov     ebx,[_bpl1mod]
                        mov     eax,[_bpl2mod]
                        jmp     dword ptr [dummydecodetable + edx*4]
ddec6:                  add     [_bpl6pt],ecx
                        add     [_bpl6pt],eax
ddec5:                  add     [_bpl5pt],ecx
                        add     [_bpl5pt],ebx
ddec4:                  add     [_bpl4pt],ecx
                        add     [_bpl4pt],eax
ddec3:                  add     [_bpl3pt],ecx
                        add     [_bpl3pt],ebx
ddec2:                  add     [_bpl2pt],ecx
                        add     [_bpl2pt],eax
ddec1:                  add     [_bpl1pt],ecx
                        add     [_bpl1pt],ebx
ddec0:                  ret


; ebx - number of lores pixels to draw

                        ALIGN32

fillbg320b_:            mov     esi,dword ptr [_screenptr]
                        mov     eax,dword ptr [_shadcol]
                        cmp     ebx,4
                        jb      fbg320b1
fbg320b2:               mov     [esi],eax
                        sub     ebx,4
                        add     esi,4
                        cmp     ebx,4
                        jae     fbg320b2
fbg320b1:               test    ebx,ebx
                        jz      fbg320b3
fbg320b4:               mov     [esi],al
                        inc     esi
                        dec     ebx
                        jnz     fbg320b4
fbg320b3:               mov     [_screenptr],esi
                        ret

                        ALIGN32

public drawbgline640w_
drawbgline640w_:        pushad
                        mov     ebp,[_ypos]
                        cmp     ebp,[_cliptop]
                        jb      dbg640wexit
                        cmp     ebp,[_clipbot]
                        jae     dbg640wexit
                        mov     ebx,[_shadcol]
                        mov     ecx,[_lineflags+4*ebp]
                        mov     edx,[_configdoublebuffer]
                        cmp     ecx,ebx
                        jne     dbg640wnewcolor
                        mov     dl,byte ptr [_lineflagstimes + ebp]
                        test    dl,dl
                        jz      dbg640wnodraw
                        dec     dl
dbg640wnewcolor:        mov     [_lineflags+4*ebp],ebx
                        mov     byte ptr [_lineflagstimes + ebp],dl
                        mov     eax,[_screenptr]
                        mov     ebp,20                 
dbg640wloop:            mov     [eax],ebx
                        mov     4[eax],ebx
                        mov     8[eax],ebx
                        mov     12[eax],ebx
                        mov     16[eax],ebx
                        mov     20[eax],ebx
                        mov     24[eax],ebx
                        mov     28[eax],ebx
                        mov     32[eax],ebx
                        mov     36[eax],ebx
                        mov     40[eax],ebx
                        mov     44[eax],ebx
                        mov     48[eax],ebx
                        mov     52[eax],ebx
                        mov     56[eax],ebx
                        mov     60[eax],ebx
                        add     eax,64
                        dec     ebp
                        jnz     dbg640wloop
                        add     eax,[_draw_scanlinemodulo]
                        mov     [_screenptr],eax
dbg640wexit:            popad
                        ret
dbg640wnodraw:
                        mov     eax,[_draw_scanlinemodulo]
                        add     eax,1280
                        add     [_screenptr],eax
                        popad
                        ret


                        ALIGN32

public drawbgline320b_
drawbgline320b_:        pushad
                        mov     ebp,[_ypos]
                        cmp     ebp,[_cliptop]
                        jb      drawbg320bouttahere
                        cmp     ebp,[_clipbot]
                        jae     drawbg320bouttahere
                        mov     ebx,[_shadcol]
                        mov     ecx,[_lineflags+4*ebp]
                        mov     edx,[_configdoublebuffer]
                        cmp     ecx,ebx
                        jne     drawbgit320b
                        mov     dl,byte ptr [_lineflagstimes + ebp]
                        test    dl,dl
                        jz      iminheaven1320b
                        dec     dl
drawbgit320b:           mov     byte ptr [_lineflagstimes + ebp],dl
                        mov     [_lineflags+4*ebp],ebx
                        mov     ebx,[_shadcol]
                        mov     eax,[_screenptr]
                        mov     ebp,dword ptr [_cliprightx]
                        sub     ebp,dword ptr [_clipleftx]
                        cmp     ebp,320
                        jne     drawbg320bx1
                        mov     ebp,5
                        jmp     dbl320b
drawbg320bx1:           mov     ebp,6
dbl320b:                mov     [eax],ebx
                        mov     4[eax],ebx
                        mov     8[eax],ebx
                        mov     12[eax],ebx
                        mov     16[eax],ebx
                        mov     20[eax],ebx
                        mov     24[eax],ebx
                        mov     28[eax],ebx
                        mov     32[eax],ebx
                        mov     36[eax],ebx
                        mov     40[eax],ebx
                        mov     44[eax],ebx
                        mov     48[eax],ebx
                        mov     52[eax],ebx
                        mov     56[eax],ebx
                        mov     60[eax],ebx
                        add     eax,64
                        dec     ebp
                        jnz     dbl320b
                        add     eax,[_draw_scanlinemodulo]
                        mov     [_screenptr],eax
drawbg320bouttahere:    popad
                        ret
iminheaven1320b:        mov     eax,dword ptr [_cliprightx]
                        sub     eax,dword ptr [_clipleftx]
                        add     eax,[_draw_scanlinemodulo]
                        add     [_screenptr],eax
                        popad
                        ret

                        ALIGN32

public drawlores640w_
drawlores640w_:         mov     ebp,[_DIWlastvisiblepos]
                        mov     eax,[_DIWfirstvisiblepos]
                        mov     edx,[_screenptr]
                        cmp     eax,[_clipleftx]
                        jae     dl640wleftnoclip
                        mov     eax,[_clipleftx]
dl640wleftnoclip:       cmp     ebp,[_cliprightx]
                        jbe     dl640wrightnoclip
                        mov     ebp,[_cliprightx]
dl640wrightnoclip:      sub     ebp,eax
                        jle     dl640wexit
                        xor     ebx,ebx
                        cmp     ebp,4
                        jl      dl640wlastloop
dl640wloop:             mov     ecx,[_linje+eax]
                        mov     bl,cl
                        mov     esi,[_shadcol+ebx]
                        mov     [edx],esi
                        mov     bl,ch
                        mov     esi,[_shadcol+ebx]
                        shr     ecx,16
                        mov     4[edx],esi
                        mov     bl,cl
                        mov     esi,[_shadcol+ebx]
                        mov     8[edx],esi
                        mov     bl,ch
                        mov     esi,[_shadcol+ebx]
                        mov     12[edx],esi
                        add     edx,16
                        sub     ebp,4
                        add     eax,4
                        cmp     ebp,4
                        jae     dl640wloop
                        test    ebp,ebp
                        jz      dl640wexit
dl640wlastloop:         mov     bl,byte ptr [_linje+eax]
                        mov     esi,[_shadcol+ebx]
                        mov     [edx],esi
                        add     edx,4
                        inc     eax
                        dec     ebp
                        jnz     dl640wlastloop
dl640wexit:             mov     [_screenptr],edx
                        ret


                        ALIGN32

public drawhires640w_
drawhires640w_:         mov     ebp,[_DIWlastvisiblepos]
                        mov     eax,[_DIWfirstvisiblepos]
                        mov     edx,[_screenptr]
                        mov     ebx,[_clipleftx]
                        mov     ecx,[_cliprightx]
                        shl     ebx,1
                        shl     ecx,1
                        cmp     eax,ebx
                        jae     dh640wleftnoclip
                        mov     eax,ebx
dh640wleftnoclip:       cmp     ebp,ecx
                        jbe     dh640wrightnoclip
                        mov     ebp,ecx
dh640wrightnoclip:      sub     ebp,eax
                        jle     dh640wexit
                        xor     ebx,ebx
                        cmp     ebp,4
                        jl      dh640wlastloop
dh640wloop:             mov     ecx,[_linje + eax]
                        mov     bl,ch
                        mov     esi,[_shadcol + ebx]
                        mov     bl,cl
                        mov     si,word ptr [_shadcol + ebx]
                        shr     ecx,16
                        mov     [edx],esi
                        mov     bl,ch
                        mov     esi,[_shadcol + ebx]
                        mov     bl,cl
                        mov     si,word ptr [_shadcol + ebx]
                        mov     4[edx],esi
                        add     edx,8
                        sub     ebp,4
                        add     eax,4
                        cmp     ebp,4
                        jae     dh640wloop
                        test    ebp,ebp
                        jz      dh640wexit
dh640wlastloop:         mov     bl,byte ptr [_linje + eax]
                        mov     esi,[_shadcol + ebx]
                        mov     [edx],si
                        add     edx,2
                        inc     eax
                        dec     ebp
                        jnz     dh640wlastloop
dh640wexit:             mov     [_screenptr],edx
                        ret

                        ALIGN32

public drawlores320b_
drawlores320b_:         mov     esi,[_screenptr]
                        mov     ebp,[_DIWlastvisiblepos]
                        mov     edi,[_DIWfirstvisiblepos]
                        test    byte ptr [_bplcon0+1],080h
                        jz      dl320blores
                        shr     ebp,1
                        shr     edi,1
dl320blores:            cmp     edi,[_clipleftx]
                        jae     dl320bleftnoclip
                        mov     edi,[_clipleftx]
dl320bleftnoclip:       cmp     ebp,[_cliprightx]
                        jbe     dl320brightnoclip
                        mov     ebp,[_cliprightx]
dl320brightnoclip:      sub     ebp,edi
                        xor     ebx,ebx
                        xor     eax,eax
                        cmp     ebp,4
                        jl      dl320blast4
                        test    esi,1h
                        jz      dl320balign2
                        mov     al,byte ptr [_linje+edi]
                        mov     dl,byte ptr [_shadcol+eax]
                        mov     [esi],dl
                        inc     esi
                        inc     edi
                        dec     ebp
                        cmp     ebp,4
                        jl      dl320blast4
dl320balign2:           test    esi,2h
                        jz      drlo320b
                        mov     al,byte ptr [_linje + edi]
                        mov     bl,byte ptr [_linje + 1 + edi]
                        mov     dl,byte ptr [_shadcol + eax]
                        mov     dh,byte ptr [_shadcol + ebx]
                        mov     [esi],dx
                        add     esi,2
                        add     edi,2
                        sub     ebp,2
                        cmp     ebp,4
                        jl      dl320blast4
drlo320b:               mov     ecx,[_linje+edi]
                        add     edi,4                  
                        mov     bl,ch                  
                        sub     ebp,4                  
                        mov     al,cl                  
                        shr     ecx,16                 
                        mov     dh,byte ptr [_shadcol+ebx]  
                        mov     bl,ch                        
                        mov     dl,byte ptr [_shadcol+eax]    
                        mov     al,cl                        
                        shl     edx,16
                        mov     dh,byte ptr [_shadcol+ebx]  
                        mov     dl,byte ptr [_shadcol+eax]    
                        rol     edx,16
                        mov     [esi],edx
                        add     esi,4                        
                        cmp     ebp,4                        
                        jae     drlo320b                  
dl320blast4:            test    ebp,ebp
                        jz      dl320bexit
dl320blastloop:         mov     bl,byte ptr [_linje+edi]
                        mov     edx,[_shadcol+ebx]
                        mov     [esi],dl
                        inc     edi
                        inc     esi
                        dec     ebp
                        jnz     dl320blastloop
dl320bexit:             mov     [_screenptr],esi
                        ret

                        ALIGN32

public drawduallores640w_
drawduallores640w_:     mov     esi,[_screenptr]
                        mov     ebp,[_DIWlastvisiblepos]
                        mov     eax,[_DIWfirstvisiblepos]

                        cmp     eax,[_clipleftx]
                        jae     ddl640wleftnoclip
                        mov     eax,[_clipleftx]
ddl640wleftnoclip:      cmp     ebp,[_cliprightx]
                        jbe     ddl640wrightnoclip
                        mov     ebp,[_cliprightx]
ddl640wrightnoclip:     sub     ebp,eax
                        jle     ddl640wexit
                        lea     edi,[_dualtranslate]
                        test    byte ptr [_bplcon2],040h
                        jnz     ddl640wprinotset
                        add     edi,010000h
ddl640wprinotset:       xor     ebx,ebx
                        cmp     ebp,4
                        jl      ddl640wlast
ddl640w:                mov     ecx,[_linje+eax]
                        mov     edx,[_linje2+eax]
                        push    ebp
                        mov     bh,cl       
                        push    eax   
                        mov     bl,dl 
                        xor     eax,eax
                        mov     al,[edi+ebx] 
                        mov     ebp,[_shadcol+eax]     
                        mov     [esi],ebp       
                        mov     bh,ch                            
                        shr     ecx,16                          
                        mov     bl,dh                           
                        shr     edx,16                          
                        mov     al,[edi+ebx]           
                        mov     ebp,[_shadcol+eax]     
                        mov     4[esi],ebp             
                        mov     bh,cl
                        mov     bl,dl
                        mov     al,[edi+ebx]
                        mov     ebp,[_shadcol+eax]
                        mov     8[esi],ebp
                        mov     bh,ch
                        mov     bl,dh
                        mov     al,[edi+ebx]
                        mov     ebp,[_shadcol+eax]
                        mov     12[esi],ebp
                        pop     eax
                        pop     ebp
                        add     esi,16
                        sub     ebp,4
                        add     eax,4
                        cmp     ebp,4
                        jae     ddl640w
                        test    ebp,ebp
                        jz      ddl640wexit
ddl640wlast:            xor     ecx,ecx
ddl640wlastloop:        mov     bh,byte ptr [_linje+eax]
                        mov     bl,byte ptr [_linje2+eax]
                        inc     eax
                        mov     cl,[edi+ebx]
                        mov     edx,[_shadcol+ecx]
                        mov     [esi],edx
                        add     esi,4
                        dec     ebp
                        jnz     ddl640wlastloop
ddl640wexit:            mov     [_screenptr],esi
                        ret


                        ALIGN32

public drawdualhires640w_
drawdualhires640w_:     mov     esi,[_screenptr]
                        mov     ebp,[_DIWlastvisiblepos]
                        mov     eax,[_DIWfirstvisiblepos]

                        mov     ebx,[_clipleftx]
                        mov     ecx,[_cliprightx]
                        shl     ebx,1
                        shl     ecx,1
                        cmp     eax,ebx
                        jae     ddh640wleftnoclip
                        mov     eax,ebx
ddh640wleftnoclip:      cmp     ebp,ecx
                        jbe     ddh640wrightnoclip
                        mov     ebp,ecx
ddh640wrightnoclip:     sub     ebp,eax
                        jle     ddh640wexit
                        lea     edi,[_dualtranslate]
                        test    byte ptr [_bplcon2],040h
                        jnz     ddh640wprinotset
                        add     edi,010000h
ddh640wprinotset:       xor     ebx,ebx
                        cmp     ebp,4
                        jl      ddh640wlast
ddh640w:                mov     ecx,[_linje+eax]
                        mov     edx,[_linje2+eax]
                        push    ebp
                        mov     bh,ch       
                        push    eax   
                        mov     bl,dh 
                        xor     eax,eax
                        mov     al,[edi+ebx] 
                        mov     ebp,[_shadcol+eax]     
                        mov     bh,cl                            
                        shr     ecx,16                          
                        mov     bl,dl                           
                        shr     edx,16                          
                        mov     al,[edi+ebx]           
                        mov     bp,word ptr [_shadcol+eax]     
                        mov     [esi],ebp             
                        mov     bh,ch
                        mov     bl,dh
                        mov     al,[edi+ebx]
                        mov     ebp,[_shadcol+eax]
                        mov     bh,cl
                        mov     bl,dl
                        mov     al,[edi+ebx]
                        mov     bp,word ptr [_shadcol+eax]
                        mov     4[esi],ebp
                        pop     eax
                        pop     ebp
                        add     esi,8
                        sub     ebp,4
                        add     eax,4
                        cmp     ebp,4
                        jae     ddh640w
                        test    ebp,ebp
                        jz      ddh640wexit
ddh640wlast:            xor     ecx,ecx
ddh640wlastloop:        mov     bh,byte ptr [_linje+eax]
                        mov     bl,byte ptr [_linje2+eax]
                        inc     eax
                        mov     cl,[edi+ebx]
                        mov     edx,[_shadcol+ecx]
                        mov     [esi],dx
                        add     esi,2
                        dec     ebp
                        jnz     ddh640wlastloop
ddh640wexit:            mov     [_screenptr],esi
                        ret


                        ALIGN32

public drawduallores320W_
drawduallores320w_:     mov     esi,[_screenptr]
                        mov     ebp,[_DIWlastvisiblepos]
                        mov     eax,[_DIWfirstvisiblepos]
                        test    byte ptr [_bplcon0+1],080h
                        jz      ddul320wlores
                        shr     ebp,1
                        shr     eax,1
ddul320wlores:          cmp     eax,[_clipleftx]
                        jae     ddul320wleftnoclip
                        mov     eax,[_clipleftx]
ddul320wleftnoclip:     cmp     ebp,[_cliprightx]
                        jbe     ddul320wrightnoclip
                        mov     ebp,[_cliprightx]
ddul320wrightnoclip:    sub     ebp,eax
                        lea     edi,[_dualtranslate]
                        test    byte ptr [_bplcon2],040h
                        jnz     drdual320lopriunset
                        add     edi,010000h
drdual320lopriunset:    xor     ebx,ebx
                        xor     ecx,ecx
                        cmp     ebp,2
                        jl      dual320last
                        test    esi,03h                 ; Align VGA-pointer
                        jz      drduallo320
                        mov     bh,byte ptr [_linje+eax]
                        mov     bl,byte ptr [_linje2+eax]
                        mov     cl,[edi+ebx]
                        mov     edx,[_shadcol+ecx]    
                        mov     [esi],dx 
                        add     esi,2
                        inc     eax
                        dec     ebp
                        cmp     ebp,2
                        jl      dual320last
drduallo320:            mov     bh,byte ptr [_linje+1+eax]
                        mov     bl,byte ptr [_linje2+1+eax]
                        mov     cl,[edi+ebx]
                        mov     edx,[_shadcol+ecx]    
                        mov     bh,byte ptr [_linje+eax]      
                        mov     bl,byte ptr [_linje2+eax]  
                        mov     cl,[edi+ebx]
                        mov     dx,word ptr [_shadcol+ecx]
                        mov     [esi],edx 
                        sub     ebp,2
                        add     esi,4
                        add     eax,2
                        cmp     ebp,2
                        jae     drduallo320
dual320last:            test    ebp,ebp
                        jz      dual320exit
                        mov     bh,byte ptr [_linje+eax]
                        mov     bl,byte ptr [_linje2+eax]
                        mov     cl,[edi+ebx]
                        mov     dx,word ptr [_shadcol+ecx]
                        mov     [esi],dx
                        add     esi,2
dual320exit:            mov     [_screenptr],esi
                        ret


                        ALIGN32

public drawduallores320b_
drawduallores320b_:     mov     esi,[_screenptr]
                        mov     ebp,[_DIWlastvisiblepos]
                        mov     eax,[_DIWfirstvisiblepos]
                        test    byte ptr [_bplcon0+1],080h
                        jz      ddul320blores
                        shr     ebp,1
                        shr     eax,1
ddul320blores:          cmp     eax,[_clipleftx]
                        jae     ddul320bleftnoclip
                        mov     eax,[_clipleftx]
ddul320bleftnoclip:     cmp     ebp,[_cliprightx]
                        jbe     ddul320brightnoclip
                        mov     ebp,[_cliprightx]
ddul320brightnoclip:    sub     ebp,eax
                        lea     edi,[_dualtranslate]
                        test    byte ptr [_bplcon2],040h
                        jnz     drdual320blopriunset
                        add     edi,010000h
drdual320blopriunset:   xor     ebx,ebx
                        xor     ecx,ecx
                        cmp     ebp,4
                        jl      dual320blast
                        test    esi,01h                 ; Align VGA-pointer
                        jz      drduallo320balign2
                        mov     bh,byte ptr [_linje+eax]
                        mov     bl,byte ptr [_linje2+eax]
                        mov     cl,[edi+ebx]
                        mov     edx,[_shadcol+ecx]    
                        mov     [esi],dl 
                        inc     esi
                        inc     eax
                        dec     ebp
                        cmp     ebp,4
                        jl      dual320blast
drduallo320balign2:     test    esi,02h                 ; Align VGA-pointer
                        jz      drduallo320b
                        mov     bh,byte ptr [_linje+eax]
                        mov     bl,byte ptr [_linje2+eax]
                        mov     cl,[edi+ebx]
                        mov     edx,[_shadcol+ecx]    
                        mov     bh,byte ptr [_linje+1+eax]
                        mov     bl,byte ptr [_linje2+1+eax]
                        mov     cl,[edi+ebx]
                        mov     dh,byte ptr [_shadcol+ecx]    
                        mov     [esi],dx
                        add     esi,2
                        add     eax,2
                        sub     ebp,2
                        cmp     ebp,4
                        jl      dual320blast
drduallo320b:
                        mov     bh,byte ptr [_linje+1+eax]
                        mov     bl,byte ptr [_linje2+1+eax]
                        mov     cl,[edi+ebx]
                        mov     dh,byte ptr [_shadcol+ecx]    
                        mov     bh,byte ptr [_linje+eax]      
                        mov     bl,byte ptr [_linje2+eax]  
                        mov     cl,[edi+ebx]
                        mov     dl,byte ptr [_shadcol+ecx]
                        shl     edx,16
                        mov     bh,byte ptr [_linje+3+eax]
                        mov     bl,byte ptr [_linje2+3+eax]
                        mov     cl,[edi+ebx]
                        mov     dh,byte ptr [_shadcol+ecx]    
                        mov     bh,byte ptr [_linje+2+eax]      
                        mov     bl,byte ptr [_linje2+2+eax]  
                        mov     cl,[edi+ebx]
                        mov     dl,byte ptr [_shadcol+ecx]
                        rol     edx,16
                        mov     [esi],edx
                        sub     ebp,4
                        add     esi,4
                        add     eax,4
                        cmp     ebp,4
                        jae     drduallo320b
dual320blast:           test    ebp,ebp
                        jz      dual320bexit
ddual320blastloop:      mov     bh,byte ptr [_linje+eax]
                        mov     bl,byte ptr [_linje2+eax]
                        mov     cl,[edi+ebx]
                        mov     dl,byte ptr [_shadcol+ecx]
                        mov     [esi],dl
                        inc     eax
                        inc     esi
                        dec     ebp
                        test    ebp,ebp
                        jnz     ddual320blastloop
dual320bexit:           mov     [_screenptr],esi
                        ret

#endif
	
                        ALIGN32

public drawham320W_
drawham320w_:           mov     ebp,[_DIWlastvisiblepos]
                        mov     edi,[_DIWfirstvisiblepos]
                        sub     ebp,edi
                        jz      dhl320exit
                        mov     edx,[_screenptr]
                        xor     esi,esi
dhl320:                 mov     cl,byte ptr [_linje+edi]
                        xor     ebx,ebx
                        mov     bl,cl            
                        test    cl,0c0h
                        jz      dhl320normal
                        and     bl,0c0h
                        cmp     bl,0c0h
                        je      dhl320green
                        cmp     bl,80h
                        je      dhl320red
                        mov     ebx,ecx           ; Blue component to be exchanged
                        and     ebx,03ch
                        shr     ebx,1
                        and     esi,07fe07fe0h   ; Mask away old blue
                        or      esi,ebx
                        shl     ebx,16
                        or      esi,ebx
                        jmp     dhl320draw
dhl320red:              mov     ebx,ecx           ; Red component to be exchanged
                        and     ebx,03ch
                        shl     ebx,9
                        and     esi,03ff03ffh   ; Mask away old red
                        or      esi,ebx
                        shl     ebx,16
                        or      esi,ebx
                        jmp     dhl320draw
dhl320green:            mov     ebx,ecx           ; Green component to be exchanged
                        and     ebx,03ch
                        shl     ebx,4
                        and     esi,07c1f7c1fh   ; Mask away old green
                        or      esi,ebx
                        shl     ebx,16
                        or      esi,ebx
                        jmp     dhl320draw
dhl320normal:           mov     esi,[_shadcol+ebx]
dhl320draw:             cmp     edi,[_clipleftx]
                        jb      dhl320nodraw
                        cmp     edi,[_cliprightx]
                        jae     dhl320nodraw
                        mov     [edx],si
                        add     edx,2
dhl320nodraw:           inc     edi
                        dec     ebp
                        jnz     dhl320
			mov	ecx,dword ptr [_screenptr]
	                mov     dword ptr [_screenptr],edx
			mov	edx,ecx
			jmp	mergesprites_ham_low_
dhl320exit:             ret


	
                        ALIGN32

public drawham320b_
drawham320b_:           mov     ebp,[_DIWlastvisiblepos]
                        mov     edi,[_DIWfirstvisiblepos]
                        sub     ebp,edi
                        jz      dhl320bexit
                        mov     edx,[_screenptr]
                        xor     esi,esi
dhl320b:                mov     cl,byte ptr [_linje+edi]
                        xor     ebx,ebx
                        mov     bl,cl            
                        test    cl,0c0h
                        jz      dhl320bnormal
                        and     bl,0c0h
                        cmp     bl,0c0h
                        je      dhl320bgreen
                        cmp     bl,80h
                        je      dhl320bred
                        mov     ebx,ecx           ; Blue component to be exchanged
                        and     ebx,03ch
                        shr     ebx,2
                        and     esi,0ff0h   ; Mask away old blue
                        or      esi,ebx
                        jmp     dhl320bdraw
dhl320bred:             mov     ebx,ecx           ; Red component to be exchanged
                        and     ebx,03ch
                        shl     ebx,6
                        and     esi,0ffh   ; Mask away old red
                        or      esi,ebx
                        jmp     dhl320bdraw
dhl320bgreen:           mov     ebx,ecx           ; Green component to be exchanged
                        and     ebx,03ch
                        shl     ebx,2
                        and     esi,0f0fh   ; Mask away old green
                        or      esi,ebx
                        jmp     dhl320bdraw
dhl320bnormal:          mov     esi,[_shadcol+ebx]
                        and     esi,0ffh
                        mov     esi,_vgareg2color[esi*4]
dhl320bdraw:            cmp     edi,[_clipleftx]
                        jb      dhl320bnodraw
                        cmp     edi,[_cliprightx]
                        jae     dhl320bnodraw
                        mov     ebx,_colortab[esi*4]
                        mov     [edx],bl
                        inc     edx
dhl320bnodraw:          inc     edi
                        dec     ebp
                        jnz     dhl320b
			mov	ecx,dword ptr [_screenptr]
	                mov     dword ptr _screenptr,edx
			mov	edx,ecx
			jmp	mergesprites_ham_lob_
dhl320bexit:		ret


                        ALIGN32

public drawham640W_
drawham640w_:           mov     ebp,[_DIWlastvisiblepos]
                        mov     edi,[_DIWfirstvisiblepos]
                        sub     ebp,edi
                        jz      dhl640exit
                        mov     edx,[_screenptr]
                        xor     esi,esi
dhl640:                 mov     cl,byte ptr [_linje+edi]
                        xor     ebx,ebx
                        mov     bl,cl            
                        test    cl,0c0h
                        jz      dhl640normal
                        and     bl,0c0h
                        cmp     bl,0c0h
                        je      dhl640green
                        cmp     bl,80h
                        je      dhl640red
                        mov     ebx,ecx           ; Blue component to be exchanged
                        and     ebx,03ch
                        shr     ebx,1
                        and     esi,07fe07fe0h   ; Mask away old blue
                        or      esi,ebx
                        shl     ebx,16
                        or      esi,ebx
                        jmp     dhl640draw
dhl640red:              mov     ebx,ecx           ; Red component to be exchanged
                        and     ebx,03ch
                        shl     ebx,9
                        and     esi,03ff03ffh   ; Mask away old red
                        or      esi,ebx
                        shl     ebx,16
                        or      esi,ebx
                        jmp     dhl640draw
dhl640green:            mov     ebx,ecx           ; Green component to be exchanged
                        and     ebx,03ch
                        shl     ebx,4
                        and     esi,07c1f7c1fh   ; Mask away old green
                        or      esi,ebx
                        shl     ebx,16
                        or      esi,ebx
                        jmp     dhl640draw
dhl640normal:           mov     esi,[_shadcol+ebx]
dhl640draw:             cmp     edi,[_clipleftx]
                        jb      dhl640nodraw
                        cmp     edi,[_cliprightx]
                        jae     dhl640nodraw
                        mov     [edx],esi
                        add     edx,4
dhl640nodraw:           inc     edi
                        dec     ebp
                        jnz     dhl640
			mov	ecx,dword ptr [_screenptr]
	                mov     dword ptr _screenptr,edx
			mov	edx,ecx
			jmp	mergesprites_ham_hiw_
dhl640exit:		ret



#ifndef DRAW_C

; Width 800

                        ALIGN32

public drawddfline_
drawddfline_:		pushad
                        mov     ebp,[_ypos]
                        mov     dword ptr [_lineflags+4*ebp],-1
                        mov     dl,byte ptr [_configdoublebuffer]
                        mov     byte ptr [_lineflagstimes + ebp],dl
                        cmp     ebp,01ah
                        jb      drawddf320wnothing
drawddf800wccnodcols:
                        mov     eax,dword ptr [_screenptr]
                        mov     ebx,dword ptr [_draw_scanlinemodulo]
                        lea     eax,1600[eax+ebx]
                        push    eax
                        mov     eax,dword ptr [_decoderoutineptr]
                        call    eax ;dword ptr [_decoderoutineptr]
                        test    byte ptr [_spritesonline],1
                        jz      drawddfnospritemerge
                        test	byte ptr [_bplcon0 + 1], 8
			jnz	drawddfnospritemerge
			call    mergesprites
                        mov     byte ptr [_spritesonline],0
drawddfnospritemerge:   mov     eax,[_clipleftx]
                        mov     ebx,[_DIWfirstvisiblepos]
                        test    byte ptr [_bplcon0+1],080h
                        jz      drawddffilllores1
                        shr     ebx,1
drawddffilllores1:      sub     ebx,eax
                        jle     drawddfnobgfront
                        call    fillbg800w_
drawddfnobgfront:       call    dword ptr [_drawroutineptr]
                        mov     eax,[_DIWlastvisiblepos]
                        mov     ebx,[_DIWlastposonline]
                        sub     ebx,eax
                        jle     drawddfnobgbehind
                        test    byte ptr [_bplcon0+1],080h
                        jz      drawddffilllores2
                        shr     ebx,1
drawddffilllores2:      call    fillbg800w_
drawddfnobgbehind:      pop     eax
                        mov     [_screenptr],eax
                        popad
                        ret

; Width 800, cycle exact colors

                        ALIGN32

public drawddfline800wCC_
drawddfline800wCC_:     pushad
                        mov     ebp,[_ypos]
                        mov     dword ptr [_lineflags+4*ebp],-1
                        mov     dl,byte ptr [_configdoublebuffer]
                        mov     byte ptr [_lineflagstimes + ebp],dl
                        cmp     ebp,01ah
                        jb      drawddf320wnothing

                        test    dword ptr [_delay_color_total],-1
                        jz      drawddf800wccnodcols
                        mov     eax,dword ptr [_screenptr]
                        mov     ebx,dword ptr [_draw_scanlinemodulo]
                        lea     eax,1600[eax+ebx]
                        push    eax
                        mov     eax,dword ptr [_decoderoutineptr]
                        call    eax ;dword ptr [_decoderoutineptr]
                        test    byte ptr [_spritesonline],1
                        jz      drawddfnospritemergeCC
			test	byte ptr [_bplcon0 + 1],8
			jnz	drawddfnospritemergeCC
                        call    mergesprites
                        mov     byte ptr [_spritesonline],0
drawddfnospritemergeCC: mov     eax,[_DIWfirstposonline]
                        mov     ebx,[_DIWfirstvisiblepos]
                        sub     ebx,eax
                        jle     drawddfnobgfrontCC
                        test    byte ptr [_bplcon0+1],080h
                        jz      drawddffilllores1CC
                        shr     ebx,1
drawddffilllores1CC:    mov     ecx,88
                        call    fillbg800wCC_
drawddfnobgfrontCC:     call    dword ptr [_drawroutineptr]
                        mov     eax,[_DIWlastvisiblepos]
                        mov     ebx,[_DIWlastposonline]
                        sub     ebx,eax
                        jle     drawddfnobgbehindCC
                        test    byte ptr [_bplcon0+1],080h
                        jz      drawddffilllores2CC
                        shr     ebx,1
                        shr     eax,1
drawddffilllores2CC:    mov     ecx,eax
                        call    fillbg800wCC_
drawddfnobgbehindCC:    pop     eax
                        mov     [_screenptr],eax
                        mov     eax,1000
                        call    process_delayed_colors_
                        call    clear_delayed_colors_
                        popad
                        ret


;--------------------------------
; Width: hires (640/800)
;--------------------------------

; ebx - number of lores pixels to draw

                        ALIGN32
public fillbg800w_
fillbg800w_:            mov     esi,[_screenptr]
                        mov     eax,[_shadcol]
                        cmp     ebx,4
                        jb      fbg1
fbg2:                   mov     [esi],eax
                        mov     4[esi],eax
                        mov     8[esi],eax
                        mov     12[esi],eax
                        add     esi,16
                        sub     ebx,4
                        cmp     ebx,4
                        jae     fbg2
fbg1:                   test    ebx,ebx
                        jz      fbg4
fbg3:                   mov     [esi],eax
                        add     esi,4
                        dec     ebx
                        jnz     fbg3
fbg4:                   mov     [_screenptr],esi
                        ret

;--------------------------------
; Width: hires (640/800)
;--------------------------------

; ebx - number of lores pixels to draw
; ecx - first cylinder in fill

                        ALIGN32
public fillbg800wCC_
fillbg800wCC_:          mov     esi,[_screenptr]
                        mov     eax,[_shadcol]
                        cmp     ebx,2
                        jb      fbg1CC
fbg2CC:
                        mov     eax,ecx
                        call    process_delayed_colors_
                        mov     eax,dword ptr [_shadcol]
                        mov     [esi],eax
                        mov     4[esi],eax
                        add     esi,8
                        add     ecx,2
                        sub     ebx,2
                        cmp     ebx,2
                        jae     fbg2CC
fbg1CC:                 test    ebx,ebx
                        jz      fbg4CC
fbg3CC:
                        mov     eax,ecx
                        call    process_delayed_colors_
                        mov     eax,dword ptr [_shadcol]
                        mov     [esi],eax
                        add     esi,4
                        inc     ecx
                        dec     ebx
                        jnz     fbg3CC
fbg4CC:                 mov     [_screenptr],esi
                        ret

                        ALIGN32
public drawbgline800w_
drawbgline800w_:        pushad
                        mov     ebp,[_ypos]
                        cmp     ebp,1ah
                        jb      dbgexit
                        TSC_BEFORE _drawbgline800_tsctmp
                        mov     ebx,[_shadcol]
                        mov     ecx,[_lineflags+4*ebp]
                        mov     edx,[_configdoublebuffer]
                        cmp     byte ptr [_config_graphics_flickerfree],1
                        jne     nodelace
                        mov     edx,2
nodelace:               cmp     ecx,ebx
                        jne     dbgnewcolor
                        mov     dl,byte ptr [_lineflagstimes + ebp]
                        test    dl,dl
                        jz      dbgnodraw
                        dec     dl
dbgnewcolor:            mov     [_lineflags+4*ebp],ebx
                        mov     byte ptr [_lineflagstimes + ebp],dl
                        mov     eax,[_screenptr]
                        mov     ebp,16
dbgloop:                mov     [eax],ebx
                        mov     4[eax],ebx
                        mov     8[eax],ebx
                        mov     12[eax],ebx
                        mov     16[eax],ebx
                        mov     20[eax],ebx
                        mov     24[eax],ebx
                        mov     28[eax],ebx
                        mov     32[eax],ebx
                        mov     36[eax],ebx
                        mov     40[eax],ebx
                        mov     44[eax],ebx
                        mov     48[eax],ebx
                        mov     52[eax],ebx
                        mov     56[eax],ebx
                        mov     60[eax],ebx
                        mov     64[eax],ebx
                        mov     68[eax],ebx
                        mov     72[eax],ebx
                        mov     76[eax],ebx
                        mov     80[eax],ebx
                        mov     84[eax],ebx
                        mov     88[eax],ebx
                        mov     92[eax],ebx
                        add     eax,96
                        dec     ebp
                        jnz     dbgloop
                        add     eax,64
                        add     eax,[_draw_scanlinemodulo]
                        mov     [_screenptr],eax
                        TSC_AFTER _drawbgline800_tsctmp, _drawbgline800_tsc, _drawbgline800_tsctimes
dbgexit:                popad
                        ret
dbgnodraw:              mov     eax,[_draw_scanlinemodulo]
                        add     eax,1600
                        add     [_screenptr],eax
                        TSC_AFTER _drawbgline800_tsctmp, _drawbgline800notdrawn_tsc, _drawbgline800notdrawn_tsctimes
                        popad
                        ret


                        ALIGN32

public drawbgline800wmmx_
public dbgloopmmx_
drawbgline800wmmx_:     pushad
                        mov     ebp,[_ypos]
                        cmp     ebp,1ah
                        jb      dbgexitmmx
                        TSC_BEFORE _drawbgline800mmx_tsctmp

                        mov     ebx,[_shadcol]
                        mov     ecx,[_lineflags + 4*ebp]
                        mov     edx,[_configdoublebuffer]
                        cmp     byte ptr [_config_graphics_flickerfree],1
                        jne     nodelacemmx
                        mov     edx,2
nodelacemmx:            cmp     ecx,ebx
                        jne     dbgnewcolormmx
                        mov     dl,byte ptr [_lineflagstimes + ebp]
                        test    dl,dl
                        jz      dbgnodrawmmx_
                        dec     dl
dbgnewcolormmx:         mov     [_lineflags+4*ebp],ebx
                        mov     byte ptr [_lineflagstimes + ebp],dl
                        mov     eax,[_screenptr]
                        mov     ebp,16
                        movd    mm0,[_shadcol]
                        movq    mm1,mm0
                        psllq   mm1,32
                        por     mm0,mm1
dbgloopmmx_:            movq    [eax],mm0
                        movq    8[eax],mm0
                        movq    16[eax],mm0
                        movq    24[eax],mm0
                        movq    32[eax],mm0
                        movq    40[eax],mm0
                        movq    48[eax],mm0
                        movq    56[eax],mm0
                        movq    64[eax],mm0
                        movq    72[eax],mm0
                        movq    80[eax],mm0
                        movq    88[eax],mm0
                        add     eax,96
                        dec     ebp
                        jnz     dbgloopmmx_
                        add     eax,64
                        add     eax,[_draw_scanlinemodulo]
                        mov     [_screenptr],eax
                        TSC_AFTER _drawbgline800mmx_tsctmp, _drawbgline800mmx_tsc, _drawbgline800mmx_tsctimes
dbgexitmmx:             popad
                        ret
public dbgnodrawmmx_
dbgnodrawmmx_:          mov     eax,[_draw_scanlinemodulo]
                        add     eax,1600
                        add     [_screenptr],eax
                        TSC_AFTER _drawbgline800mmx_tsctmp, _drawbgline800notdrawn_tsc, _drawbgline800notdrawn_tsctimes
                        popad
                        ret

                        ALIGN32

; Cycle-exact
; Test how many color-writes were cached, if none, jump to
; normal routine.

; If the line is divided by color-writes, it must be redrawn next time.

DELAY_COLOR_SET_END_OF_LINE macro CYLINDER
                        push    edx
                        mov     edx,dword ptr [_delay_color_total]
                        mov     word ptr [_delay_color + 8*edx], CYLINDER
                        pop     edx
endm

DELAY_COLOR_PROCESS macro
local myexit
                        push    edx
                        push    ecx
                        push    eax
                        xor     edx,edx
                        xor     ecx,ecx
                        mov     eax,dword ptr [_delay_color_processed]
                        cmp     eax,dword ptr [_delay_color_total]
                        je      myexit
                        mov     cx,word ptr [_delay_color + 2 + 8*eax]
                        mov     dx,word ptr [_delay_color + 4 + 8*eax]
                        inc     eax
                        mov     dword ptr [_delay_color_processed],eax
                        call    wcolor_
myexit:                 pop     eax
                        pop     ecx
                        pop     edx
endm

DELAY_COLOR_CYLINDERS_UNTIL_NEXT macro CURRENT_CYLINDER, DESTREG 
                        mov     DESTREG,dword ptr [_delay_color_processed]
                        mov     DESTREG,dword ptr [_delay_color + 8*DESTREG]
                        and     DESTREG,0ffffh
                        sub     DESTREG,CURRENT_CYLINDER
endm

DELAY_COLOR_DRAW_BACKGROUND macro PIXELS
local myloop, oneleft, myexit
                        cmp     PIXELS,0
                        jle     myexit
                        mov     edx,dword ptr [_shadcol]
                        cmp     PIXELS,1
                        jbe     oneleft
myloop:                 mov     [eax],edx
                        mov     4[eax],edx
                        sub     PIXELS,2
                        add     eax,8
                        cmp     PIXELS,1
                        ja      myloop
oneleft:                test    PIXELS,PIXELS
                        jz      myexit
                        mov     [eax],edx
                        dec     edi
                        add     eax,4
myexit:
endm

public drawbgline800wCC_
drawbgline800wCC_:      pushad
                        mov     ebp,[_ypos]
                        cmp     ebp,1ah
                        jb      dbgexitCC
                        TSC_BEFORE _drawbgline800mmx_tsctmp
                        test    dword ptr [_delay_color_total],-1
                        jnz     dbg800wccdcols
                        popad
                        test    byte ptr [_mmx_detected],1
                        jz      drawbgline800w_
                        jmp     drawbgline800wmmx_

dbg800wccdcols:
                        mov     dword ptr [_lineflags+4*ebp],-1
                        mov     byte ptr [_lineflagstimes+ebp],3

                        ; Draw loop

                        DELAY_COLOR_SET_END_OF_LINE 472
                        mov     eax,[_screenptr]
                        mov     ecx,88          ; Use ecx as position counter
dbg800wloopCC:             
                        DELAY_COLOR_CYLINDERS_UNTIL_NEXT ecx, edi
                        add     ecx,edi

                        DELAY_COLOR_DRAW_BACKGROUND edi
                        DELAY_COLOR_PROCESS

                        cmp     ecx,472
                        jb      dbg800wloopCC

                        add     eax,64
                        add     eax,[_draw_scanlinemodulo]
                        mov     [_screenptr],eax
                        TSC_AFTER _drawbgline800mmx_tsctmp, _drawbgline800mmx_tsc, _drawbgline800mmx_tsctimes
dbgexitCC:
                        mov     eax,1000
                        call    process_delayed_colors_
                        call    clear_delayed_colors_
                        popad
                        ret
public dbgnodrawCC_
dbgnodrawCC_:           mov     eax,[_draw_scanlinemodulo]
                        add     eax,1600
                        add     [_screenptr],eax
                        TSC_AFTER _drawbgline800mmx_tsctmp, _drawbgline800notdrawn_tsc, _drawbgline800notdrawn_tsctimes
                        popad
                        ret


                        ALIGN32

public drawlores800w_
drawlores800w_:		mov	ebp,[_DIWlastvisiblepos]
			mov	edi,[_DIWfirstvisiblepos]
			mov	esi,[_screenptr]
			sub	ebp,edi
			jle	dlexit
drawlores800wnocc:	xor	ebx,ebx
			xor	eax,eax
			xor	edx,edx
			xor	ecx,ecx
			test	esi,0fffffff8h		; One pixel aligns
			jz	drawlores800waligned
			mov	al,byte ptr [_linje + edi]
			mov	eax,dword ptr [_shadcol + eax]
			inc	edi
			mov	[esi],eax
			add	esi,4
			dec	ebp
			jz	dlexit
			xor	eax,eax
drawlores800waligned:	cmp	ebp,4
			jl	dllastloop
dlloop:			mov	ecx,[_linje + edi]
			mov	al,ch
			mov	bl,cl
			mov	edx,[_shadcol + ebx]
			mov	[esi],edx      
			mov	edx,[_shadcol + eax]
			shr	ecx,16
			mov	4[esi],edx
			mov	bl,cl
			mov	al,ch
			mov	edx,[_shadcol + ebx]
			mov	8[esi],edx
			mov	edx,[_shadcol + eax]
			mov	12[esi],edx
			add	esi,16
			sub	ebp,4
			add	edi,4
			cmp	ebp,4
			jae	dlloop
			test	ebp,ebp
			jz	dlexit
dllastloop:		mov	bl,byte ptr [_linje + edi]
			mov	edx,[_shadcol + ebx]
			mov	[esi],edx
			add	esi,4
			inc	edi
			dec	ebp
			jnz	dllastloop
dlexit:			mov	[_screenptr],esi
			ret


                        ALIGN32
public drawlores800wmmx_
public dlloopmmx_
drawlores800wmmx_:	mov	ebp,[_DIWlastvisiblepos]
			mov	edi,[_DIWfirstvisiblepos]
			mov	esi,[_screenptr]
			sub	ebp,edi
			jle	dlexitmmx
drawlores800wmmxnocc:	xor	ebx,ebx
			xor	eax,eax
			xor	edx,edx
			xor	ecx,ecx
			test	esi,0fffffff8h		; One pixel aligns
			jz	drawlores800walignedmmx
			mov	al,byte ptr [_linje + edi]
			mov	eax,dword ptr [_shadcol + eax]
			inc	edi
			mov	[esi],eax
			add	esi,4
			dec	ebp
			jz	dlexitmmx
			xor	eax,eax
drawlores800walignedmmx:cmp	ebp,4
			jl	dllastloopmmx
dlloopmmx_:		mov	al,byte ptr [_linje + edi]
			mov	bl,byte ptr [_linje + 1 + edi]
			mov	cl,byte ptr [_linje + 2 + edi]
			mov	dl,byte ptr [_linje + 3 + edi]
			movd	mm0,[_shadcol + eax]
			movd	mm1,[_shadcol + ebx]
			movd	mm2,[_shadcol + ecx]
			movd	mm3,[_shadcol + edx]
			psllq	mm1,32
			psllq	mm3,32
			por	mm0,mm1
			por	mm2,mm3
			movq	[esi],mm0
			movq	8[esi],mm2
			sub	ebp,4
			add	edi,4
			add	esi,16
			cmp	ebp,4
			jae	dlloopmmx_
			test	ebp,ebp
			jz	dlexitmmx
dllastloopmmx:		mov	bl,byte ptr [_linje+edi]
			mov	edx,[_shadcol + ebx]
			mov	[esi],edx
			add	esi,4
			inc	edi
			dec	ebp
			jnz	dllastloopmmx
dlexitmmx:		mov	[_screenptr],esi
			ret



                        ALIGN32

public drawlores800wCC_
drawlores800wCC_:
                        TSC_BEFORE _drawlores800mmx_tsctmp
                        mov     ebp,[_DIWlastvisiblepos]
                        mov     edi,[_DIWfirstvisiblepos]
                        mov     esi,[_screenptr]
                        sub     ebp,edi
                        jle     dlexitCC
                        test    dword ptr [_delay_color_total],-1
                        jz      drawlores800wnocc
                        xor     ebx,ebx
                        xor     eax,eax
                        xor     edx,edx
                        xor     ecx,ecx
                        test    esi,0fffffff8h          ; One pixel aligns
                        jz      drawlores800walignedCC
                        mov     al,byte ptr [_linje + edi]
                        mov     eax,dword ptr [_shadcol + eax]
                        inc     edi
                        mov     [esi],eax
                        add     esi,4
                        dec     ebp
                        xor     eax,eax
drawlores800walignedCC:
                        cmp     ebp,4
                        jl      dllastloopCC
dlloopCC_:              mov     eax,edi
                        call    process_delayed_colors_
                        xor     eax,eax
                        mov     al,byte ptr [_linje+edi]
                        mov     bl,byte ptr [_linje+1+edi]
                        mov     ecx,[_shadcol + eax]
                        mov     edx,[_shadcol + ebx]
                        mov     [esi],ecx
                        mov     4[esi],edx
                        lea     eax,2[edi]
                        call    process_delayed_colors_
                        xor     eax,eax
                        mov     al,byte ptr [_linje+2+edi]
                        mov     bl,byte ptr [_linje+3+edi]
                        mov     ecx,[_shadcol + eax]
                        mov     edx,[_shadcol + ebx]
                        mov     8[esi],ecx
                        mov     12[esi],edx
                        sub     ebp,4
                        add     edi,4
                        add     esi,16
                        cmp     ebp,4
                        jae     dlloopCC_
                        test    ebp,ebp
                        jz      dlexitCC
dllastloopCC:           mov     bl,byte ptr [_linje+edi]
                        mov     eax,edi
                        call    process_delayed_colors_
                        mov     edx,[_shadcol+ebx]
                        mov     [esi],edx
                        add     esi,4
                        inc     edi
                        dec     ebp
                        jnz     dllastloopCC
dlexitCC:               mov     [_screenptr],esi
                        TSC_AFTER _drawlores800mmx_tsctmp, _drawlores800mmx_tsc, _drawlores800mmx_tsctimes
                        ret



                        ALIGN32

public drawlores800wmmxCC_
drawlores800wmmxCC_:
                        TSC_BEFORE _drawlores800mmx_tsctmp
                        mov     ebp,[_DIWlastvisiblepos]
                        mov     edi,[_DIWfirstvisiblepos]
                        mov     esi,[_screenptr]
                        sub     ebp,edi
                        jle     dlexitmmxCC
                        test    dword ptr [_delay_color_total],-1
                        jz      drawlores800wmmxnocc
                        xor     ebx,ebx
                        xor     eax,eax
                        xor     edx,edx
                        xor     ecx,ecx
                        test    esi,0fffffff8h          ; One pixel aligns
                        jz      drawlores800walignedmmxCC
                        mov     al,byte ptr [_linje + edi]
                        mov     eax,dword ptr [_shadcol + eax]
                        inc     edi
                        mov     [esi],eax
                        add     esi,4
                        dec     ebp
                        xor     eax,eax
drawlores800walignedmmxCC:
                        cmp     ebp,4
                        jl      dllastloopmmxCC
dlloopmmxCC_:           mov     eax,edi
                        call    process_delayed_colors_
                        xor     eax,eax
                        mov     al,byte ptr [_linje+edi]
                        mov     bl,byte ptr [_linje+1+edi]
                        mov     cl,byte ptr [_linje+2+edi]
                        mov     dl,byte ptr [_linje+3+edi]
                        movd    mm0,[_shadcol+eax]
                        movd    mm1,[_shadcol+ebx]
                        lea     eax,2[edi]
                        call    process_delayed_colors_
                        xor     eax,eax
                        movd    mm2,[_shadcol+ecx]
                        movd    mm3,[_shadcol+edx]
                        psllq   mm1,32
                        psllq   mm3,32
                        por     mm0,mm1
                        por     mm2,mm3
                        movq    [esi],mm0
                        movq    8[esi],mm2
                        sub     ebp,4
                        add     edi,4
                        add     esi,16
                        cmp     ebp,4
                        jae     dlloopmmxCC_
                        test    ebp,ebp
                        jz      dlexitmmxCC
dllastloopmmxCC:        mov     bl,byte ptr [_linje+edi]
                        mov     eax,edi
                        call    process_delayed_colors_
                        mov     edx,[_shadcol+ebx]
                        mov     [esi],edx
                        add     esi,4
                        inc     edi
                        dec     ebp
                        jnz     dllastloopmmxCC
dlexitmmxCC:            mov     [_screenptr],esi
                        TSC_AFTER _drawlores800mmx_tsctmp, _drawlores800mmx_tsc, _drawlores800mmx_tsctimes
                        ret


                        ALIGN32

public drawhires800w_
drawhires800w_:
                        mov     ebp,[_DIWlastvisiblepos]
                        mov     edi,[_DIWfirstvisiblepos]
                        mov     esi,[_screenptr]
                        sub     ebp,edi
                        jle     dhexit
drawhires800wnocc:
                        xor     eax,eax
                        xor     ebx,ebx
                        xor     ecx,ecx
                        xor     edx,edx
                        cmp     ebp,4
                        jl      dhlastloop
                        test    esi,06h                 ; align with one pix
                        jz      drawhires800waligned
drawhires800walign8:    mov     al,byte ptr [_linje + edi]
                        dec     ebp
                        mov     ebx,dword ptr [_shadcol + eax]
                        inc     edi
                        mov     [esi],bx
                        add     esi,2
                        test    esi,06h
                        jnz     drawhires800walign8
                        xor     ebx,ebx
drawhires800waligned:   cmp     ebp,4
                        jl      dhlastloop
dhloop:                 mov     ecx,[_linje+edi]
                        mov     bl,ch
                        mov     edx,[_shadcol+ebx]
                        mov     bl,cl
                        mov     dx,word ptr [_shadcol+ebx]
                        shr     ecx,16
                        mov     [esi],edx
                        mov     bl,ch
                        mov     edx,[_shadcol+ebx]
                        mov     bl,cl
                        mov     dx,word ptr [_shadcol+ebx]
                        mov     4[esi],edx
                        add     esi,8
                        sub     ebp,4
                        add     edi,4
                        cmp     ebp,4
                        jae     dhloop
                        test    ebp,ebp
                        jz      dhexit
dhlastloop:             mov     bl,byte ptr [_linje+edi]
                        mov     edx,[_shadcol+ebx]
                        mov     [esi],dx
                        add     esi,2
                        inc     edi
                        dec     ebp
                        jnz     dhlastloop
dhexit:                 mov     [_screenptr],esi
                        ret


                        ALIGN32

public drawhires800wmmx_
drawhires800wmmx_:
                        mov     ebp,[_DIWlastvisiblepos]
                        mov     edi,[_DIWfirstvisiblepos]
                        mov     esi,[_screenptr]
                        sub     ebp,edi
                        jle     dhexitmmx
drawhires800wmmxnocc:
                        xor     eax,eax
                        xor     ebx,ebx
                        xor     ecx,ecx
                        mov     edx,0ffffh
                        movd    mm4,edx
                        movq    mm5,mm4
                        psllq   mm5,16
                        xor     edx,edx
                        cmp     ebp,4
                        jl      dhlastloopmmx
                        test    esi,06h                 ; align with one pix
                        jz      drawhires800walignedmmx
drawhires800walign8mmx: mov     al,byte ptr [_linje + edi]
                        dec     ebp
                        mov     ebx,dword ptr [_shadcol + eax]
                        inc     edi
                        mov     [esi],bx
                        add     esi,2
                        test    esi,06h
                        jnz     drawhires800walign8mmx
                        xor     ebx,ebx
drawhires800walignedmmx:cmp     ebp,4
                        jl      dhlastloopmmx
dhloopmmx:              mov     al,byte ptr [_linje + edi]
                        mov     bl,byte ptr [_linje + 1 + edi]
                        mov     cl,byte ptr [_linje + 2 + edi]
                        mov     dl,byte ptr [_linje + 3 + edi]
                        movd    mm0,[_shadcol + eax]
                        movd    mm1,[_shadcol + ebx]
                        movd    mm2,[_shadcol + ecx]
                        movd    mm3,[_shadcol + edx]
                        pand    mm0,mm4
                        pand    mm1,mm5
                        pand    mm2,mm4
                        psllq   mm3,48
                        psllq   mm2,32
                        por     mm0,mm1
                        por     mm2,mm3
                        por     mm0,mm2
                        movq    [esi],mm0
                        sub     ebp,4
                        add     edi,4
                        add     esi,8
                        cmp     ebp,4
                        jae     dhloopmmx
                        test    ebp,ebp
                        jz      dhexitmmx
dhlastloopmmx:          mov     bl,byte ptr [_linje + edi]
                        mov     edx,[_shadcol + ebx]
                        mov     [esi],dx
                        add     esi,2
                        inc     edi
                        dec     ebp
                        jnz     dhlastloopmmx
dhexitmmx:              mov     [_screenptr],esi
                        ret


                        ALIGN32

public drawhires800wCC_
drawhires800wCC_:
                        TSC_BEFORE _drawhires800mmx_tsctmp
                        mov     ebp,[_DIWlastvisiblepos]
                        mov     edi,[_DIWfirstvisiblepos]
                        mov     esi,[_screenptr]
                        sub     ebp,edi
                        jle     dhexitCC
                        test    dword ptr [_delay_color_total],-1
                        jz      drawhires800wnocc
                        xor     eax,eax
                        xor     ebx,ebx
                        xor     ecx,ecx
                        xor     edx,edx
                        cmp     ebp,4
                        jl      dhlastloopCC
                        test    esi,06h                 ; align with one pix
                        jz      drawhires800walignedCC
drawhires800walign8CC:
                        mov     eax,edi
                        shr     eax,1
                        call    process_delayed_colors_
                        xor     eax,eax
                        mov     al,byte ptr [_linje + edi]
                        dec     ebp
                        mov     ebx,dword ptr [_shadcol + eax]
                        inc     edi
                        mov     [esi],bx
                        add     esi,2
                        test    esi,06h
                        jnz     drawhires800walign8CC
                        xor     ebx,ebx
drawhires800walignedCC:
                        cmp     ebp,4
                        jl      dhlastloopCC
dhloopCC:
                        mov     eax,edi
                        shr     eax,1
                        call    process_delayed_colors_
                        xor     eax,eax
                        mov     al,byte ptr [_linje + edi]
                        mov     bl,byte ptr [_linje + 1 + edi]
                        mov     ecx,dword ptr [_shadcol + ebx]
                        mov     cx,word ptr [_shadcol + eax]
                        mov     [esi],ecx
                        lea     eax,[2 + edi]
                        shr     eax,1
                        call    process_delayed_colors_
                        xor     eax,eax
                        mov     al,byte ptr [_linje + 2 + edi]
                        mov     bl,byte ptr [_linje + 3 + edi]
                        mov     ecx,dword ptr [_shadcol + ebx]
                        mov     cx,word ptr [_shadcol + eax]
                        mov     4[esi],ecx
                        sub     ebp,4
                        add     edi,4
                        add     esi,8
                        cmp     ebp,4
                        jae     dhloopCC
                        test    ebp,ebp
                        jz      dhexitCC
dhlastloopCC:           mov     eax,edi
                        shr     eax,1
                        call    process_delayed_colors_
                        mov     bl,byte ptr [_linje+edi]
                        mov     edx,[_shadcol+ebx]
                        mov     [esi],dx
                        add     esi,2
                        inc     edi
                        dec     ebp
                        jnz     dhlastloopCC
dhexitCC:               mov     [_screenptr],esi
                        TSC_AFTER _drawhires800mmx_tsctmp, _drawhires800mmx_tsc, _drawhires800mmx_tsctimes
                        ret


                        ALIGN32

public drawhires800wmmxCC_
drawhires800wmmxCC_:
                        TSC_BEFORE _drawhires800mmx_tsctmp
                        mov     ebp,[_DIWlastvisiblepos]
                        mov     edi,[_DIWfirstvisiblepos]
                        mov     esi,[_screenptr]
                        sub     ebp,edi
                        jle     dhexitmmxCC
                        test    dword ptr [_delay_color_total],-1
                        jz      drawhires800wmmxnocc
                        xor     eax,eax
                        xor     ebx,ebx
                        xor     ecx,ecx
                        mov     edx,0ffffh
                        movd    mm4,edx
                        xor     edx,edx
                        cmp     ebp,4
                        jl      dhlastloopmmxCC
                        test    esi,06h                 ; align with one pix
                        jz      drawhires800walignedmmxCC
drawhires800walign8mmxCC:
                        mov     eax,edi
                        shr     eax,1
                        call    process_delayed_colors_
                        xor     eax,eax
                        mov     al,byte ptr [_linje + edi]
                        dec     ebp
                        mov     ebx,dword ptr [_shadcol + eax]
                        inc     edi
                        mov     [esi],bx
                        add     esi,2
                        test    esi,06h
                        jnz     drawhires800walign8mmxCC
                        xor     ebx,ebx
drawhires800walignedmmxCC:
                        cmp     ebp,4
                        jl      dhlastloopmmxCC
dhloopmmxCC:
                        mov     eax,edi
                        shr     eax,1
                        call    process_delayed_colors_
                        xor     eax,eax
                        mov     al,byte ptr [_linje + edi]
                        mov     bl,byte ptr [_linje + 1 + edi]
                        mov     cl,byte ptr [_linje + 2 + edi]
                        mov     dl,byte ptr [_linje + 3 + edi]
                        movd    mm0,[_shadcol + eax]
                        movd    mm1,[_shadcol + ebx]
                        lea     eax,[2 + edi]
                        shr     eax,1
                        call    process_delayed_colors_
                        xor     eax,eax
                        movd    mm2,[_shadcol + ecx]
                        movd    mm3,[_shadcol + edx]
                        pand    mm2,mm4
                        pand    mm0,mm4
                        pslld   mm1,16
                        psllq   mm2,32
                        psllq   mm3,48
                        por     mm0,mm1
                        por     mm2,mm3
                        por     mm0,mm2
                        movq    [esi],mm0
                        sub     ebp,4
                        add     edi,4
                        add     esi,8
                        cmp     ebp,4
                        jae     dhloopmmxCC
                        test    ebp,ebp
                        jz      dhexitmmxCC
dhlastloopmmxCC:        mov     eax,edi
                        shr     eax,1
                        call    process_delayed_colors_
                        mov     bl,byte ptr [_linje+edi]
                        mov     edx,[_shadcol+ebx]
                        mov     [esi],dx
                        add     esi,2
                        inc     edi
                        dec     ebp
                        jnz     dhlastloopmmxCC
dhexitmmxCC:            mov     [_screenptr],esi
                        TSC_AFTER _drawhires800mmx_tsctmp, _drawhires800mmx_tsc, _drawhires800mmx_tsctimes
                        ret


                        ALIGN32

public drawduallores800w_
drawduallores800w_:     mov     esi,[_screenptr]
                        mov     ebp,[_DIWlastvisiblepos]
                        mov     eax,[_DIWfirstvisiblepos]
                        sub     ebp,eax
                        jle     ddlexit
                        lea     edi,[_dualtranslate]
                        test    byte ptr [_bplcon2],040h
                        jnz     ddlprinotset
                        add     edi,010000h
ddlprinotset:           xor     ebx,ebx
                        cmp     ebp,4
                        jl      ddllast
ddl:                    mov     ecx,[_linje+eax]
                        mov     edx,[_linje2+eax]
                        push    ebp
                        mov     bh,cl       
                        push    eax   
                        mov     bl,dl 
                        xor     eax,eax
                        mov     al,[edi+ebx] 
                        mov     ebp,[_shadcol+eax]     
                        mov     [esi],ebp       
                        mov     bh,ch                            
                        shr     ecx,16                          
                        mov     bl,dh                           
                        shr     edx,16                          
                        mov     al,[edi+ebx]           
                        mov     ebp,[_shadcol+eax]     
                        mov     4[esi],ebp             
                        mov     bh,cl
                        mov     bl,dl
                        mov     al,[edi+ebx]
                        mov     ebp,[_shadcol+eax]
                        mov     8[esi],ebp
                        mov     bh,ch
                        mov     bl,dh
                        mov     al,[edi+ebx]
                        mov     ebp,[_shadcol+eax]
                        mov     12[esi],ebp
                        pop     eax
                        pop     ebp
                        add     esi,16
                        sub     ebp,4
                        add     eax,4
                        cmp     ebp,4
                        jae     ddl
                        test    ebp,ebp
                        jz      ddlexit
ddllast:                xor     ecx,ecx
ddllastloop:            mov     bh,byte ptr [_linje+eax]
                        mov     bl,byte ptr [_linje2+eax]
                        inc     eax
                        mov     cl,[edi+ebx]
                        mov     edx,[_shadcol+ecx]
                        mov     [esi],edx
                        add     esi,4
                        dec     ebp
                        jnz     ddllastloop
ddlexit:                mov     [_screenptr],esi
                        ret


                        ALIGN32

public drawduallores800wmmx_
drawduallores800wmmx_:  mov     esi,[_screenptr]
                        mov     ebp,[_DIWlastvisiblepos]
                        mov     eax,[_DIWfirstvisiblepos]
                        sub     ebp,eax
                        jle     ddlexitmmx
                        lea     edi,[_dualtranslate]
                        test    byte ptr [_bplcon2],040h
                        jnz     ddlprinotsetmmx
                        add     edi,010000h
ddlprinotsetmmx:        xor     ebx,ebx
                        cmp     ebp,4
                        jl      ddllastmmx
                        mov     edx,0ffffffffh
                        movd    mm4,edx
                        xor     edx,edx
                        xor     ecx,ecx
                        xor     ebx,ebx
                        test    esi,7           ; One "pixel" will align 8
                        jz      ddlmmx
                        mov     bh,byte ptr [_linje + eax]
                        mov     bl,byte ptr [_linje2 + eax]
                        mov     dl,[edi + ebx]
                        mov     ecx,[_shadcol + edx]
                        mov     dword ptr [esi],ecx
                        dec     ebp
                        add     esi,4
                        inc     eax
                        xor     ecx,ecx
                        cmp     ebp,4
                        jl      ddllastmmx
ddlmmx:                 mov     bh,byte ptr [_linje + eax]
                        mov     bl,byte ptr [_linje2 + eax]
                        mov     ch,byte ptr [_linje + 1 + eax]
                        mov     cl,byte ptr [_linje2 + 1 + eax]
                        mov     dl,[edi + ebx]
                        movd    mm0,[_shadcol + edx]
                        mov     dl,[edi + ecx]
                        movd    mm1,[_shadcol + edx]
                        psllq   mm1,32
                        mov     bh,byte ptr [_linje + 2 + eax]
                        mov     bl,byte ptr [_linje2 + 2 + eax]
                        mov     ch,byte ptr [_linje + 3 + eax]
                        mov     cl,byte ptr [_linje2 + 3 + eax]
                        mov     dl,[edi + ebx]
                        movd    mm2,[_shadcol + edx]
                        mov     dl,[edi + ecx]
                        movd    mm3,[_shadcol + edx]
                        psllq   mm3,32
                        por     mm0,mm1
                        por     mm2,mm3
                        movq    [esi],mm0
                        movq    [esi + 8],mm2
                        add     esi,16
                        sub     ebp,4
                        add     eax,4
                        cmp     ebp,4
                        jae     ddlmmx
                        test    ebp,ebp
                        jz      ddlexitmmx
ddllastmmx:             xor     ecx,ecx
ddllastloopmmx:         mov     bh,byte ptr [_linje+eax]
                        mov     bl,byte ptr [_linje2+eax]
                        inc     eax
                        mov     cl,[edi+ebx]
                        mov     edx,[_shadcol+ecx]
                        mov     [esi],edx
                        add     esi,4
                        dec     ebp
                        jnz     ddllastloopmmx
ddlexitmmx:             mov     [_screenptr],esi
                        ret


                        ALIGN32

public drawdualhires800w_
drawdualhires800w_:    mov     esi,[_screenptr]
                        mov     ebp,[_DIWlastvisiblepos]
                        mov     eax,[_DIWfirstvisiblepos]
                        sub     ebp,eax
                        jle     ddhexit
                        lea     edi,[_dualtranslate]
                        test    byte ptr [_bplcon2],040h
                        jnz     ddhprinotset
                        add     edi,010000h
ddhprinotset:           xor     ebx,ebx
                        cmp     ebp,4
                        jl      ddhlast
ddh:                    mov     ecx,[_linje+eax]
                        mov     edx,[_linje2+eax]
                        push    ebp
                        mov     bh,ch       
                        push    eax   
                        mov     bl,dh 
                        xor     eax,eax
                        mov     al,[edi+ebx] 
                        mov     ebp,[_shadcol+eax]     
                        mov     bh,cl                            
                        shr     ecx,16                          
                        mov     bl,dl                           
                        shr     edx,16                          
                        mov     al,[edi+ebx]           
                        mov     bp,word ptr [_shadcol+eax]     
                        mov     [esi],ebp             
                        mov     bh,ch
                        mov     bl,dh
                        mov     al,[edi+ebx]
                        mov     ebp,[_shadcol+eax]
                        mov     bh,cl
                        mov     bl,dl
                        mov     al,[edi+ebx]
                        mov     bp,word ptr [_shadcol+eax]
                        mov     4[esi],ebp
                        pop     eax
                        pop     ebp
                        add     esi,8
                        sub     ebp,4
                        add     eax,4
                        cmp     ebp,4
                        jae     ddh
                        test    ebp,ebp
                        jz      ddhexit
ddhlast:                xor     ecx,ecx
ddhlastloop:            mov     bh,byte ptr [_linje+eax]
                        mov     bl,byte ptr [_linje2+eax]
                        inc     eax
                        mov     cl,[edi+ebx]
                        mov     edx,[_shadcol+ecx]
                        mov     [esi],dx
                        add     esi,2
                        dec     ebp
                        jnz     ddhlastloop
ddhexit:                mov     [_screenptr],esi
                        ret





;--------------------------------
; Width: lores (320)
;--------------------------------

; ebx - number of lores pixels to draw

                        ALIGN32
public fillbg320w_
fillbg320w_:            mov     esi,[_screenptr]
                        mov     eax,[_shadcol]
                        cmp     ebx,4
                        jb      fbg320w1
                        test    esi,03h
                        jz      fbg320w2
                        mov     [esi],ax
                        dec     ebx
                        add     esi,2
                        cmp     ebx,4
                        jb      fbg320w1
fbg320w2:               mov     [esi],eax
                        mov     4[esi],eax
                        sub     ebx,4
                        add     esi,8
                        cmp     ebx,4
                        jae     fbg320w2
fbg320w1:               test    ebx,ebx
                        jz      fbg320w3
fbg320w4:               mov     [esi],ax
                        add     esi,2
                        dec     ebx
                        jnz     fbg320w4
fbg320w3:               mov     [_screenptr],esi
                        ret

                        ALIGN32

public drawbgline320w_
drawbgline320w_:        pushad
                        mov     ebp,[_ypos]
                        cmp     ebp,[_cliptop]
                        jb      drawbg320wouttahere
                        cmp     ebp,[_clipbot]
                        jae     drawbg320wouttahere
                        mov     ebx,[_shadcol]
                        mov     ecx,[_lineflags+4*ebp]
                        mov     edx,[_configdoublebuffer]
                        cmp     ecx,ebx
                        jne     drawbgit320w
                        mov     dl,byte ptr [_lineflagstimes + ebp]
                        test    dl,dl
                        jz      iminheaven1320w
                        dec     dl
drawbgit320w:           mov     byte ptr [_lineflagstimes + ebp],dl
                        mov     [_lineflags+4*ebp],ebx
                        mov     ebx,[_shadcol]
                        mov     eax,[_screenptr]
                        mov     ebp,dword ptr [_cliprightx]
                        sub     ebp,dword ptr [_clipleftx]
                        cmp     ebp,320
                        jne     drawbg320wx1
                        mov     ebp,10
                        jmp     dbl320w
drawbg320wx1:           mov     ebp,12
dbl320w:                mov     [eax],ebx
                        mov     4[eax],ebx
                        mov     8[eax],ebx
                        mov     12[eax],ebx
                        mov     16[eax],ebx
                        mov     20[eax],ebx
                        mov     24[eax],ebx
                        mov     28[eax],ebx
                        mov     32[eax],ebx
                        mov     36[eax],ebx
                        mov     40[eax],ebx
                        mov     44[eax],ebx
                        mov     48[eax],ebx
                        mov     52[eax],ebx
                        mov     56[eax],ebx
                        mov     60[eax],ebx
                        add     eax,64
                        dec     ebp
                        jnz     dbl320w
                        add     eax,[_draw_scanlinemodulo]
                        mov     [_screenptr],eax
drawbg320wouttahere:    popad
                        ret
iminheaven1320w:        mov     eax,dword ptr [_cliprightx]
                        sub     eax,dword ptr [_clipleftx]
                        shl     eax,1
                        add     eax,[_draw_scanlinemodulo]
                        add     [_screenptr],eax
                        popad
                        ret

                        ALIGN32

public drawlores320w_
drawlores320w_:         mov     edx,[_screenptr]
                        mov     ebp,[_DIWlastvisiblepos]
                        mov     edi,[_DIWfirstvisiblepos]
                        test    byte ptr [_bplcon0+1],080h
                        jz      dl320wlores
                        shr     ebp,1
                        shr     edi,1
dl320wlores:            cmp     edi,[_clipleftx]
                        jae     dl320wleftnoclip
                        mov     edi,[_clipleftx]
dl320wleftnoclip:       cmp     ebp,[_cliprightx]
                        jbe     dl320wrightnoclip
                        mov     ebp,[_cliprightx]
dl320wrightnoclip:      sub     ebp,edi
                        xor     ebx,ebx
                        xor     eax,eax
                        cmp     ebp,4
                        jl      dl320wlast4
                        test    edx,03h
                        jz      drlo320w
                        mov     bl,byte ptr [_linje+edi]
                        inc     edi
                        dec     ebp
                        mov     si,word ptr [_shadcol+ebx]
                        mov     [edx],si
                        add     edx,2
                        cmp     ebp,4
                        jl      dl320wlast4
drlo320w:               mov     ecx,[_linje+edi]       
                        add     edi,4                  
                        mov     bl,ch                  
                        sub     ebp,4                  
                        mov     al,cl                  
                        shr     ecx,16                 
                        mov     esi,[_shadcol+ebx]  
                        mov     bl,ch                        
                        mov     si,word ptr [_shadcol+eax]    
                        mov     al,cl                        
                        mov     [edx],esi          
                        mov     esi,[_shadcol+ebx]  
                        mov     si,word ptr [_shadcol+eax]    
                        mov     4[edx],esi         
                        add     edx,8                        
                        cmp     ebp,4                        
                        jae     drlo320w                  
dl320wlast4:            test    ebp,ebp
                        jz      dl320wexit
dl320wlastloop:         mov     bl,byte ptr [_linje+edi]
                        mov     esi,[_shadcol+ebx]
                        mov     [edx],si
                        inc     edi
                        add     edx,2
                        dec     ebp
                        jnz     dl320wlastloop
dl320wexit:             mov     [_screenptr],edx
                        ret
                        ALIGN32

public drawlores320wmmx_
drawlores320wmmx_:      mov     edx,[_screenptr]
                        mov     ebp,[_DIWlastvisiblepos]
                        mov     edi,[_DIWfirstvisiblepos]
                        test    byte ptr [_bplcon0+1],080h
                        jz      dl320wmmxlores
                        shr     ebp,1
                        shr     edi,1
dl320wmmxlores:         cmp     edi,[_clipleftx]
                        jae     dl320wmmxleftnoclip
                        mov     edi,[_clipleftx]
dl320wmmxleftnoclip:    cmp     ebp,[_cliprightx]
                        jbe     dl320wmmxrightnoclip
                        mov     ebp,[_cliprightx]
dl320wmmxrightnoclip:   sub     ebp,edi
                        xor     ebx,ebx
                        xor     eax,eax
                        cmp     ebp,4
                        jl      dl320wmmxlast4
                        test    edx,07h
                        jz      drlo320wmmxstart
dl320wmmxalign8:        mov     bl,byte ptr [_linje+edi]
                        inc     edi
                        dec     ebp
                        mov     si,word ptr [_shadcol+ebx]
                        mov     [edx],si
                        add     edx,2
                        test    dl,07h
                        jnz     dl320wmmxalign8
                        cmp     ebp,4
                        jl      dl320wmmxlast4
drlo320wmmxstart:       mov     ecx,0ffffh
                        movd    mm4,ecx
                        movq    mm5,mm4
                        movq    mm6,mm4
                        movq    mm7,mm4
                        psllq   mm5,16
                        psllq   mm6,32
                        psllq   mm7,48
                        xor     ecx,ecx
drlo320wmmx:            mov     al,byte ptr [_linje + edi]
                        mov     bl,byte ptr [_linje + 1 + edi]
                        mov     cl,byte ptr [_linje + 2 + edi]
                        movd    mm0,[_shadcol + eax]
                        mov     al,byte ptr [_linje + 3 + edi]
                        add     edi,4
                        sub     ebp,4                  
                        movd    mm1,[_shadcol + ebx]
                        movq    mm2,[_shadcol - 4 + ecx]
                        movq    mm3,[_shadcol - 4 + eax]
                        pand    mm0,mm4
                        pand    mm1,mm5
                        pand    mm2,mm6
                        pand    mm3,mm7
                        por     mm0,mm1
                        por     mm2,mm3
                        por     mm0,mm2
                        movq    [edx],mm0
                        add     edx,8                        
                        cmp     ebp,4                        
                        jae     drlo320wmmx                  
dl320wmmxlast4:         test    ebp,ebp
                        jz      dl320wmmxexit
dl320wmmxlastloop:      mov     bl,byte ptr [_linje+edi]
                        mov     esi,[_shadcol+ebx]
                        mov     [edx],si
                        inc     edi
                        add     edx,2
                        dec     ebp
                        jnz     dl320wmmxlastloop
dl320wmmxexit:          mov     [_screenptr],edx
                        ret

#endif


; ---------------------------------------------------
; Draw the speed-indicator number to the framebuffer
; ---------------------------------------------------
	
                ALIGN32

public draw_speed_
draw_speed_:	mov	ebx,dword ptr [_config_graphics_mode]
		mov	ecx,dword ptr [_draw_bufferdraw]
		mov	eax,dword ptr [_framebuffer]
		add	eax,dword ptr [_bufferoffsets + 4*ecx]
		test	ebx,ebx
		jne	dump320
		add	eax,1536 + 1600
		add	eax,dword ptr [_draw_scanlinemodulo]
		mov	edi,1568
		jmp	dodump
dump320:	cmp	ebx,11
		je	dump320w
		cmp	ebx,12
		je	dump320w
		cmp	ebx,13
		je	dump400w
		cmp	ebx,3
		jae	dump640
dump320w:	add	eax,608
		mov	edi,608
		jmp	dodump
dump400w:	add	eax,736
		mov	edi,736
		jmp	dodump
dump640:	cmp	ebx,6
		je	dump320b
		cmp	ebx,7
		je	dump320b
		cmp	ebx,8
		je	dump320b
		cmp	ebx,9
		je	dump320b
		cmp	ebx,10
		je	dump400b
		add	eax,1248
		mov	edi,1248
		jmp	dodump
dump400b:	add	eax,368
		mov	edi,368
		jmp	dodumpb
dump320b:	add	eax,304
		mov	edi,304
dodumpb:	mov	esi,offset _speedbuffer
		mov	ch,05h
dumploop2b:	mov	cl,08h
dumploopb:	mov	edx,dword ptr [esi]
		test	dx,dx
		jz	dumploop3b
		mov	dx,251
dumploop3b:	test	edx,0ffff0000h
		jz	dumploop3c
		mov	dh,251
dumploop3c:	mov	word ptr [eax],dx
		add	esi,4
		add	eax,2
		dec	cl
		jnz	dumploopb
		add	eax,edi
		add	eax,dword ptr [_draw_scanlinemodulo]
		dec	ch
		jnz	dumploop2b
		ret
dodump:		mov	esi,offset _speedbuffer
		mov	ch,05h
dumploop2:	mov	cl,04h
dumploop:	mov	edx,dword ptr [esi]
		mov	dword ptr [eax],edx
		mov	edx,dword ptr [4 + esi]
		mov	dword ptr [4 + eax],edx
		add	esi,8
		add	eax,8
		dec	cl
		jnz	dumploop
		add	eax,edi
		add	eax,dword ptr [_draw_scanlinemodulo]
		dec	ch
		jnz	dumploop2
		ret

	
                ALIGN32

_TEXT ends

_DATA segment dword public 'DATA'

include data\memory.inc
include data\inout.inc
include data\fellow.inc
include data\graphem.inc
include data\draw.inc
	
#ifdef TSC_PROFILING
public _drawbgline800_tsc
public _drawbgline800_tsctimes
public _drawbgline800notdrawn_tsc
public _drawbgline800notdrawn_tsctimes

public _drawbgline800mmx_tsc
public _drawbgline800mmx_tsctimes

public _drawlores800_tsc
public _drawlores800_tsctimes

public _drawlores800mmx_tsc
public _drawlores800mmx_tsctimes

public _drawhires800_tsc
public _drawhires800_tsctimes

public _drawhires800mmx_tsc
public _drawhires800mmx_tsctimes

_drawbgline800_tsctmp:  dd      0,0
_drawbgline800_tsc:  dd      0,0
_drawbgline800_tsctimes:  dd      0
_drawbgline800notdrawn_tsc:  dd      0,0
_drawbgline800notdrawn_tsctimes:  dd      0

_drawbgline800mmx_tsctmp:  dd      0,0
_drawbgline800mmx_tsc:  dd      0,0
_drawbgline800mmx_tsctimes:  dd      0

_drawlores800_tsctmp:  dd      0,0
_drawlores800_tsc:  dd      0,0
_drawlores800_tsctimes:  dd      0

_drawlores800mmx_tsctmp:  dd      0,0
_drawlores800mmx_tsc:  dd      0,0
_drawlores800mmx_tsctimes:  dd      0

_drawhires800_tsctmp:  dd      0,0
_drawhires800_tsc:  dd      0,0
_drawhires800_tsctimes:  dd      0

_drawhires800mmx_tsctmp:  dd      0,0
_drawhires800mmx_tsc:  dd      0,0
_drawhires800mmx_tsctimes:  dd      0


#endif

dummydecodetable:       dd      offset  ddec0
                        dd      offset  ddec1
                        dd      offset  ddec2
                        dd      offset  ddec3
                        dd      offset  ddec4
                        dd      offset  ddec5
                        dd      offset  ddec6
                        dd      offset  ddec6

_DATA ends

_BSS segment dword public 'DATA'
_BSS ends

end

