; =============================
;  Fellow Amiga Emulator      
;  68000 emulation core            
;  (C) 1994-1998 Petter Schau 
;            and Roman Dolejsi
; =============================
	
	
	.586p
DGROUP group _DATA,_BSS
_TEXT  segment para public use32 'CODE'
       assume cs:_TEXT, ds:DGROUP, ss:DGROUP

        dd 0
        align 16


; Note:  irq's do not clear trace bits.  Should they?

public m68000start_
m68000start_:     ; Used to check code alignment
startlbl:


	
; Petter Schau 1996

include defs.inc
include func\memory.inc
include func\sound.inc
include func\floppy.inc
include func\bus.inc
include func\blit.inc
include func\copper.inc


#ifdef DEBUGBUILD
include eventid.inc
#endif
#ifdef CPU_LOG_INSTRUCTION_START
extern cpuLogInstructionStart_:near
#endif

include mac\drawmode.mac
include mac\memory.mac
include mac\bus.mac
include mac\68000.mac


extrn print_emuspeed_:near

#ifdef PC_PTR
extern cpu_pc_in_unmapped_mem_:near
#endif

; set pc, for use from C, performs the needed pointer conversion


		ALIGN32

public set_pc_
set_pc_:	push	edx
		PC_TO_PTR edx
		mov	dword ptr [_pc], edx
		pop	edx
		ret


		ALIGN32

public get_pc_
get_pc_:	PTR_TO_PC edx
		ret


#ifdef PREFETCH

; Load prefetch word from PC
; Called at reset, irq, exception and jumps

; edx - PC to prefetch



                        ALIGN32

public prefetch_fill_
prefetch_fill_:         push    ecx
                        push    edx
                        mov     ecx,edx
                        fetchw
                        mov     word ptr [_prefetch_word],dx
                        pop     edx
                        pop     ecx
                        ret

#endif

; Fixes a weird thing the compiler does

public fix_a7pointer_
fix_a7pointer_:
       push     eax
       lea      eax,[_a+28]
       mov      dword ptr _a7pointer,eax
       pop      eax
       ret


public i07_B_1_                 ; X
public i07_W_1_                 ; X
public i07_L_1_                 ; X
public i07_B_2_                 ; X
public i07_W_2_                 ; X
public i07_L_2_                 ; X
public i08_B_                   ; X
public i08_W_                   ; X
public i08_L_                   ; X
public i08_B_CCR_               ; X
public i08_W_SR_                ; X
public i09_RI_I_B_              ; X
public i09_LE_I_B_              ; X
public i09_RI_I_W_              ; X
public i09_LE_I_W_              ; X
public i09_RI_I_L_              ; X
public i09_LE_I_L_              ; X
public i09_RI_R_B_              ; X
public i09_LE_R_B_              ; X
public i09_RI_R_W_              ; X
public i09_LE_R_W_              ; X
public i09_RI_R_L_              ; X
public i09_LE_R_L_              ; X
public i09_RI_M_W_              ; X
public i09_LE_M_W_              ; X
public i12_D_L_                 ; X
public i12_D_B_                 ; X
public i12_S_L_                 ; X
public i12_S_B_                 ; X
public i13_D_L_                 ; X
public i13_D_B_                 ; X
public i13_S_L_                 ; X
public i13_S_B_                 ; X
public i15_D_L_                 ; X
public i15_D_B_                 ; X
public i15_S_L_                 ; X
public i15_S_B_                 ; X
public i17_D_L_                 ; X
public i17_D_B_                 ; X
public i17_S_L_                 ; X
public i17_S_B_                 ; X
public i18_                     ; X
public i19_                     ; X
public i20_B_                   ; X
public i20_W_                   ; X
public i20_L_                   ; X
public i21_W_                   ; X
public i21_L_                   ; X
public i22_B_                   ; X
public i22_W_                   ; X
public i22_L_                   ; X
public i23_B_                   ; X
public i23_W_                   ; X
public i23_L_                   ; X
public i24_                     ; X
public i25_                     ; X
public i26_                     ; X
public i27_B_                   ; X
public i27_W_                   ; X
public i27_L_                   ; X
public i28_B_                   ; X
public i28_W_                   ; X
public i28_L_                   ; X
public i28_B_CCR_               ; X
public i28_W_SR_                ; X
public i29_                     ; X
public i30_W_                   ; X
public i30_L_                   ; X
public i33_                     ; X
public i34_                     ; X
public i35_RI_I_B_              ; X
public i35_LE_I_B_              ; X
public i35_RI_I_W_              ; X
public i35_LE_I_W_              ; X
public i35_RI_I_L_              ; X
public i35_LE_I_L_              ; X
public i35_RI_R_B_              ; X
public i35_LE_R_B_              ; X
public i35_RI_R_W_              ; X
public i35_LE_R_W_              ; X
public i35_RI_R_L_              ; X
public i35_LE_R_L_              ; X
public i35_RI_M_W_              ; X
public i35_LE_M_W_              ; X
public i38_                     ; X
public i39_                     ; X
public i40_                     ; X
public i41_1_                   ; X
public i41_2_                   ; X
public i42_W_                   ; X
public i42_L_                   ; X
public i43_W_PREM_
public i43_W_POSTR_
public i43_W_CONM_
public i43_W_CONR_
public i43_L_PREM_
public i43_L_POSTR_
public i43_L_CONM_
public i43_L_CONR_
public i44_W_1_                     ; X
public i44_L_1_                     ; X
public i44_W_2_                     ; X
public i44_L_2_                     ; X
public i46_                     ; X
public i47_                     ; X
public i48_B_                   ; X
public i49_B_                   ; X
public i49_W_                   ; X
public i49_L_                   ; X
public i52_B_                   ; X
public i52_W_                   ; X
public i52_L_                   ; X
public i53_B_1_                 ; X
public i53_W_1_                 ; X
public i53_L_1_                 ; X
public i53_B_2_                 ; X
public i53_W_2_                 ; X
public i53_L_2_                 ; X
public i54_B_                   ; X
public i54_W_                   ; X
public i54_L_                   ; X
public i54_B_CCR_               ; X
public i54_W_SR_                ; X
public i55_                     ; X
public i56_                     ; X
public i57_RI_I_B_              ; X
public i57_LE_I_B_              ; X
public i57_RI_I_W_              ; X
public i57_LE_I_W_              ; X
public i57_RI_I_L_              ; X
public i57_LE_I_L_              ; X
public i57_RI_R_B_              ; X
public i57_LE_R_B_              ; X
public i57_RI_R_W_              ; X
public i57_LE_R_W_              ; X
public i57_RI_R_L_              ; X
public i57_LE_R_L_              ; X
public i57_RI_M_W_              ; X
public i57_LE_M_W_              ; X
public i59_RI_I_B_              ; X
public i59_LE_I_B_              ; X
public i59_RI_I_W_              ; X
public i59_LE_I_W_              ; X
public i59_RI_I_L_              ; X
public i59_LE_I_L_              ; X
public i59_RI_R_B_              ; X
public i59_LE_R_B_              ; X
public i59_RI_R_W_              ; X
public i59_LE_R_W_              ; X
public i59_RI_R_L_              ; X
public i59_LE_R_L_              ; X
public i59_RI_M_W_              ; X
public i59_LE_M_W_              ; X
public i64_1_                   ; X
public i64_2_                   ; X
public i65_                     ; X
public i66_                     ; X
public i67_B_1_                 ; X
public i67_W_1_                 ; X
public i67_L_1_                 ; X
public i67_B_2_                 ; X
public i67_W_2_                 ; X
public i67_L_2_                 ; X
public i68_W_                   ; X
public i68_L_                   ; X
public i69_B_                   ; X
public i69_W_                   ; X
public i69_L_                   ; X


;========================================================================
; Group 1 Frame format
;
; 000:	All, except bus and address error
;
; Assumes esi is loaded with correct pc ptr wherever it should point
; and that SR has been updated to whatever it should contain
;========================================================================
	
GROUP1 macro
		mov	ecx, dword ptr [_a + 28]	; Save PC
		sub	ecx, 4
		mov	dword ptr [_a + 28], ecx
		mov	edx, esi
		PTR_TO_PC	edx
		writel
		mov	ecx, dword ptr [_a + 28]	; Save SR
		sub	ecx, 2
		mov	dword ptr [_a + 28], ecx
		mov	edx, dword ptr [_sr]
		writew
endm


		ALIGN32

public cpuGroup1_
cpuGroup1_:	GROUP1
		ret


;========================================================================
; Group 2 Frame format
;
; 000:	Bus and address error
;
; Assumes esi is loaded with correct pc ptr wherever it should point
; and that SR has been updated to whatever it should contain
; memory_fault_address contains the violating address
; memory_fault_read is TRUE if the access was a read
;========================================================================
	
GROUP2 macro
		mov	ecx, dword ptr [_a + 28]	; Save PC
		sub	ecx, 4
		mov	dword ptr [_a + 28], ecx
		mov	edx, esi
		PTR_TO_PC	edx
		writel
		mov	ecx, dword ptr [_a + 28]	; Save SR
		sub	ecx, 2
		mov	dword ptr [_a + 28], ecx
		mov	edx, dword ptr [_sr]
		writew
		mov	ecx, dword ptr [_a + 28]	; Fault addr, skip ireg
		sub	ecx, 6			 
		mov	dword ptr [_a + 28], ecx
		mov	edx, dword ptr [_memory_fault_address]
		writel
		mov	edx, dword ptr [_memory_fault_read]
		shl	edx, 4
		mov	ecx, dword ptr [_a + 28]
		sub	ecx, 2
		mov	dword ptr [_a + 28], ecx
		writel
endm


		ALIGN32

public cpuGroup2_
cpuGroup2_:	GROUP2
		ret


;========================================================================
; Frame format $0
;
; 010:	All, except bus and address errors
; 020:	Irq, Format error, Trap #N, Illegal inst., A-line, F-line,
;	Priv. violation, copr preinst
; 030:	Same as for 020
; 040:	Irq, Format error, Trap #N, Illegal inst., A-line, F-line,
;	Priv. violation, FPU preinst
; 060:	Irq, Format error, Trap #N, Illegal inst., A-line, F-line,
;	Priv. violation, FPU preinst, Unimpl. Integer, Unimpl. EA
;
; Assumes esi is loaded with correct pc ptr wherever it should point
; and that SR has been updated to whatever it should contain
;========================================================================
	
FRAME0 macro VECTOR_OFFSET
		mov	ecx, dword ptr [_a + 28]	; Save Vector offset 
		sub	ecx, 2
		mov	dword ptr [_a + 28], ecx
		mov	edx, VECTOR_OFFSET
		writew
		mov	ecx, dword ptr [_a + 28]	; Save PC
		sub	ecx, 4
		mov	dword ptr [_a + 28], ecx
		mov	edx, esi
		PTR_TO_PC	edx
		writel
		mov	ecx, dword ptr [_a + 28]	; Save SR
		sub	ecx, 2
		mov	dword ptr [_a + 28], ecx
		mov	edx, dword ptr [_sr]
		writew
endm


		ALIGN32

public cpuFrame0_
cpuFrame0_:	FRAME0	ebx
		ret


;========================================================================
; Frame format $1
;
; 020:	Irq, second frame created
; 030:	Same as for 020
; 040:	Same as for 020
;
; Assumes esi is loaded with correct pc ptr wherever it should point
; and that SR has been updated to whatever it should contain
;========================================================================
	
FRAME1 macro VECTOR_OFFSET
		mov	ecx, dword ptr [_a + 28]	; Save Vector offset 
		sub	ecx, 2
		mov	dword ptr [_a + 28], ecx
		mov	edx, VECTOR_OFFSET
		or	edx, 01000h
		writew
		mov	ecx, dword ptr [_a + 28]	; Save PC
		sub	ecx, 4
		mov	dword ptr [_a + 28], ecx
		mov	edx, esi
		PTR_TO_PC	edx
		writel
		mov	ecx, dword ptr [_a + 28]	; Save SR
		sub	ecx, 2
		mov	dword ptr [_a + 28], ecx
		mov	edx, dword ptr [_sr]
		writew
endm


		ALIGN32

public cpuFrame1_
cpuFrame1_:	FRAME1	ebx
		ret


;========================================================================
; Frame format $2
;
; 020:	chk, chk2, cpTrapcc, trapcc, trapv, trace, zero divide, MMU config,
;	copr postinst 
; 030:	Same as for 020
; 040:	chk, chk2, FTrapcc, trapcc, trapv, trace, zero divide, address error,
;	Unimplemented FPU inst. 
; 060:	Same as for 040
;
; Assumes esi is loaded with correct pc ptr wherever it should point,
; that SR has been updated to whatever it should contain
; and that _pc contains the start of the current instruction
;========================================================================
	
FRAME2 macro VECTOR_OFFSET
		mov	ecx, dword ptr [_a + 28]	; Save inst address 
		sub	ecx, 4
		mov	dword ptr [_a + 28], ecx
		mov	edx, dword ptr [_pc]
		writel
		mov	ecx, dword ptr [_a + 28]	; Save Vector offset 
		sub	ecx, 2
		mov	dword ptr [_a + 28], ecx
		mov	edx, VECTOR_OFFSET
		or	edx, 02000h
		writew
		mov	ecx, dword ptr [_a + 28]	; Save PC
		sub	ecx, 4
		mov	dword ptr [_a + 28], ecx
		mov	edx, esi
		PTR_TO_PC	edx
		writel
		mov	ecx, dword ptr [_a + 28]	; Save SR
		sub	ecx, 2
		mov	dword ptr [_a + 28], ecx
		mov	edx, dword ptr [_sr]
		writew
endm


		ALIGN32

public cpuFrame2_
cpuFrame2_:	FRAME2	ebx
		ret


;========================================================================
; Frame format $3
;
; 040:	FPU post inst.
; 060:	Same as for 040
;
; Fellow never generates this frame
;========================================================================
	
FRAME3 macro VECTOR_OFFSET
		mov	ecx, dword ptr [_a + 28]	; Save Vector offset 
		sub	ecx, 6
		mov	dword ptr [_a + 28], ecx
		mov	edx, VECTOR_OFFSET
		or	edx, 03000h
		writew
		mov	ecx, dword ptr [_a + 28]	; Save PC
		sub	ecx, 4
		mov	dword ptr [_a + 28], ecx
		mov	edx, esi
		writel
		PTR_TO_PC	edx
		mov	ecx, dword ptr [_a + 28]	; Save SR
		sub	ecx, 2
		mov	dword ptr [_a + 28], ecx
		mov	edx, dword ptr [_sr]
		writew
endm


		ALIGN32

public cpuFrame3_
cpuFrame3_:	FRAME3	ebx
		ret

	
;========================================================================
; Frame format $4
;
; 040:	Unimplemented FPU inst. on EC040 and LC040
; 060:	FPU Disabled, Bus error
;
;========================================================================
	
FRAME4 macro VECTOR_OFFSET
		mov	ecx, dword ptr [_a + 28]	; Save Vector offset 
		sub	ecx, 10
		mov	dword ptr [_a + 28], ecx
		mov	edx, VECTOR_OFFSET
		or	edx, 04000h
		writew
		mov	ecx, dword ptr [_a + 28]	; Save PC
		sub	ecx, 4
		mov	dword ptr [_a + 28], ecx
		mov	edx, esi
		PTR_TO_PC	edx
		writel
		mov	ecx, dword ptr [_a + 28]	; Save SR
		sub	ecx, 2
		mov	dword ptr [_a + 28], ecx
		mov	edx, dword ptr [_sr]
		writew
endm


		ALIGN32

public cpuFrame4_
cpuFrame4_:	FRAME4	ebx
		ret


;========================================================================
; Frame format $7
;
; 040:	Address error for non-inst word accesses
;
;========================================================================
	
FRAME7 macro VECTOR_OFFSET
		mov	ecx, dword ptr [_a + 28]	; Save Vector offset 
		sub	ecx, 54
		mov	dword ptr [_a + 28], ecx
		mov	edx, VECTOR_OFFSET
		or	edx, 07000h
		writew
		mov	ecx, dword ptr [_a + 28]	; Save PC
		sub	ecx, 4
		mov	dword ptr [_a + 28], ecx
		mov	edx, esi
		PTR_TO_PC	edx
		writel
		mov	ecx, dword ptr [_a + 28]	; Save SR
		sub	ecx, 2
		mov	dword ptr [_a + 28], ecx
		mov	edx, dword ptr [_sr]
		writew
endm


		ALIGN32

public cpuFrame7_
cpuFrame7_:	FRAME7	ebx
		ret


;========================================================================
; Frame format $8
;
; 010:	Bus and address error
;
;========================================================================
	
FRAME8 macro VECTOR_OFFSET
		mov	ecx, dword ptr [_a + 28]	; Save Vector offset 
		sub	ecx, 52
		mov	dword ptr [_a + 28], ecx
		mov	edx, VECTOR_OFFSET
		or	edx, 08000h
		writew
		mov	ecx, dword ptr [_a + 28]	; Save PC
		sub	ecx, 4
		mov	dword ptr [_a + 28], ecx
		mov	edx, esi
		PTR_TO_PC	edx
		writel
		mov	ecx, dword ptr [_a + 28]	; Save SR
		sub	ecx, 2
		mov	dword ptr [_a + 28], ecx
		mov	edx, dword ptr [_sr]
		writew
endm

				
		ALIGN32

public cpuFrame8_
cpuFrame8_:	FRAME8	ebx
		ret


;============================================================================
; Frame format $9
;
; 020:	copr midinst, main detected protocol violation, irq during copr inst
; 030:	Same as for 020
;
; Not generated in Fellow
;========================================================================
	
FRAME9 macro VECTOR_OFFSET
		mov	ecx, dword ptr [_a + 28]	; Save inst address 
		sub	ecx, 12
		mov	dword ptr [_a + 28], ecx
		mov	edx, dword ptr [_pc]
		writel
		mov	ecx, dword ptr [_a + 28]	; Save Vector offset 
		sub	ecx, 2
		mov	dword ptr [_a + 28], ecx
		mov	edx, VECTOR_OFFSET
		or	edx, 09000h
		writew
		mov	ecx, dword ptr [_a + 28]	; Save PC
		sub	ecx, 4
		mov	dword ptr [_a + 28], ecx
		mov	edx, esi
		PTR_TO_PC	edx
		writel
		mov	ecx, dword ptr [_a + 28]	; Save SR
		sub	ecx, 2
		mov	dword ptr [_a + 28], ecx
		mov	edx, dword ptr [_sr]
		writew
endm


		ALIGN32

public cpuFrame9_
cpuFrame9_:	FRAME9	ebx
		ret


;========================================================================
; Frame format $A
;
; 020:	Address or bus-error on instruction boundrary
; 030:	Same as for 020
;
; Assumes that SR has been updated to whatever it should contain
; and that _pc contains the start of the current instruction
;
; Will not set any values beyond the format/offset word
; Fellow will always generate this frame for bus/address errors
;========================================================================
	
FRAMEA macro VECTOR_OFFSET
		mov	ecx, dword ptr [_a + 28]	; Save Vector offset 
		sub	ecx, 26
		mov	dword ptr [_a + 28], ecx
		mov	edx, VECTOR_OFFSET
		or	edx, 0a000h
		writew
		mov	ecx, dword ptr [_a + 28]	; Save PC
		sub	ecx, 4
		mov	dword ptr [_a + 28], ecx
		mov	edx, esi
		PTR_TO_PC	edx
		writel
		mov	ecx, dword ptr [_a + 28]	; Save SR
		sub	ecx, 2
		mov	dword ptr [_a + 28], ecx
		mov	edx, dword ptr [_sr]
		writew
endm


		ALIGN32

public cpuFrameA_
cpuFrameA_:	FRAMEA	ebx
		ret


;========================================================================
; Frame format $B
;
; 020:	Address or bus-error mid-instruction
; 030:	Same as for 020
;
; Fellow will not generate this frame for bus/address errors
;========================================================================
	
FRAMEB macro VECTOR_OFFSET
		mov	ecx, dword ptr [_a + 28]	; Save Vector offset 
		sub	ecx, 84
		mov	dword ptr [_a + 28], ecx
		mov	edx, VECTOR_OFFSET
		or	edx, 0b000h
		writew
		mov	ecx, dword ptr [_a + 28]	; Save PC
		sub	ecx, 4
		mov	dword ptr [_a + 28], ecx
		mov	edx, esi
		PTR_TO_PC	edx
		writel
		mov	ecx, dword ptr [_a + 28]	; Save SR
		sub	ecx, 2
		mov	dword ptr [_a + 28], ecx
		mov	edx, dword ptr [_sr]
		writew
endm


		ALIGN32

public cpuFrameB_
cpuFrameB_:	FRAMEB	ebx
		ret


;========================================================================
;
; Generate stack frame
;
; Input:	ebx - vector offset
;========================================================================


GENERATE_STACK_FRAME macro
		and	ebx, 0fch
		call	dword ptr [_cpu_stack_frame_gen + ebx]
endm


;=============================================================
; Move ISP (SSP) or MSP to A7, return it in ecx
;=============================================================

ACTIVATE_SSP macro
local l1, l2
		mov	ecx, dword ptr [_a + 28]	; ecx - Current SP 
		test	byte ptr [_sr + 1], 20h		; Check supervisor 
		jnz	l1
		mov	dword ptr [_usp], ecx		; User mode, save USP 
		mov	ecx, dword ptr [_ssp]
		test	byte ptr [_sr + 1], 10h		; Get ISP or MSP 
		jz	l2
		mov	ecx, dword ptr [_msp]
l2:		mov	dword ptr [_a + 28], ecx	; Set new A7 (SP) 
l1:		; Here, a7 is either ISP (SSP) or MSP
endm
	

;=========================================================================
; Takes new SR in edx and maintains the integrity of the super/user state
;
; Hack:
; If trace mode is on, the return address on the stack is changed
; to bus_trace_mode
; This means that updatesr must be called with nothing else
; on the stack.  68000.asm satisfies that, what about 68030?
;=========================================================================

		ALIGN32

public updateSR_
updateSR_:
updateSR:	and	edx, 0ffffh
		mov	byte ptr [upsrtraceset], 0
		test	byte ptr [_sr + 1], 0c0h
		jz	upsrnotraceset
		inc	byte ptr [upsrtraceset]
upsrnotraceset:	mov	ecx, dword ptr [_a + 28]; Get current stack pointer
		test	byte ptr [_sr + 1], 20h	; Are we in super mode?
		jnz	upsup
		mov	dword ptr [_usp], ecx	; No, save stack pointer to usp
		jmp	upd2
upsup:		test	byte ptr [_sr + 1], 010h; In super mode, save ISP/MSP
		jnz	upsup2
		mov	dword ptr [_ssp], ecx	; Master = 0
		jmp	upd2
upsup2:		mov	dword ptr [_msp], ecx	; Master = 1 
upd2:		test	dh, 20h			; Check new super/user mode
		jnz	upsup3
		mov	ecx, dword ptr [_usp]	; New mode is user, get usp
		jmp	upd3
upsup3:		mov	ecx, dword ptr [_ssp]	; New mode is super, get ssp
		test	dh, 10h			; or msp
		jz	upd3
		mov	ecx, dword ptr [_msp]
upd3:		mov	dword ptr [_a + 28], ecx; Set new stack pointer
		mov	dword ptr [_sr], edx	; Set new SR
upd4:		test	byte ptr [_sr + 1], 0c0h
		jz	updsrnotrace
		test	byte ptr [upsrtraceset], 1
		jnz	updsrnotrace
		add	esp, 8
		push	offset bus_trace_mode
		sub	esp, 4
updsrnotrace:	jmp	raise_interrupt_	; Evaluate interrupts


;=====================================================
; No parameters, just checking for waiting interrupts
;
; First, check which irq that should be generated
; Then check if it already has been scheduled.
; If not, then schedule it
;=====================================================

	
		ALIGN32

public raise_interrupt_
raise_interrupt_:
		push	eax
		push	ebx
		push	ecx
		push	edx
	
		mov	edx, 0ffh			; IRQ level to raise 
		mov	ebx, dword ptr [_intena]
		mov	eax, dword ptr [_intreq]
		test	bh, 40h				; IRQ disabled?
		jz	rIRQ_schedule
		and	ebx, 3fffh
		and	eax, ebx			; eax - ena AND req
		mov	ebx, dword ptr [_sr]		; Get current IRQlevel
		and	ebx, 0700h
		shl	ebx, 6
		or	eax, ebx
		mov	dl, byte ptr [_irq_table + eax]
rIRQ_schedule:	test	dl, dl				; Irq waiting?
		jns	rIRQ_int

		; No irq up for schedule

		test	byte ptr [_interruptflag], 1
		jz	rIRQ_exit
		mov	dword ptr [_interruptflag], 0
		mov	dword ptr [_irq_next], -1
		jmp	rIRQ_sched_exit
	
		; Irq waiting here, test if it has been scheduled already
		
rIRQ_int:	test	byte ptr [_interruptflag], 1	; Already scheduled? 
		jz	rIRQ_noprevious
		cmp	dl, byte ptr [_interruptlevel]	; Same irq? 
		jne	rIRQ_noprevious
		mov	eax, dword ptr [_curcycle]	; Just for safety, 
		cmp	eax, dword ptr [_irq_next]	; check that the time
		jb	rIRQ_exit			; has not expired.
		add	eax, 1				; Set new time
		mov	dword ptr [_irq_next], eax
		jmp	rIRQ_sched_exit

		; Schedule new irq
		
rIRQ_noprevious:mov	dword ptr [_interruptlevel], edx; Save runlevel 
		mov	ebx, dword ptr [_vbr]
		lea	ecx, [60h + ebx + edx*4]        ; Save vector address
		fetchl
		mov	dword ptr [_interruptaddress], edx
		mov	eax, dword ptr [_curcycle]	; Set time 
		add	eax, 38
		mov	dword ptr [_irq_next], eax
		mov	dword ptr [_interruptflag], 1
#ifdef DEBUGBUILDX
		push	ebx
		mov	ebx, dword ptr [_interruptlevel]
		cmp	ebx, 02h
		jne	rIRQlogno
		mov	eax,[_loglast]
		and	eax,EVENTMASK
		shl	eax,6
		mov	[_logbuffer+20+eax],ebx
		mov	ebx,IRQ2_CIAA
		mov     [_logbuffer+eax],ebx
		mov	ebx,[_frames]
		mov	[_logbuffer+4+eax],ebx
		mov	ebx,[_ypos]
		mov	[_logbuffer+8+eax],ebx
		mov	ebx,[_xpos]
		mov	[_logbuffer+12+eax],ebx
		mov	ebx,esi ;[_pc] 
		PTR_TO_PC ebx
		mov	[_logbuffer+16+eax],ebx
		inc	dword ptr [_loglast]
		mov	ebx,[_loglast]
		sub	ebx,[_logfirst]
		cmp	ebx,EVENTCOUNT
		jne	rIRQlogno
		inc	dword ptr [_logfirst]
rIRQlogno:	pop	ebx
#endif

rIRQ_sched_exit:SCAN_EVENTS_LVL5
rIRQ_exit:	pop	edx
		pop	ecx
		pop	ebx
		pop	eax
		ret


;============================================================
; Transfers control to an interrupt routine
;
; 1. Put SSP/MSP into A7
; 2. Generate stack frame with normal format
; 3. T1 = T0 = 0, S = 1, set IRQ level (A7 already correct)
; 4. If 020++ and not 060: Get ISP, generate throwaway frame
;    with SR from step 3
; 5. If 020++ and not 060: Clear M bit (A7 already correct)
; 6. Set new PC and fill prefetch if enabled
; 7. Restart CPU if stopped
; 8. Reschedule events
;============================================================


		ALIGN32

public set_up_interrupt_
set_up_interrupt_:
		pushad
		ACTIVATE_SSP					; step 1
		mov	ebx, dword ptr [_interruptlevel]	; step 2
		mov	esi, dword ptr [_pc]
		GENERATE_STACK_FRAME
		and	byte ptr [_sr + 1], 38h			; step 3 
		mov	cl, byte ptr [_interruptlevel]
		or	cl, 20h
		or	byte ptr [_sr + 1], cl
		cmp	byte ptr [_config_cpu_type], 2		; step 4
		jb	si_step6
		cmp	byte ptr [_config_cpu_type], 6
		jae	si_step6
		mov	ecx, dword ptr [_a + 28]
		test	byte ptr [_sr + 1], 010h
		jz	si_alreadyisp
		mov	dword dword ptr [_msp], ecx
		mov	ecx, dword ptr [_ssp]
		mov	dword ptr [_a + 28], ecx
si_alreadyisp:	mov	ebx, dword ptr [_interruptlevel]
		FRAME1	ebx
		and	byte ptr [_sr + 1], 0efh		; step 5
si_step6:	mov	edx, dword ptr [_interruptaddress]	; step 6
		PC_TO_PTR edx
		mov	dword ptr [_pc], edx
#ifdef PREFETCH
		call	prefetch_fill_
#endif
		test	byte ptr [_cpustopflag], 1		; step 7
		jz	si_nostop
		cmp	byte ptr [_blitterstatus], 2
		je	si_nostop
		mov	edx, dword ptr [_curcycle]
		add	edx, 4
		mov	dword ptr [_cpu_next], edx
		mov	dword ptr [_cpustopflag], 0
si_nostop:	mov	dword ptr [_interruptflag], 0
		mov	dword ptr [_irq_next], -1		; step 8
		SCAN_EVENTS_LVL5
		popad
		ret


;===============================================
; Sets up an exception - ebx - offset of vector
;===============================================


		ALIGN32

public prepare_exception_
prepare_exception_:	push	eax
#ifdef DEBUGBUILD
		push	ebx
		mov	eax,[_loglast]
		and	eax,EVENTMASK
		shl	eax,6
		cmp	ebx,08h
		jne	eup1
		cmp	byte ptr [_logbuserrorex],1
		jne	eupnei
		mov	ebx,EXBUSERROR
		jmp	eupja
eup1:		cmp	ebx,0ch
		jne	eup2
		cmp	byte ptr [_logoddaddressex],1
		jne	eupnei
		mov	ebx,EXODDADDRESS
		jmp	eupja
eup2:		cmp	ebx,010h 
		jne	eup3
		cmp	byte ptr [_logillegalinstructionex],1
		jne	eupnei
		mov	ebx,EXILLEGAL
		jmp	eupja
eup3:		cmp	ebx,014h
		jne	eup6
		cmp	byte ptr [_logdivisionby0ex],1
		jne	eupnei
		mov	ebx,EXDIVBYZERO
		jmp	eupja
eup6:		cmp	ebx,020h
		jne	eup8
		cmp	byte ptr [_logprivilegieviolationex],1
		jne 	eupnei
		mov	ebx,EXPRIV
		jmp	eupja
eup8:		cmp	ebx,02ch
		jne	eup7
		cmp	byte ptr [_logfline],1
		jne 	eupnei
		mov	ebx,EXFLINE
		jmp	eupja
eup7:		cmp	ebx,080h
		jbe	eupnei
		cmp	ebx,0bch
		ja	eupnei
		cmp	byte ptr [_logtrapex],1
		jne	eupnei
		mov	[_logbuffer+20+eax],ebx
		mov	ebx,EXTRAP
eupja:		mov     [_logbuffer+eax],ebx
		mov	ebx,[_frames]
		mov	[_logbuffer+4+eax],ebx
		mov	ebx,[_ypos]
		mov	[_logbuffer+8+eax],ebx
		mov	ebx,[_xpos]
		mov	[_logbuffer+12+eax],ebx
		mov	ebx,esi ;[_pc] 
		PTR_TO_PC ebx
		mov	[_logbuffer+16+eax],ebx
		inc	dword ptr [_loglast]
		mov	ebx,[_loglast]
		sub	ebx,[_logfirst]
		cmp	ebx,EVENTCOUNT
		jne	eupnei
		inc	dword ptr [_logfirst]
eupnei:		pop	ebx
#endif

		ACTIVATE_SSP
		GENERATE_STACK_FRAME
		mov	ecx, dword ptr [_vbr]
		add	ecx, ebx 
		fetchl
		PC_TO_PTR edx
		mov	dword ptr [_pc], edx		; Set PC
		mov	esi, edx

		or	byte ptr [_sr + 1], 20h	; Set supermodus
		and	byte ptr [_sr + 1], 03fh

		test	byte ptr [_cpustopflag], 1 ; If CPU stopped, restart it
		jz	prpenostop
		mov	dword ptr [_cpustopflag], 0
		mov	eax, dword ptr [_curcycle]
		add	eax, 4
		mov	dword ptr [_cpu_next], eax

prpenostop:	pop	eax
		mov	esp, [_exceptionstack]
#ifdef PREFETCH
		mov	edx,dword ptr [_pc]
		call	prefetch_fill_
#endif
		jmp	dword ptr [_exceptionbackdooraddress]


;
; Adressmode routines to read byte, word, longword
; With PC increase
; Parameters:  In:  edx - pointer to register   esi - current PC position     
;             Out:  edx - result                esi - current PC position
;

	
; Dx        read
; --------------
; Ax        read
; --------------


                ALIGN32

public arb00_
public arw00_
public arl00_
public arw01_
public arl01_

arb00_:
arw00_:
arl00_:
arw01_:
arl01_:         mov     edx,dword ptr [edx]             
                ret                                     
						

; (Ax)      read
; --------------


                ALIGN32

public arl02_
arl02_:         mov     ecx,dword ptr [edx]
                fetchl
		ret


                ALIGN32

public arw02_
arw02_:         mov     ecx,dword ptr [edx]
		fetchw
		ret


                ALIGN32

public arb02_
arb02_:         mov     ecx,dword ptr [edx]
		fetchb
		ret


; (Ax)+     read
; --------------


                ALIGN32

public arl03_
arl03_:         mov     ecx,dword ptr [edx]
                add     dword ptr [edx],4
                fetchlret


                ALIGN32

public arw03_
arw03_:         mov     ecx,dword ptr [edx]
                add     dword ptr [edx],2
                fetchwret


                ALIGN32

public arb03_
arb03_:         mov     ecx,dword ptr [edx]
                inc     dword ptr [edx]
                cmp     edx,dword ptr [_a7pointer]
                jne     egt
                inc     dword ptr [edx]
egt:		fetchb
		ret



; -(Ax)     read
; --------------


                ALIGN32

public arl04_
arl04_:         sub     dword ptr [edx],4
                mov     ecx,dword ptr [edx]
                fetchlret


                ALIGN32

public arw04_
arw04_:         sub     dword ptr [edx],2
                mov     ecx,dword ptr [edx]
                fetchwret


                ALIGN32

public arb04_
arb04_:         dec     dword ptr [edx]
                cmp     edx,dword ptr [_a7pointer]
                jne     arw04a
                dec     dword ptr [edx]
arw04a:         mov     ecx,dword ptr [edx]
		fetchb
		ret



; disp(Ax)  read
; --------------


                ALIGN32

public arl05_
arl05_:         push    edx               
                mov     ecx,esi           
                fetchwopcode_inc_pos
                movsx   ecx,dx
                pop     edx                     
                add     esi,2                   
                add     ecx,dword ptr [edx]     
                fetchlret


                ALIGN32

public arw05_
arw05_:         push    edx
                mov     ecx,esi
                fetchwopcode_inc_pos
                movsx   ecx,dx
                pop     edx
                add     esi,2
                add     ecx,dword ptr [edx]
                fetchwret


                ALIGN32

public arb05_
arb05_:         push    edx
                mov     ecx,esi
                fetchwopcode_inc_pos
                movsx   ecx,dx
                pop     edx
                add     esi,2
                add     ecx,dword ptr [edx]
		fetchb
		ret



; disp(Ax,Ri) read
; ----------------


                ALIGN32

public arl06_
arl06_:         push    ebx                   
                mov     ebx,edx               
                mov     ecx,esi               
                fetchwopcode_inc_pos
                add     esi,2                 
                movsx   ecx,dl                
                add     ecx,dword ptr [ebx]   
                mov     ebx,edx               
                shr     ebx,10                
                and     ebx,03ch              
                mov     ebx,dword ptr [_d+ebx]
                test    dh,08h                
                jnz     xx1                   
                movsx   ebx,bx                
xx1:            add     ecx,ebx               
                pop     ebx                   
                fetchlret                  


                ALIGN32

public arw06_
arw06_:         push    ebx
                mov     ebx,edx
                mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   ecx,dl
                add     ecx,dword ptr [ebx]
                mov     ebx,edx
                shr     ebx,10
                and     ebx,03ch
                mov     ebx,dword ptr [_d+ebx]          ; Exploit position
                test    dh,08h                          ; Size
                jnz     xx2
                movsx   ebx,bx
xx2:            add     ecx,ebx
                pop     ebx
                fetchwret


                ALIGN32

public arb06_
arb06_:         push    ebx
                mov     ebx,edx
                mov     ecx,esi                         ; Get word for adressmode
                fetchwopcode_inc_pos
                add     esi,2
                movsx   ecx,dl                          ; Get displacement
                add     ecx,dword ptr [ebx]             ; Add adress register
                mov     ebx,edx
                shr     ebx,10
                and     ebx,03ch
                mov     ebx,dword ptr [_d+ebx]          ; Exploit position
                test    dh,08h                          ; Size
                jnz     xx3
                movsx   ebx,bx
xx3:            add     ecx,ebx                         ; Add dataregister
                pop     ebx
		fetchb
		ret



; xxx.W     read
; --------------


                ALIGN32

public arl70_
arl70_:         mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   ecx,dx
                fetchlret


                ALIGN32

public arw70_
arw70_:         mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   ecx,dx
                fetchwret


                ALIGN32

public arb70_
arb70_:         mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   ecx,dx
		fetchb
		ret



; xxx.L     read
; --------------


                ALIGN32

public arl71_

arl71_:         mov     ecx,esi
                fetchlopcode_inc_pos
                add     esi,4
                mov     ecx,edx
                fetchlret


                ALIGN32

public arw71_
arw71_:         mov     ecx,esi
                fetchlopcode_inc_pos
                add     esi,4
                mov     ecx,edx
                fetchwret


                ALIGN32

public arb71_
arb71_:         mov     ecx,esi
                fetchlopcode_inc_pos
                add     esi,4
                mov     ecx,edx
		fetchb
		ret



; disp(pc)  read
; --------------


                ALIGN32

public arl72_
arl72_:         mov     ecx,esi
                fetchwopcode_inc_pos
                movsx   ecx,dx
                add     ecx,esi
                PTR_TO_PC ecx
                add     esi,2
                fetchlret


                ALIGN32

public arw72_
arw72_:         mov     ecx,esi
                fetchwopcode_inc_pos
                movsx   ecx,dx
                add     ecx,esi
                PTR_TO_PC ecx
                add     esi,2
                fetchwret


                ALIGN32

public arb72_
arb72_:         mov     ecx,esi
                fetchwopcode_inc_pos
                movsx   ecx,dx
                add     ecx,esi
                PTR_TO_PC ecx
                add     esi,2
		fetchb
		ret



; disp(pc,Ri) read
; ----------------


                ALIGN32

public arl73_
arl73_:         push    ebx
                mov     ecx,esi
                fetchwopcode_inc_pos
                movsx   ecx,dl
                add     ecx,esi
                PTR_TO_PC ecx
                mov     ebx,edx
                shr     ebx,10
                and     ebx,03ch
                add     esi,2
                mov     ebx,dword ptr [_d+ebx]          ; Exploit position
                test    dh,08h                          ; Size
                jnz     xx4
                movsx   ebx,bx
xx4:            add     ecx,ebx
                pop     ebx
                fetchlret


                ALIGN32

public arw73_
arw73_:         push    ebx
                mov     ecx,esi
                fetchwopcode_inc_pos
                movsx   ecx,dl
                add     ecx,esi
                PTR_TO_PC ecx
                mov     ebx,edx
                shr     ebx,10
                and     ebx,03ch
                add     esi,2
                mov     ebx,dword ptr [_d+ebx]          ; Exploit position
                test    dh,08h                          ; Size
                jnz     xx5
                movsx   ebx,bx
xx5:            add     ecx,ebx
                pop     ebx
                fetchwret


                ALIGN32

public arb73_
arb73_:         push    ebx
                mov     ecx,esi
                fetchwopcode_inc_pos
                movsx   ecx,dl
                add     ecx,esi
                PTR_TO_PC ecx
                mov     ebx,edx
                shr     ebx,10
                and     ebx,03ch
                add     esi,2
                mov     ebx,dword ptr [_d+ebx]          ; Exploit position
                test    dh,08h                          ; Size
                jnz     xx6
                movsx   ebx,bx
xx6:            add     ecx,ebx
                pop     ebx
		fetchb
		ret



; #xxxxxxxx read
; --------------


                ALIGN32

public arl74_
arl74_:         mov     ecx,esi
                add     esi,4
                fetchlopcode_inc_pos
                ret

                ALIGN32

public arw74_
public arb74_
arw74_:
arb74_:         mov     ecx,esi
                add     esi,2
                fetchwopcode_inc_pos
                ret


;
; Adressemode Routiner for lesning av byte,word,longword
; UTEN PC KNING,  og An inc/dec
; Konstanter ved start:  edx - reg.nr*4   edx - retur  esi - PC
;


; (Ax)+     les
; -------------


                ALIGN32

public parl03_
parl03_:        mov     ecx,dword ptr [edx]
                fetchlret


                ALIGN32

public parw03_
parw03_:        mov     ecx,dword ptr [edx]
                fetchwret


                ALIGN32

public parb03_
parb03_:        mov     ecx,dword ptr [edx]
		fetchb
		ret



; -(Ax)     les
; -------------


                ALIGN32

public parl04_
parl04_:        mov     ecx,dword ptr [edx]
                sub     ecx,4
                fetchlret


                ALIGN32

public parw04_
parw04_:        mov     ecx,dword ptr [edx]
                sub     ecx,2
                fetchwret


                ALIGN32

public parb04_
parb04_:        mov     ecx,dword ptr [edx]
                dec     ecx
                cmp     edx,dword ptr [_a7pointer]
                jne     egt2
                dec     ecx
egt2:		fetchb
		ret



; disp(Ax)  les
; -------------


                ALIGN32

public parl05_
parl05_:        push    edx
                mov     ecx,esi
                fetchwopcode_keep_pos
                movsx   ecx,dx
                pop     edx
                add     ecx,dword ptr [edx]
                fetchlret


                ALIGN32

public  parw05_
parw05_:        push    edx
                mov     ecx,esi
                fetchwopcode_keep_pos
                movsx   ecx,dx
                pop     edx
                add     ecx,dword ptr [edx]
                fetchwret


                ALIGN32

public parb05_
parb05_:        push    edx
                mov     ecx,esi
                fetchwopcode_keep_pos
                movsx   ecx,dx
                pop     edx
                add     ecx,dword ptr [edx]
		fetchb
		ret



; disp(Ax,Ri) les
; ---------------


                ALIGN32

public parl06_
parl06_:        push    ebx
                mov     ebx,edx
                mov     ecx,esi
                fetchwopcode_keep_pos
                movsx   ecx,dl
                add     ecx,dword ptr [ebx]
                mov     ebx,edx
                shr     ebx,10
                and     ebx,03ch
                mov     ebx,dword ptr [_d+ebx]          ; Exploit position
                test    dh,08h                          ; Size
                jnz     pxx1
                movsx   ebx,bx
pxx1:           add     ecx,ebx
                pop     ebx
                fetchlret


                ALIGN32

public parw06_
parw06_:        push    ebx
                mov     ebx,edx
                mov     ecx,esi
                fetchwopcode_keep_pos
                movsx   ecx,dl
                add     ecx,dword ptr [ebx]
                mov     ebx,edx
                shr     ebx,10
                and     ebx,03ch
                mov     ebx,dword ptr [_d+ebx]          ; Exploit position
                test    dh,08h                          ; Size
                jnz     pxx2
                movsx   ebx,bx
pxx2:           add     ecx,ebx
                pop     ebx
                fetchwret


                ALIGN32

public parb06_
parb06_:        push    ebx
                mov     ebx,edx
                mov     ecx,esi
                fetchwopcode_keep_pos
                movsx   ecx,dl
                add     ecx,dword ptr [ebx]
                mov     ebx,edx
                shr     ebx,10
                and     ebx,03ch
                mov     ebx,dword ptr [_d+ebx]          ; Exploit position
                test    dh,08h                          ; Size
                jnz     pxx3
                movsx   ebx,bx
pxx3:           add     ecx,ebx
                pop     ebx
		fetchb
		ret



; xxx.W     les
; -------------


                ALIGN32

public parl70_
parl70_:        mov     ecx,esi
                fetchwopcode_keep_pos
                movsx   ecx,dx
                fetchlret


                ALIGN32

public parw70_
parw70_:        mov     ecx,esi
                fetchwopcode_keep_pos
                movsx   ecx,dx
                fetchwret


                ALIGN32

public parb70_
parb70_:        mov     ecx,esi
                fetchwopcode_keep_pos
                movsx   ecx,dx
		fetchb
		ret



; xxx.L     les
; -------------


                ALIGN32

public parl71_
parl71_:        mov     ecx,esi
                fetchlopcode_keep_pos
                mov     ecx,edx
                fetchlret


                ALIGN32

public parw71_
parw71_:        mov     ecx,esi
                fetchlopcode_keep_pos
                mov     ecx,edx
                fetchwret


                ALIGN32

public parb71_
parb71_:        mov     ecx,esi
                fetchlopcode_keep_pos
                mov     ecx,edx
		fetchb
		ret



; disp(pc)  les
; -------------


                ALIGN32

public parl72_
parl72_:        mov     ecx,esi
                fetchwopcode_keep_pos
                movsx   ecx,dx
                add     ecx,esi
                PTR_TO_PC ecx
                fetchlret


                ALIGN32

public parw72_
parw72_:        mov     ecx,esi
                fetchwopcode_keep_pos
                movsx   ecx,dx
                add     ecx,esi
                PTR_TO_PC ecx
                fetchwret


                ALIGN32

public parb72_
parb72_:        mov     ecx,esi
                fetchwopcode_keep_pos
                movsx   ecx,dx
                add     ecx,esi
                PTR_TO_PC ecx
		fetchb
		ret



; disp(pc,Ri) les
; ---------------


                ALIGN32

public parl73_
parl73_:        push    ebx
                mov     ecx,esi
                fetchwopcode_keep_pos
                movsx   ecx,dl
                mov     ebx,edx
                shr     ebx,10
                and     ebx,03ch
                add     ecx,esi
                PTR_TO_PC ecx
                mov     ebx,dword ptr [_d+ebx]          ; Exploit position
                test    dh,08h                          ; Size
                jnz     pxx4
                movsx   ebx,bx
pxx4:           add     ecx,ebx
                pop     ebx
                fetchlret


                ALIGN32

public parw73_
parw73_:        push    ebx
                mov     ecx,esi
                fetchwopcode_keep_pos
                movsx   ecx,dl
                mov     ebx,edx
                shr     ebx,10
                and     ebx,03ch
                add     ecx,esi
                PTR_TO_PC ecx
                mov     ebx,dword ptr [_d+ebx]          ; Exploit position
                test    dh,08h                          ; Size
                jnz     pxx5
                movsx   ebx,bx
pxx5:           add     ecx,ebx
                pop     ebx
                fetchwret


                ALIGN32

public parb73_
parb73_:        push    ebx
                mov     ecx,esi
                fetchwopcode_keep_pos
                movsx   ecx,dl
                mov     ebx,edx
                shr     ebx,10
                and     ebx,03ch
                add     ecx,esi
                PTR_TO_PC ecx
                mov     ebx,dword ptr [_d+ebx]          ; Exploit position
                test    dh,08h                          ; Size
                jnz     pxx6
                movsx   ebx,bx
pxx6:           add     ecx,ebx
                pop     ebx
		fetchb
		ret



; #xxxxxxxx les
; -------------


                ALIGN32

public parl74_
parl74_:        mov     ecx,esi
                fetchlopcode_keep_pos
                ret

                ALIGN32

public parw74_
public parb74_
parw74_:
parb74_:        mov     ecx,esi
                fetchwopcode_keep_pos
                ret


;
; Addressmode write
; with PC and -(aX)+ modify
; In: EBX - reg.nr EDX - data som skal writees
;


; Dx     write
; -------------


                ALIGN32

public awb00_
awb00_:         mov     byte ptr [ebx],dl
                ret


                ALIGN32

public aww00_
aww00_:         mov     word ptr [ebx],dx
                ret


                ALIGN32

public awl00_
awl00_:         mov     dword ptr [ebx],edx
                ret


; Ax      write
; -------------


                ALIGN32

public aww01_
aww01_:         movsx   edx,dx
                mov     dword ptr [ebx],edx
                ret


                ALIGN32

public awl01_
awl01_:         mov     dword ptr [ebx],edx
                ret


; (Ax)    write
; -------------


                ALIGN32

public awl02_
awl02_:         mov     ecx,dword ptr [ebx]
                writelret


                ALIGN32

public aww02_
aww02_:         mov     ecx,dword ptr [ebx]
                writewret


                ALIGN32

public awb02_
awb02_:         mov     ecx,dword ptr [ebx]
                writebret


; (Ax)+     write
; ---------------

                ALIGN32

public awl03_
awl03_:         mov     ecx,dword ptr [ebx]
                add     dword ptr [ebx],4
                writelret


                ALIGN32

public aww03_
aww03_:         mov     ecx,dword ptr [ebx]
                add     dword ptr [ebx],2
                writewret


                ALIGN32

public awb03_
awb03_:         mov     ecx,dword ptr [ebx]
                inc     dword ptr [ebx]
                cmp     ebx,dword ptr [_a7pointer]
                jne     egt3
                inc     dword ptr [ebx]
egt3:		writebret


; -(Ax)     write
; ---------------


                ALIGN32

public awl04_
awl04_:         sub     dword ptr [ebx],4
                mov     ecx,dword ptr [ebx]
                writelret


                ALIGN32

public aww04_
aww04_:         sub     dword ptr [ebx],2
                mov     ecx,dword ptr [ebx]
                writewret


                ALIGN32

public awb04_
awb04_:         dec     dword ptr [ebx]
                cmp     ebx,dword ptr [_a7pointer]
                jne     awb04a
                dec     dword ptr [ebx]
awb04a:         mov     ecx,dword ptr [ebx]
		writebret


; disp(Ax)  write
; -------------


                ALIGN32

public awl05_
awl05_:         push    edx
                mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   ecx,dx
                add     ecx,dword ptr [ebx]
                pop     edx
                writelret


                ALIGN32

public aww05_
aww05_:         push    edx
                mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   ecx,dx
                add     ecx,dword ptr [ebx]
                pop     edx
                writewret


                ALIGN32

public awb05_
awb05_:         push    edx
                mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   ecx,dx
                add     ecx,dword ptr [ebx]
                pop     edx
                writebret


; disp(Ax,Ri) write
; -----------------


                ALIGN32

public awl06_
awl06_:         push    edx
                mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   ecx,dl
                add     ecx,dword ptr [ebx]
                mov     ebx,edx
                shr     ebx,10
                and     ebx,03ch
                mov     ebx,dword ptr [_d+ebx]          ; Exploit position
                test    dh,08h                          ; Size
                jnz     wxx1
                movsx   ebx,bx
wxx1:           add     ecx,ebx
                pop     edx
                writelret


                ALIGN32

public aww06_
aww06_:         push    edx
                mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   ecx,dl
                add     ecx,dword ptr [ebx]
                mov     ebx,edx
                shr     ebx,10
                and     ebx,03ch
                mov     ebx,dword ptr [_d+ebx]          ; Exploit position
                test    dh,08h                          ; Size
                jnz     wxx2
                movsx   ebx,bx
wxx2:           add     ecx,ebx
                pop     edx
                writewret


                ALIGN32

public awb06_
awb06_:         push    edx
                mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   ecx,dl
                add     ecx,dword ptr [ebx]
                mov     ebx,edx
                shr     ebx,10
                and     ebx,03ch
                mov     ebx,dword ptr [_d+ebx]          ; Exploit position
                test    dh,08h                          ; Size
                jnz     wxx3
                movsx   ebx,bx
wxx3:           add     ecx,ebx
                pop     edx
                writebret


; xxx.W     write
; ---------------


                ALIGN32

public awl70_
awl70_:         push    edx
                mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   ecx,dx
                pop     edx
                writelret


                ALIGN32

public aww70_
aww70_:         push    edx
                mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   ecx,dx
                pop     edx
                writewret


                ALIGN32

public awb70_
awb70_:         push    edx
                mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   ecx,dx
                pop     edx
                writebret


; xxx.L     write
; ---------------


                ALIGN32

public awl71_
awl71_:         push    edx
                mov     ecx,esi
                fetchlopcode_inc_pos
                add     esi,4
                mov     ecx,edx
                pop     edx
                writelret


                ALIGN32

public aww71_
aww71_:         push    edx
                mov     ecx,esi
                fetchlopcode_inc_pos
                add     esi,4
                mov     ecx,edx
                pop     edx
                writewret


                ALIGN32

public awb71_
awb71_:         push    edx
                mov     ecx,esi
                fetchlopcode_inc_pos
                add     esi,4
                mov     ecx,edx
                pop     edx
                writebret


;
; Effective address evaluation
; Increases PC
; In:  edx - reg.nr*4+d   esi - PC
; Out: edx - effective address
;


; (Ax)      les
; -------------


                ALIGN32

public eac02_
eac02_:         mov     edx,dword ptr [edx] 
                ret                         


; disp(Ax)  les
; -------------


                ALIGN32

public eac05_
eac05_:         push    ebx
                mov     ebx,edx
                mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   edx,dx
                add     edx,dword ptr [ebx]
                pop     ebx
                ret


; disp(Ax,Ri) les
; ---------------


                ALIGN32

public eac06_
eac06_:         push    ebx
                mov     ebx,edx
                mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   ecx,dl
                add     ecx,dword ptr [ebx]
                mov     ebx,edx
                shr     ebx,10
                and     ebx,03ch
                mov     ebx,dword ptr [_d+ebx]          ; Exploit position
                test    dh,08h                          ; Size
                jnz     xxc1
                movsx   ebx,bx
xxc1:           add     ecx,ebx
                mov     edx,ecx
                pop     ebx
                ret


; xxx.W     les
; -------------


                ALIGN32

public eac70_
eac70_:         mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   edx,dx
                ret


; xxx.L     les
; -------------


                ALIGN32

public eac71_
eac71_:         mov     ecx,esi
                add     esi,4
                fetchlopcode_inc_pos
                ret


; disp(pc)  les
; -------------


                ALIGN32

public eac72_
eac72_:         push    ebx
                mov     ebx,esi
                mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   edx,dx
                add     edx,ebx
		PTR_TO_PC edx
                pop     ebx
                ret


; disp(pc,Ri) les
; ---------------


                ALIGN32

public eac73_
eac73_:         push    ebx
                mov     ebx,esi
                mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                movsx   ecx,dl
                add     ecx,ebx
                mov     ebx,edx
                shr     ebx,10
                and     ebx,03ch
                mov     ebx,dword ptr [_d+ebx]          ; Exploit position
                test    dh,08h                          ; Size
                jnz     xxc4
                movsx   ebx,bx
xxc4:           add     ecx,ebx
                mov     edx,ecx
                PTR_TO_PC edx
                pop     ebx
                ret


;
; Evaluation of branch conditions
; Out:  dl = 1 means branch / 0 not
;


; RA (TRUE)
; ---------


                        ALIGN32

public cc0_
cc0_:                   mov     dl,1
                        ret


; SR (TRUE) PC to stack
; ---------------------


                        ALIGN32

public cc1_
cc1_:		mov	ebx, ecx			; Save ecx
		mov	ecx, dword ptr [_a + 28]
		sub	ecx, 4
		mov	dword ptr [_a + 28], ecx
		mov	edx, esi
		add	edx, dword ptr [edi + 12]
		PTR_TO_PC edx
		writel					; Push PC to stack
		mov	ecx, ebx
		mov	dl, 1
		ret


; F (FALSE)
; ---------


                        ALIGN32

public cc1false_
cc1false_:              xor     edx,edx
                        ret


; HI (-C & -Z)
; ------------


                        ALIGN32

public cc2_
cc2_:                   xor     edx,edx
                        test    byte ptr _sr,05h
                        jnz     cc2a
                        inc     edx
cc2a:                   ret


; LS (C OR Z)
; -----------


                        ALIGN32

public cc3_
cc3_:                   mov     edx,dword ptr _sr
                        and     dl,05h
                        ret


; CC (-C)
; -------


                        ALIGN32

public cc4_
cc4_:                   mov     edx,dword ptr _sr
                        and     dl,01h
                        xor     dl,01h
                        ret


; CS (C)
; ------


                        ALIGN32

public cc5_
cc5_:                   mov     edx,dword ptr _sr
                        and     dl,01h
                        ret


; NE (-Z)
; -------


                        ALIGN32

public cc6_
cc6_:                   mov     edx,dword ptr _sr
                        and     dl,04h
                        xor     dl,04h
                        ret


; EQ (Z)
; ------


                        ALIGN32

public cc7_
cc7_:                   mov     edx,dword ptr _sr
                        and     dl,04h
                        ret


; VC (-V)
; -------


                        ALIGN32

public cc8_
cc8_:                   mov     edx,dword ptr _sr
                        and     dl,02h
                        xor     dl,02h
                        ret


; VS (V)
; ------


                        ALIGN32

public cc9_
cc9_:                   mov     edx,dword ptr _sr
                        and     dl,02h
                        ret


; PL (-N)
; -------


                        ALIGN32

public cca_
cca_:                   mov     edx,dword ptr _sr
                        and     dl,08h
                        xor     dl,08h
                        ret


; MI (N)
; ------


                        ALIGN32

public ccb_
ccb_:                   mov     edx,dword ptr _sr
                        and     dl,08h
                        ret


; GE (N AND V OR -N AND -V)
; -------------------------


                        ALIGN32

public ccc_
ccc_:                   mov     edx,dword ptr _sr
                        and     edx,0fh
                        mov     dl,byte ptr [_ccctt+edx]
                        ret


; LT (N AND -V OR -N AND V)
; -------------------------


                        ALIGN32

public ccd_
ccd_:                   mov     edx,dword ptr _sr
                        and     edx,0fh
                        mov     dl,byte ptr [_ccdtt+edx]
                        ret


; GT (-Z & -N & V) OR (-Z & N & -V) 
; Old and Wrong: (N & V & Z) OR (-N & -V & -Z)
; --------------------------------


                        ALIGN32

public cce_
cce_:                   mov     edx,dword ptr [_sr]
                        and     edx,0fh
                        mov     dl,byte ptr [_ccett+edx]
                        ret

; LE ( Z OR (N & -V) OR (-N & V) )
; --------------------------------

                        ALIGN32

public ccf_
ccf_:                   mov     edx,dword ptr _sr
                        and     edx,0fh
                        mov     dl,byte ptr [_ccftt+edx]
                        ret


; End of branch conditions
;

;
; Exceptions
;


                        ALIGN32

public privilegie_violation_
public privilegie_violation
privilegie_violation:
privilegie_violation_:  sub     esi,2
                        mov     ebx,020h
                        mov     eax,38
			jmp     prepare_exception_


;
; Illegal instruction
;


extern call_calltrap_:near

                        ALIGN32

public i00_
i00_:		mov	esi, dword ptr [_pc]
		mov	ecx, esi
		PTR_TO_PC ecx
		mov	ebx, ecx
		fetchw
		mov	ecx, edx
		and	dh, 0f0h
		cmp	dh, 0f0h
		je	i00fline
		cmp	dh, 0a0h
		je	i00aline
		mov	ebx, 010h
		mov	eax, 38
		jmp	prepare_exception_

i00fline:	mov	ebx, 02ch
		mov	eax, 38
		jmp	prepare_exception_

i00aline:	and	ebx, 0ff0000h
		cmp	ebx, 0f00000h
		je	i00berndline
		mov	ebx, 028h
		mov	eax, 38
		jmp	prepare_exception_

i00berndline:	add	dword ptr [_pc], 2
		and	ecx, 0fffh
		mov	eax, ecx
		call	call_calltrap_
		mov	eax, 512
		mov	esi, dword ptr [_pc]
		sub	dword ptr [_pc], 2
		ret
			

;
; Instruction 1   ABCD.B Dy,Dx    ABCD.B -(Ay),-(Ax)
; Tableusage  2 - rx*4(dest)  3 - ry*4
; Opcode*32 i edi
; FLAGS: XC
;

                ALIGN32

public i01_1_
i01_1_:
	mov     ebx,dword ptr [8+edi]          ; ebx - Source register
	mov     ecx,dword ptr [4+edi]           ; ecx - Destination register
	mov     edx,dword ptr _sr               ; edx - Flags
	movzx   eax,byte ptr [ebx]              ; eax - Get Source data

	movzx   ebx,byte ptr [_bcd2hex+eax]     ; ebx - Binary version of source
	movzx   eax,byte ptr [ecx]              ; eax - Get Destination data

	movzx   eax,byte ptr [_bcd2hex+eax]     ; eax - Binary version of source
	test    dl,10h                          ; Add X flag to bl
	jz      i01_1a
	inc     ebx
i01_1a: add     eax,ebx
	and     dl,0eh
	cmp     al,100                          ; Carry?
	jb      i01_1b
	or      edx,11h                         ; Carry!
	sub     al,100
i01_1b: test    al,al                           ; Zero?
	jz      i01_1c
	and     dl,01bh                         ; Non-Zero!
i01_1c: mov     byte ptr _sr,dl                 ; Flags end
        and     eax,0ffh
        mov     al,byte ptr [_hex2bcd+eax]
	mov     byte ptr [ecx],al
	mov     eax,6
	ret                                     

                ALIGN32

public i01_2_
i01_2_:
        mov     ebx,dword ptr [8+edi]        ; Source
	mov     ecx,dword ptr [ebx]
	dec     ecx
        cmp     ebx,dword ptr [_a7pointer]
        jne     i01_2i
        dec     ecx
i01_2i:
	mov     dword ptr [ebx],ecx
	xor     edx,edx
        fetchb
        xor     ebx,ebx
        mov     bl,byte ptr [_bcd2hex+edx]                           ; bl is now sourcedata
	mov     eax,dword ptr [4+edi]         ; Dest
	mov     ecx,dword ptr [eax]
	dec     ecx
        cmp     eax,dword ptr [_a7pointer]
        jne     i01_2j
        dec     ecx
i01_2j:
	mov     dword ptr [eax],ecx
	xor     edx,edx
	mov     ebp,ecx                          ; Save ecx for later use
        fetchb
        xor     eax,eax
        mov     al,byte ptr [_bcd2hex+edx]
	mov     dl,byte ptr _sr                  ; Flags
	test    dl,10h
	jz      i01_2a
	inc     eax
i01_2a: add     eax,ebx
	and     dl,0eh
	cmp     al,100                          ; Carry?
	jb      i01_2b
	or      dl,11h                          ; Carry!
	sub     al,100
i01_2b: test    al,al                           ; Zero?
	jz      i01_2c
	and     dl,01bh                         ; Non-Zero!
i01_2c: mov     byte ptr _sr,dl                 ; Flags end
        and     eax,0ffh
        mov     dl,byte ptr [_hex2bcd+eax]
	mov     ecx,ebp                         ; restore saved <ea>
        writeb
	mov     eax,18                          ; return cyclecount
	ret     


IMSK_XNZVC      =     0x8c1
MCLR_XNZVC      =     0
MSET_XNZVC      =     0x1f
		
SETFLAGS macro INTELMASK, M68CLEAR, M68SET
		pushfd
		pop	eax
		and	eax,INTELMASK
                mov     eax,dword ptr [_statustab+4*eax]
                if      M68SET eq 0x1f
                        mov     byte ptr [_sr],al
                else
                        mov     ah,byte ptr [_sr]
                        and     ah,M68CLEAR
                        and     al,M68SET
                        or      ah,al
                        mov     byte ptr [_sr],ah
                endif
endm
	 	
GETARG macro ROUTINE,REGISTER,DESTREG 
		mov	edx,dword ptr [REGISTER]
		call	dword ptr [ROUTINE]
                ifdif   DESTREG,edx
                        mov     DESTREG,edx
                endif
endm	

SETARG macro ROUTINE,REGISTER,SOURREG 
		mov	ebx,dword ptr [REGISTER]
                ifdif   SOURREG,edx
                        mov     edx,SOURREG
                endif
		call	dword ptr [ROUTINE]
endm	

GETREGVAL macro DESTREG , REGISTER , REGREG
                mov     REGREG,dword ptr [REGISTER]
                mov     DESTREG,dword ptr [REGREG]
endm

SETREGVAL macro SOURREG , REGISTER
                mov     eax,dword ptr [REGISTER]
                mov     dword ptr [eax],SOURREG
endm
				
SETREGVALHREG macro SOURREG , REGISTER , REGREG
                mov     dword ptr [REGREG],SOURREG
endm
				
;================================================
; ADD.X <ea>,Dn (case 1) / ADD.X Dn,<ea> (case 2)
; Flags: All
;================================================

                ALIGN32

public i02_B_1_
i02_B_1_:
#ifdef TSC_PROFILING
		call		i02tsc_before_
#endif
	        GETARG          edi+12,edi+8,edx
                GETREGVAL       ecx,edi+16,ebx
                add             cl,dl
                SETFLAGS        IMSK_XNZVC,MCLR_XNZVC,MSET_XNZVC
                SETREGVALHREG   ecx,edi+16,ebx
                mov             eax,dword ptr [edi+20]
#ifdef TSC_PROFILING
		call		i02tsc_after_
#endif
		ret

                ALIGN32

public i02_W_1_
i02_W_1_:
#ifdef TSC_PROFILING	
 	        call		i02tsc_before_
#endif
		GETARG          edi+12,edi+8,edx
                GETREGVAL       ecx,edi+16,ebx
                add             cx,dx
                SETFLAGS        IMSK_XNZVC,MCLR_XNZVC,MSET_XNZVC
                SETREGVALHREG   ecx,edi+16,ebx
                mov             eax,dword ptr [edi+20]
#ifdef TSC_PROFILING
		call		i02tsc_after_
#endif
		ret

                ALIGN32

public i02_L_1_
i02_L_1_:
#ifdef TSC_PROFILING	
		call		i02tsc_before_
#endif
		GETARG          edi+12,edi+8,edx
                GETREGVAL       ecx,edi+16,ebx
                add             ecx,edx
                SETFLAGS        IMSK_XNZVC,MCLR_XNZVC,MSET_XNZVC
                SETREGVALHREG   ecx,edi+16,ebx
                mov             eax,dword ptr [edi+20]
#ifdef TSC_PROFILING
		call		i02tsc_after_
#endif
		ret

                ALIGN32

public i02_B_2_
i02_B_2_:
#ifdef TSC_PROFILING
		call		i02tsc_before_
#endif
	        GETARG          edi+12,edi+8,edx
                GETREGVAL       ecx,edi+16,eax
                add             dl,cl
                SETFLAGS        IMSK_XNZVC,MCLR_XNZVC,MSET_XNZVC
                SETARG          edi+24,edi+8,edx
                mov             eax,dword ptr [edi+20]
#ifdef TSC_PROFILING
		call		i02tsc_after_
#endif
		ret

                ALIGN32

public i02_W_2_
i02_W_2_:
#ifdef TSC_PROFILING
		call		i02tsc_before_
#endif
	        GETARG          edi+12,edi+8,edx
                GETREGVAL       ecx,edi+16,eax
                add             dx,cx
                SETFLAGS        IMSK_XNZVC,MCLR_XNZVC,MSET_XNZVC
                SETARG          edi+24,edi+8,edx
                mov             eax,dword ptr [edi+20]
#ifdef TSC_PROFILING
		call		i02tsc_after_
#endif
		ret

                ALIGN32

public i02_L_2_
i02_L_2_:
#ifdef TSC_PROFILING
		call		i02tsc_before_
#endif
	        GETARG          edi+12,edi+8,edx
                GETREGVAL       ecx,edi+16,eax
                add             edx,ecx
                SETFLAGS        IMSK_XNZVC,MCLR_XNZVC,MSET_XNZVC
                SETARG          edi+24,edi+8,edx
                mov             eax,dword ptr [edi+20]
#ifdef TSC_PROFILING
		call		i02tsc_after_
#endif
		ret

;
; ADDA.W/L <ea>,An
; Flags:  NONE
;

                ALIGN32

public i03_W_
i03_W_:         GETARG          edi+12,edi+8,edx
                GETREGVAL       ecx,edi+16,ebx
                movsx           edx,dx
                add             ecx,edx
                SETREGVALHREG   ecx,edi+16,ebx
                mov             eax,dword ptr [edi+20]
                ret

                ALIGN32

public i03_L_
i03_L_:         GETARG          edi+12,edi+8,edx
                GETREGVAL       ecx,edi+16,ebx
                add             ecx,edx
                SETREGVALHREG   ecx,edi+16,ebx
                mov             eax,dword ptr [edi+20]
                ret

;
; ADDI.X #,<ea>
; Flags: ALL,verified OK
;

                ALIGN32

public i04_B_
i04_B_:		mov	ecx, esi
		fetchwopcode_inc_pos
		add	esi, 2
		mov	ebx, edx
		mov	eax, dword ptr [edi + 12]
		mov	edx, dword ptr [edi + 8]
		call	eax
		add	dl, bl
		pushfd
		pop	eax
		and	eax, 0fffh
		mov	eax, dword ptr [_statustab + 4*eax]
		mov	ecx, dword ptr [edi + 20]
		mov	byte ptr [_sr], al
		mov	ebx, dword ptr [edi + 8]
		call	ecx
		mov	eax, dword ptr [edi + 16]
		ret


                ALIGN32

public i04_w_
i04_W_:
        mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	add     dx,bx
	pushfd
	pop     eax
	and     eax,0fffh
	mov     eax,dword ptr [_statustab+4*eax]
	mov     ecx,dword ptr [edi+20]
	mov     byte ptr _sr,al
	mov     ebx,dword ptr [edi+8]
	call    ecx
	mov     eax,dword ptr [edi+16]
	ret

                ALIGN32

public i04_L_
i04_L_:
        mov     ecx,esi
        fetchlopcode_inc_pos
	add     esi,4
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	add     edx,ebx
	pushfd
	pop     eax
	and     eax,0fffh
	mov     eax,dword ptr [_statustab+4*eax]
	mov     ecx,dword ptr [edi+20]
	mov     byte ptr _sr,al
	mov     ebx,dword ptr [edi+8]
	call    ecx
	mov     eax,dword ptr [edi+16]
	ret

;
; ADDQ.X #,<ea>
;  0-rutinepeker 1-disasm rutine  2-eareg 3-ea les rutine
;                4-cycle count    5-ea write rutine 6-add immediate              
; Flags: ALL
;

                ALIGN32

public i05_B_
i05_B_:         mov     eax,dword ptr [edi+12]
                mov     edx,dword ptr [edi+8]
                call    eax
                mov     ebx,dword ptr [edi+24]
                add     dl,bl
                pushfd
                pop     eax
                and     eax,0fffh
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ecx,dword ptr [edi+20]
                mov     byte ptr _sr,al      
                mov     ebx,dword ptr [edi+8]
                call    ecx                    
                mov     eax,dword ptr [edi+16] 
                ret                            


                ALIGN32

public i05_W_
i05_W_:         mov     eax,dword ptr [edi+12]
                mov     edx,dword ptr [edi+8] 
                call    eax                   
                mov     ebx,dword ptr [edi+24]
                add     dx,bx                   
                pushfd                          
                pop     eax                     
                and     eax,0fffh               
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ecx,dword ptr [edi+20]
                mov     byte ptr _sr,al       
                mov     ebx,dword ptr [edi+8]
                call    ecx                   
                mov     eax,dword ptr [edi+16]
                ret


                ALIGN32

public i05_L_
i05_L_:         mov     eax,dword ptr [edi+12]
                mov     edx,dword ptr [edi+8] 
                call    eax                   
                mov     ebx,dword ptr [edi+24]
                add     edx,ebx                 
                pushfd                          
                pop     eax                     
                and     eax,0fffh               
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ecx,dword ptr [edi+20]
                mov     byte ptr _sr,al       
                mov     ebx,dword ptr [edi+8]
                call    ecx                   
                mov     eax,dword ptr [edi+16]
                ret


                ALIGN32

public i05_ADR_
i05_ADR_:       mov     eax,dword ptr [edi+8] 
                mov     edx,dword ptr [eax]
                mov     ebx,dword ptr [edi+24]
                add     edx,ebx               
                mov     dword ptr [eax],edx
                mov     eax,dword ptr [edi+16]
                ret

;
; Instruction 6   ADDX.X Dy,Dx    ADDX.X -(Ay),-(Ax)
; Tableusage  2 - rx*4(dest)  3 - ry*4
; Opcode*32 i edi
; Flags: ALL, Z unchanged if result is non-zero
;


                ALIGN32

public i06_B_1_
i06_B_1_:       mov     ebx,dword ptr [12+edi]          ; Source
                mov     ecx,dword ptr [8+edi]           ; Dest
                mov     eax,dword ptr [ebx]             
                mov     ebx,dword ptr [ecx]             
                mov     edx,dword ptr _sr
                test    dl,10h
                jz      i06b1nc
                stc     
i06b1nc:        adc     bl,al
                pushfd                                  ; Flags  
                pop     eax                             
                and     eax,0fbfh                       ; No Z                       
                mov     dword ptr [ecx],ebx             
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ah,byte ptr [_sr]
                and     ah,4                            ; Preserve Z
                test    bl,bl                           ; Clear if nonzero
                jz      i06b1nz
                xor     ah,ah
i06b1nz:        or      al,ah
                mov     byte ptr [_sr],al
                mov     eax,4
                ret


                ALIGN32

public i06_W_1_
i06_W_1_:       mov     ebx,dword ptr [12+edi]          ; Source
                mov     ecx,dword ptr [8+edi]           ; Dest
                mov     eax,dword ptr [ebx]
                mov     ebx,dword ptr [ecx]
                mov     edx,dword ptr _sr
                test    dl,10h
                jz      i06w1nc
                stc     
i06w1nc: 	adc     bx,ax
                pushfd                                
                pop     eax                           
                and     eax,0fbfh                     
                mov     dword ptr [ecx],ebx           
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ah,byte ptr [_sr]
                and     ah,4                            ; Preserve Z
                test    bx,bx                           ; Clear if nonzero
                jz      i06w1nz
                xor     ah,ah
i06w1nz:        or      al,ah
                mov     byte ptr _sr,al               
                mov     eax,4
                ret


                ALIGN32

public i06_L_1_
i06_L_1_:       mov     ebx,dword ptr [12+edi]          ; Source
                mov     ecx,dword ptr [8+edi]           ; Dest
                mov     eax,dword ptr [ebx]             
                mov     ebx,dword ptr [ecx]             
                mov     edx,dword ptr _sr
                test    dl,10h
                jz      i06l1nc
                stc     
i06l1nc:   	adc     ebx,eax
                pushfd                           
                pop     eax                      
                and     eax,0fbfh                
                mov     dword ptr [ecx],ebx      
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ah,byte ptr [_sr]
                and     ah,4                            ; Preserve Z
                test    ebx,ebx                         ; Clear if nonzero
                jz      i06l1nz
                xor     ah,ah
i06l1nz:        or      al,ah
                mov     byte ptr _sr,al                 
                mov     eax,8
                ret


                ALIGN32

public i06_B_2_
i06_B_2_:       mov     ebx,dword ptr [12+edi]          ; Source 
                mov     ecx,dword ptr [ebx]
                dec     ecx
                cmp     ebx,dword ptr [_a7pointer]
                jne     i06_B_2j
                dec     ecx
i06_B_2j:       mov     dword ptr [ebx],ecx
                fetchb
                mov     ebx,edx
                mov     eax,dword ptr [8+edi]           ; Dest
                mov     ecx,dword ptr [eax]
                dec     ecx
                cmp     eax,dword ptr [_a7pointer]
                jne     i06_B_2i
                dec     ecx
i06_B_2i:       mov     dword ptr [eax],ecx
                mov     ebp,ecx                         ; Save <ea> for later use
                fetchb
                mov     eax,dword ptr _sr
                test    al,10h
                jz      i06b2nc
                stc     
i06b2nc:        adc     dl,bl
                pushfd
                pop     eax
                and     eax,0fbfh
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ah,byte ptr [_sr]
                and     ah,4                            ; Preserve Z
                test    dl,dl                           ; Clear if nonzero
                jz      i06b2nz
                xor     ah,ah
i06b2nz:        or      al,ah
                mov     byte ptr _sr,al                 
                mov     ecx,ebp                         ; restore saved <ea>
                writeb
                mov     eax,18
                ret


                ALIGN32

public i06_W_2_
i06_W_2_:       mov     ebx,dword ptr [12+edi]          ; Source 
                mov     ecx,dword ptr [ebx]
                sub     ecx,2
                mov     dword ptr [ebx],ecx
                fetchw
                mov     ebx,edx
                mov     eax,dword ptr [8+edi]           ; Dest
                mov     ecx,dword ptr [eax]
                sub     ecx,2
                mov     dword ptr [eax],ecx
                mov     ebp,ecx                         ; Save <ea> for later use
                fetchw
                mov     eax,dword ptr _sr
                test    al,10h
                jz      i06w2nc
                stc     
i06w2nc:        adc     dx,bx
                pushfd                                  
                pop     eax                             
                and     eax,0fbfh                       
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ah,byte ptr [_sr]
                and     ah,4                            ; Preserve Z
                test    dx,dx                           ; Clear if nonzero
                jz      i06w2nz
                xor     ah,ah
i06w2nz:        or      al,ah
                mov     byte ptr _sr,al             
                mov     ecx,ebp                         ; restore saved <ea>
                writew
                mov     eax,18
                ret


                ALIGN32

public i06_L_2_
i06_L_2_:       mov     ebx,dword ptr [12+edi]          ; Source 
                mov     ecx,dword ptr [ebx]
                sub     ecx,4
                mov     dword ptr [ebx],ecx
                fetchl
                mov     ebx,edx
                mov     eax,dword ptr [8+edi]           ; Dest
                mov     ecx,dword ptr [eax]
                sub     ecx,4
                mov     dword ptr [eax],ecx
                mov     ebp,ecx                         ; Save <ea> for later use
                fetchl
                mov     al,byte ptr _sr
                test    al,10h
                jz      i06l2nc
                stc     
i06l2nc:        adc     edx,ebx
                pushfd
                pop     eax
                and     eax,0fbfh 
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ah,byte ptr [_sr]
                and     ah,4                            ; Preserve Z
                test    edx,edx                         ; Clear if nonzero
                jz      i06l2nz
                xor     ah,ah
i06l2nz:        or      al,ah
                mov     byte ptr _sr,al                 
                mov     ecx,ebp                         ; restore saved <ea>
                writel
                mov     eax,30
                ret


;
; AND.X <ea>,Dn / AND.X Dn,<ea>
; Flags: X unaffected, N Z, V = C = 0, verfied OK
;


                ALIGN32

i07_B_1_:
	mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	mov     ebx,dword ptr [edi+16]
	mov     ecx,dword ptr [ebx]
	and     cl,dl
	pushfd
	pop     eax
	and     eax,07feh
	mov     dword ptr [ebx],ecx
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     dword ptr _sr,eax
	mov     eax,dword ptr [edi+20]
	ret


                ALIGN32

i07_W_1_:
	mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	mov     ebx,dword ptr [edi+16]
	mov     ecx,dword ptr [ebx]
	and     cx,dx
	pushfd
	pop     eax
	and     eax,07feh
	mov     dword ptr [ebx],ecx
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     dword ptr _sr,eax
	mov     eax,dword ptr [edi+20]
	ret


                ALIGN32

i07_L_1_:
	mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	mov     ebx,dword ptr [edi+16]
	mov     ecx,dword ptr [ebx]
	and     ecx,edx
	pushfd
	pop     eax
	and     eax,07feh
	mov     dword ptr [ebx],ecx
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     dword ptr _sr,eax
	mov     eax,dword ptr [edi+20]
	ret


                ALIGN32

i07_B_2_:
	mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	mov     ebx,dword ptr [edi+16]
	mov     ecx,dword ptr [ebx]
	and     dl,cl
	pushfd
	pop     eax
	and     eax,07feh
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     ecx,dword ptr [edi+24]
	mov     dword ptr _sr,eax
	mov     ebx,dword ptr [edi+8]
	call    ecx
	mov     eax,dword ptr [edi+20]
	ret


                ALIGN32

i07_W_2_:
	mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	mov     ebx,dword ptr [edi+16]
	mov     ecx,dword ptr [ebx]
	and     dx,cx
	pushfd
	pop     eax
	and     eax,07feh
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     ecx,dword ptr [edi+24]
	mov     dword ptr _sr,eax
	mov     ebx,dword ptr [edi+8]
	call    ecx
	mov     eax,dword ptr [edi+20]
	ret


                ALIGN32

i07_L_2_:
	mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	mov     ebx,dword ptr [edi+16]
	mov     ecx,dword ptr [ebx]
	and     edx,ecx
	pushfd
	pop     eax
	and     eax,07feh
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     ecx,dword ptr [edi+24]
	mov     dword ptr _sr,eax
	mov     ebx,dword ptr [edi+8]
	call    ecx
	mov     eax,dword ptr [edi+20]
	ret

;
; ANDI.X #,<ea>
; Flagg: X unaffected, N Z, V = C = 0, verfied OK
;


                ALIGN32

i08_B_: mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	and     dl,bl
	pushfd
	pop     eax
	and     eax,07feh
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     ecx,dword ptr [edi+20]
	mov     dword ptr _sr,eax
	mov     ebx,dword ptr [edi+8]
	call    ecx
	mov     eax,dword ptr [edi+16]
	ret


                ALIGN32

i08_W_:
        mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	and     dx,bx
	pushfd
	pop     eax
	and     eax,07feh
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     ecx,dword ptr [edi+20]
	mov     dword ptr _sr,eax
	mov     ebx,dword ptr [edi+8]
	call    ecx
	mov     eax,dword ptr [edi+16]
	ret


                ALIGN32

i08_L_:
        mov     ecx,esi
        fetchlopcode_inc_pos
	add     esi,4
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	and     edx,ebx
	pushfd
	pop     eax
	and     eax,07feh
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     ecx,dword ptr [edi+20]
	mov     dword ptr _sr,eax
	mov     ebx,dword ptr [edi+8]
	call    ecx
	mov     eax,dword ptr [edi+16]
	ret


                ALIGN32

i08_B_CCR_:
	mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     eax,dword ptr _sr
	and     al,dl
	mov     dword ptr _sr,eax
	mov     eax,20
	ret


                ALIGN32

i08_W_SR_:
        test    byte ptr _sr+1,020h
        jz      privilegie_violation
	mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     eax,dword ptr _sr
	and     eax,edx
	mov     edx,eax
	call    updateSR
	mov     eax,20
	ret

;
; ASX.X
; Tableusage:(imm) 0-rut 1-disrut 2-shcount 3-dreg 4-cyclecount
; Tableusage:(reg) 0-rut 1-disrut 2-shcountreg 3-dreg 4-cyclecount
; Tableusage:(mem) 0-rut 1-disrut 2-eareg 3-earead 4-eawrite 5-cyclecount
; Flags: ALL, XC unaffected if shift count is zero, only happens with shiftcount
;         in Dx, V set if sign bit changes, only happes during ASL 
;


                ALIGN32

i09_RI_I_B_:    mov     ecx,dword ptr [edi+8]           ; get shcount
                mov     ebx,dword ptr [edi+12]          ; get dreg ptr
                mov     eax,dword ptr [ebx]             ; get dreg content
                sar     al,cl
                pushfd
                pop     ecx
                and     ecx,07ffh                                       ; Intel, OF undefined or 0
                mov     dword ptr [ebx],eax
                mov     ecx,dword ptr [_statustab+4*ecx]
                mov     byte ptr [_sr],cl
                mov     eax,dword ptr [edi+16]
                ret


                ALIGN32

i09_RI_I_W_:    mov     ecx,dword ptr [edi+8]           ; get shcount
                mov     ebx,dword ptr [edi+12]          ; get dreg ptr
                mov     eax,dword ptr [ebx]             ; get dreg content
                sar     ax,cl
                pushfd
                pop     ecx
                and     ecx,07ffh
                mov     dword ptr [ebx],eax
                mov     ecx,dword ptr [_statustab+4*ecx]
                mov     byte ptr [_sr],cl
                mov     eax,dword ptr [edi+16]
                ret


                ALIGN32

i09_RI_I_L_:    mov     ecx,dword ptr [edi+8]           ; get shcount
                mov     ebx,dword ptr [edi+12]          ; get dreg ptr
                mov     eax,dword ptr [ebx]             ; get dreg content
                sar     eax,cl
                pushfd
                pop     ecx
                and     ecx,07ffh
                mov     dword ptr [ebx],eax
                mov     ecx,dword ptr [_statustab+4*ecx]
                mov     byte ptr [_sr],cl
                mov     eax,dword ptr [edi+16]
                ret


                ALIGN32

i09_RI_R_B_:    mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
                mov     ebx,dword ptr [edi+12]          ; get dreg ptr
                mov     ecx,dword ptr [ecx]             ; get shcount reg content
                mov     eax,dword ptr [ebx]             ; get dreg content
                and     ecx,3fh                         ; modulo 64
                jz      i09rirbz
                sar     al,cl
                pushfd
                mov     dword ptr [ebx],eax
                mov     edx,ecx
                add     edx,edx                         ; Calculate cyclecount
                pop     ecx
                and     ecx,07ffh
                mov     eax,dword ptr [_statustab+4*ecx]
                mov     byte ptr _sr,al
                mov     eax,dword ptr [edi+16]
                add     eax,edx
                ret
i09rirbz:       test    al,al
                pushfd
                pop     ebx
                and     ebx,0c0h                        ; We want sign and zero
                shr     ebx,4
                mov     bh,byte ptr [_sr]
                and     bh,010h                         ; preserve X
                or      bh,bl
                mov     byte ptr [_sr],bh
                mov     eax,dword ptr [edi+16]
                ret


                ALIGN32

i09_RI_R_W_:    mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
                mov     ebx,dword ptr [edi+12]          ; get dreg ptr
                mov     ecx,dword ptr [ecx]             ; get shcount reg content
                mov     eax,dword ptr [ebx]             ; get dreg content
                and     ecx,3fh                         ; modulo 64
                jz      i09rirwz
                sar     ax,cl
                pushfd
                mov     dword ptr [ebx],eax
                mov     edx,ecx
                add     edx,edx                         ; Calculate cyclecount
                pop     ecx
                and     ecx,07ffh
                mov     eax,dword ptr [_statustab+4*ecx]
                mov     byte ptr [_sr],al
                mov     eax,dword ptr [edi+16]
                add     eax,edx
                ret
i09rirwz:       test    ax,ax
                pushfd
                pop     ebx
                and     ebx,0c0h                ; We want sign and zero
                shr     ebx,4
                mov     bh,byte ptr [_sr]
                and     bh,010h         ; preserve XC
                or      bh,bl
                mov     byte ptr [_sr],bh
                mov     eax,dword ptr [edi+16]
                ret


                ALIGN32

i09_RI_R_L_:    mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
                mov     ebx,dword ptr [edi+12]          ; get dreg ptr
                mov     ecx,dword ptr [ecx]             ; get shcount reg content
                mov     eax,dword ptr [ebx]             ; get dreg content
                and     ecx,3fh                         ; modulo 64
                jz      i09rirlz
                cmp     ecx,32
                jb      i09rirlok
                je      i09rirlc32
                sar     eax,31
                sar     eax,2
                jmp     i09rirlnok
i09rirlc32:     sar     eax,31
                sar     eax,1
                jmp     i09rirlnok
i09rirlok:      sar     eax,cl
i09rirlnok:     pushfd
                mov     dword ptr [ebx],eax
                mov     edx,ecx
                add     edx,edx                         ; Calculate cyclecount
                pop     ecx
                and     ecx,07ffh
                mov     eax,dword ptr [_statustab+4*ecx]
                mov     byte ptr [_sr],al
                mov     eax,dword ptr [edi+16]
                add     eax,edx
                ret
i09rirlz:       test    eax,eax
                pushfd
                pop     ebx
                and     ebx,0c0h                ; We want sign and zero
                shr     ebx,4
                mov     bh,byte ptr [_sr]
                and     bh,010h         ; preserve XC
                or      bh,bl
                mov     byte ptr [_sr],bh
                mov     eax,dword ptr [edi+16]
                ret


                ALIGN32

i09_LE_I_B_:    mov     ebx,dword ptr [edi+12]          ; get dreg ptr
                mov     ecx,dword ptr [edi+8]           ; get shcount
                mov     eax,dword ptr [ebx]             ; get dreg content
                movsx   eax,al

                mov     edx,eax
                sal     dl,cl
                pushfd
                sal     ax,cl
                pop     ecx
                and     ecx,07ffh
                mov     byte ptr [ebx],al
                mov     bl,byte ptr [_statustab+ecx]

; New
                mov     ecx,eax
                and     ecx,8080h
                cmp     ch,cl
                je      i09leibnb
                or      bl,2h
i09leibnb:      or      ah,ah
                jz      i09leibna
                xor     ah,-1
                jz      i09leibna
                or      bl,2h
i09leibna:
	
; New end

                mov     byte ptr _sr,bl
                mov     eax,dword ptr [edi+16]
                ret


                ALIGN32

i09_LE_I_W_:
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [edi+8]           ; get shcount
	mov     ax,word ptr [ebx]             ; get dreg content

	movsx   eax,ax
	mov     edx,eax
	sal     dx,cl
	pushfd
	sal     eax,cl
	pop     ecx
	and     ecx,07ffh
	mov     word ptr [ebx],ax

	mov     ebx,dword ptr [_statustab+4*ecx]


; New
	mov     ecx,eax
	and     ecx,80008000h
	mov     edx,ecx
	shr     edx,16
	cmp     dx,cx
	je      i09leiwnb
	or      bl,2h
i09leiwnb:
	and     eax,0ffff0000h
	jz      i09leibna
	cmp     eax,0ffff0000h
	je      i09leiwna
	or      bl,2h
i09leiwna:
	
; New end



	mov     eax,dword ptr [edi+16]

	mov     byte ptr _sr,bl
	ret


                ALIGN32

i09_LE_I_L_:
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     eax,dword ptr [ebx]             ; get dreg content
	
	mov     edx,-1                          ; Create mask
	mov     ecx,31                          ; edx is zero if sign change 
	sub     ecx,dword ptr [edi+8]
	shl     edx,cl
	mov     ebp,eax
	and     ebp,edx
	jnz     i09leilns
	xor     ebp,edx
	jnz     i09leilns
	xor     edx,edx
i09leilns:

	mov     ecx,dword ptr [edi+8]           ; get shcount


	sal     eax,cl
	pushfd
	pop     ecx
	and     ecx,07ffh
	mov     dword ptr [ebx],eax
	mov     ebx,dword ptr [_statustab+4*ecx]


; New
	or      edx,edx
	jnz     i09leilnb
	or      bl,2h
i09leilnb:
	
; New end

	mov     eax,dword ptr [edi+16]
	mov     byte ptr _sr,bl
	ret


                ALIGN32

i09_LE_R_B_:
	mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [ecx]             ; get shcount reg content
	and     ecx,3fh                         ; modulo 64
	jz      i09lerbz
	mov     eax,dword ptr [ebx]             ; get dreg content
	cmp     ecx,8
	jae     i09lerbtoobig

	movsx   eax,al
	mov     edx,eax
	sal     dl,cl
	pushfd
	sal     ax,cl
	mov     byte ptr [ebx],al
	mov     ebp,ecx
        add     ebp,ebp                         ; Calculate cyclecount
	pop     ecx
	and     ecx,07ffh
	mov     ebx,dword ptr [_statustab+4*ecx]
; New
	mov     ecx,eax
	and     ecx,8080h
	cmp     ch,cl
	je      i09lerbnb
	or      bl,2h
i09lerbnb:
	or      ah,ah
	jz      i09lerbna
	cmp     ah,-1
	je      i09lerbna
	or      bl,2h
i09lerbna:
	
; New end
	mov     byte ptr _sr,bl
	mov     eax,dword ptr [edi+16]
	add     eax,ebp
	ret
i09lerbz:
	or      al,al
	pushfd
	pop     ebx
	and     ebx,0c0h                ; We want sign and zero
	shr     ebx,4
	mov     bh,byte ptr _sr
        and     bh,010h         ; preserve XC
	or      bh,bl


	mov     byte ptr _sr,bh
	mov     eax,dword ptr [edi+16]
	ret
; here, set zero as result, Set Z flag, if count == size then
; set xc to sign bit and set V flag if original isnt zero 
i09lerbtoobig:
	mov     byte ptr [ebx],0
	mov     bl,4h
	or      al,al
	jz      i09lerbtbz
	or      bl,2
i09lerbtbz:
	cmp     cl,8
	jne     i09lerbtbs
	test    al,80h
	jns     i09lerbtbs
	or      bl,11h
i09lerbtbs:
	mov     byte ptr _sr,bl
	mov     edx,ecx
        add     edx,edx                         ; Calculate cyclecount
	mov     eax,dword ptr [edi+16]
	add     eax,edx
	ret     


                ALIGN32

i09_LE_R_W_:
	mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [ecx]             ; get shcount reg content
	and     ecx,3fh                         ; modulo 64
	jz      i09lerwz
	mov     eax,dword ptr [ebx]             ; get dreg content
	cmp     ecx,16
	jae     i09lerwtoobig
	movsx   eax,ax
	mov     edx,eax
	sal     dx,cl
	pushfd
	sal     eax,cl
	mov     word ptr [ebx],ax
	mov     ebp,ecx
        add     ebp,ebp                         ; Calculate cyclecount
	pop     ecx
	and     ecx,07ffh
	mov     ebx,dword ptr [_statustab+4*ecx]
; New
	mov     ecx,eax
	and     ecx,80008000h
	mov     edx,ecx
	shr     edx,16
	cmp     dx,cx
	je      i09lerwnb
	or      bl,2h
i09lerwnb:
	and     eax,0ffff0000h
	jz      i09lerwna
	cmp     eax,0ffff0000h
	je      i09lerwna
	or      bl,2h
i09lerwna:
	
; New end
	
	mov     byte ptr _sr,bl
	mov     eax,dword ptr [edi+16]
	add     eax,ebp
	ret
i09lerwz:
	or      ax,ax
	pushfd
	pop     ebx
	and     ebx,0c0h                ; We want sign and zero
	shr     ebx,4
	mov     bh,byte ptr _sr
        and     bh,010h         ; preserve XC
	or      bh,bl
	mov     byte ptr _sr,bh
	mov     eax,dword ptr [edi+16]
	ret

; here, set zero as result, Set Z flag, if count == size then
; set xc to sign bit and set V flag if original isnt zero 
i09lerwtoobig:
	mov     word ptr [ebx],0
	mov     bl,4h
	or      al,al
	jz      i09lerwtbz
	or      bl,2
i09lerwtbz:
	cmp     cl,16
	jne     i09lerwtbs
        test    ah,80h
	jns     i09lerwtbs
	or      bl,11h
i09lerwtbs:
	mov     byte ptr _sr,bl
	mov     edx,ecx
        add     edx,edx                         ; Calculate cyclecount
	mov     eax,dword ptr [edi+16]
	add     eax,edx
	ret     


                ALIGN32

i09_LE_R_L_:
	mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
	mov     ecx,dword ptr [ecx]             ; get shcount reg content
	and     ecx,3fh                         ; modulo 64
	jz      i09lerlz
	mov     eax,dword ptr [ebx]             ; get dreg content
	cmp     ecx,32
	jae     i09lerltoobig

	push    ecx
	mov     ebp,ecx
	mov     edx,-1                          ; Create mask
	mov     ecx,31                          ; edx is zero if sign change 
	sub     ecx,ebp
	shl     edx,cl
	mov     ebp,eax
	and     ebp,edx
	jnz     i09lerlns
	xor     ebp,edx
	jnz     i09lerlns
	xor     edx,edx
i09lerlns:
	pop     ecx
	sal     eax,cl
	pushfd
	mov     dword ptr [ebx],eax
	mov     ebp,ecx
        add     ebp,ebp                         ; Calculate cyclecount
	pop     ecx
	and     ecx,07ffh
	mov     ebx,dword ptr [_statustab+4*ecx]
; New
	or      edx,edx
	jnz     i09lerlnb
	or      bl,2h
i09lerlnb:
	
; New end
	mov     byte ptr _sr,bl
	mov     eax,dword ptr [edi+16]
	add     eax,ebp
	ret
i09lerlz:
	or      eax,eax
	pushfd
	pop     ebx
	and     ebx,0c0h                ; We want sign and zero
	shr     ebx,4
	mov     bh,byte ptr _sr
        and     bh,010h         ; preserve XC
	or      bh,bl
	mov     byte ptr _sr,bh
	mov     eax,dword ptr [edi+16]
	ret
; here, set zero as result, Set Z flag, if count == size then
; set xc to sign bit and set V flag if original isnt zero 
i09lerltoobig:
	mov     dword ptr [ebx],0
	mov     bl,4h
	or      al,al
	jz      i09lerltbz
	or      bl,2
i09lerltbz:
	cmp     cl,32
	jne     i09lerltbs
        test    eax,eax           ;80000000h
	jns     i09lerltbs
	or      bl,11h
i09lerltbs:
	mov     byte ptr _sr,bl
	mov     edx,ecx
        add     edx,edx                         ; Calculate cyclecount
	mov     eax,dword ptr [edi+16]
	add     eax,edx
	ret     

; Here, shift count always 1.  Things to care about:
; 1. Sign change during shift, done in hardware when count is 1


                ALIGN32

i09_RI_M_W_:
	mov     ebx,dword ptr [edi+8]           ; get ea reg ptr
	mov     edx,ebx
	mov     eax,dword ptr [edi+12]          ; get ea read rut
	call    eax
	sar     dx,1
	pushfd
	pop     ecx
	and     ecx,0fffh               ; Overflow defined here!
	mov     eax,dword ptr [edi+16]          ; get dest rut ptr.
	mov     ecx,dword ptr [_statustab+4*ecx]
	mov     byte ptr _sr,cl
	call    eax     
	mov     eax,dword ptr [edi+20]
	ret


                ALIGN32

i09_LE_M_W_:
	mov     ebx,dword ptr [edi+8]           ; get ea reg ptr
	mov     edx,ebx
	mov     eax,dword ptr [edi+12]          ; get ea read rut
	call    eax
	sal     dx,1
	pushfd
	pop     ecx
	and     ecx,0fffh               ; OF defined here
	mov     eax,dword ptr [edi+16]          ; get dest rut ptr.
	mov     ecx,dword ptr [_statustab+4*ecx]
	mov     byte ptr _sr,cl
	call    eax     
	mov     eax,dword ptr [edi+20]
	ret


;
; Bcc
; Tableusage 0- routine 1 - displacement(32bit)  2-condition evaluate routine
;


		ALIGN32

public  i11_B_
i11_B_:		mov	eax, dword ptr [edi + 8]
		call	eax				; edx = 1 take branch
		test	dl, dl
		jz	i11bnob
		mov	ebx, dword ptr [edi + 4]	; get disp
		test	bl, 1
		jnz	i11ex
		add	esi, ebx			; New PC
#ifdef PREFETCH
		mov	edx, esi
		call	prefetch_fill_
#endif
		mov	eax, 8
		ret
i11bnob:	mov	eax, 10
		ret
i11ex:		mov	ebx, 0ch			; Jump to odd address
		mov	eax, 44				; Raise exception
		jmp	prepare_exception_


		ALIGN32

public i11_W_
i11_W_:		mov	eax, dword ptr [edi + 8]
		call	eax				; edx != 0 take branch
		test	dl, dl
		jz	i11wnob
		mov	ecx, esi
		fetchwopcode_inc_pos
		movsx	ebx, dx
		test	dl, 1
		jnz	i11ex
		mov	eax, 12
		add	esi, ebx
#ifdef PREFETCH
		mov	edx, esi
		call	prefetch_fill_
#endif
		ret
i11wnob:
#ifdef PREFETCH
		mov	ecx,esi
		fetchwopcode_inc_pos
#endif
		add	esi, 2
		mov	eax, 10
		ret
        

		ALIGN32

public i11_L_
i11_L_:		CPU_LOG	0
		mov	eax, dword ptr [edi + 8]
		call	eax				; edx != 0 take branch
		test	dl, dl
		jz	i11lnob
		mov	ecx, esi
		fetchlopcode_inc_pos
		test	dl, 1
		jnz	i11ex
		mov	eax, 12
		add	esi, edx
#ifdef PREFETCH
		mov	edx, esi
		call	prefetch_fill_
#endif
		ret
i11lnob:
#ifdef PREFETCH
		mov	ecx, esi
		fetchlopcode_inc_pos
#endif
		add	esi, 4
		mov	eax, 10
		ret
        

;
; BCHG.B Dn,<ea>
; Tableusage dynamic:
; 2 - eareg 3-earead 4-reg 5-cycle count 6-eawrite
; Tableusage static:
; 2 - eareg 3-earead 4-cycle count 5-eawrite
; Flag: Z - state of the bit before the operation
;


                ALIGN32

i12_D_L_:
#ifdef TSC_PROFILING	
		call		i12tsc_before_
#endif
		mov	eax,dword ptr [edi + 8]
		mov	ecx,dword ptr [edi + 16]
		mov	ebx,dword ptr [eax]
		mov	edx,dword ptr [ecx]
		mov	ecx,dword ptr [_sr]
		and	ecx,0fffffffbh
		and	edx,1fh
		btc	ebx,edx
		jc	i12dl1
		or	ecx,4
i12dl1:		mov	dword ptr [_sr],ecx
		mov	dword ptr [eax],ebx
		mov	eax,dword ptr [edi + 20]
#ifdef TSC_PROFILING	
		call		i12tsc_after_
#endif
		ret


                ALIGN32

i12_D_B_:
#ifdef TSC_PROFILING	
		call		i12tsc_before_
#endif
		mov	eax,dword ptr [edi + 12]
		mov	edx,dword ptr [edi + 8]
		call	eax
		mov	eax,dword ptr [edi + 16]
		mov	eax,dword ptr [eax]
		mov	ecx,dword ptr [_sr]
		and	ecx,0fffffffbh
		and	eax,7
		btc	edx,eax
		jc	i12db1
		or	ecx,4
i12db1:		mov	dword ptr [_sr],ecx
		mov	ebx,dword ptr [edi + 8]
		mov	eax,dword ptr [edi + 24]
		call	eax
		mov	eax,dword ptr [edi + 20]
#ifdef TSC_PROFILING	
		call		i12tsc_after_
#endif
		ret


                ALIGN32

i12_S_L_:
#ifdef TSC_PROFILING	
		call		i12tsc_before_
#endif
		mov	ecx,esi
		fetchwopcode_inc_pos
		add	esi,2
		mov	eax,dword ptr [edi + 8]
		mov	ebx,dword ptr [eax]
		mov	ecx,dword ptr [_sr]
		and	ecx,0fffffffbh
		and	edx,1fh
		btc	ebx,edx
		jc	i12sl1
		or	ecx,4
i12sl1:		mov	dword ptr [_sr],ecx
		mov	dword ptr [eax],ebx
		mov	eax,dword ptr [edi + 16]
#ifdef TSC_PROFILING	
		call		i12tsc_after_
#endif
		ret


                ALIGN32

i12_S_B_:
#ifdef TSC_PROFILING	
		call		i12tsc_before_
#endif
		mov	ecx,esi
		fetchwopcode_inc_pos
		add	esi,2
		mov	ebx,edx
		mov	eax,dword ptr [edi + 12]
		mov	edx,dword ptr [edi + 8]
		call	eax
		mov	ecx,dword ptr [_sr]
		and	ecx,0fffffffbh
		and	ebx,7
		btc	edx,ebx
		jc	i12sb1
		or	ecx,4
i12sb1:		mov	dword ptr [_sr],ecx
		mov	ebx,dword ptr [edi + 8]
		mov	eax,dword ptr [edi + 20]
		call	eax
		mov	eax,dword ptr [edi + 16]
#ifdef TSC_PROFILING	
		call		i12tsc_after_
#endif
		ret


;
; BCLR.B Dn,<ea>
; Tableusage dynamic:
; 2 - eareg 3-earead 4-reg 5-cycle count 6-eawrite
; Tableusage static:
; 2 - eareg 3-earead 4-cycle count 5-eawrite
; Flag:	Z - state of the bit before the operation
;


                ALIGN32

i13_D_L_:
#ifdef TSC_PROFILING	
		call		i12tsc_before_
#endif
		mov	eax,dword ptr [edi + 8]
		mov	ecx,dword ptr [edi + 16]
		mov	ebx,dword ptr [eax]
		mov	edx,dword ptr [ecx]
		mov	ecx,dword ptr [_sr]
		and	ecx,0fffffffbh
		and	edx,1fh
		btr	ebx,edx
		jc	i13dl1
		or	ecx,4
i13dl1:		mov	dword ptr [_sr],ecx
		mov	dword ptr [eax],ebx
		mov	eax,dword ptr [edi + 20]
#ifdef TSC_PROFILING	
		call		i12tsc_after_
#endif
		ret


                ALIGN32

i13_D_B_:
#ifdef TSC_PROFILING	
		call		i12tsc_before_
#endif
		mov	eax,dword ptr [edi + 12]
		mov	edx,dword ptr [edi + 8]
		call	eax
		mov	eax,dword ptr [edi + 16]
		mov	eax,dword ptr [eax]
		mov	ecx,dword ptr [_sr]
		and	ecx,0fffffffbh
		and	eax,7
		btr	edx,eax
		jc	i13db1
		or	ecx,4
i13db1:		mov	dword ptr [_sr],ecx
		mov	ebx,dword ptr [edi + 8]
		mov	eax,dword ptr [edi + 24]
		call	eax
		mov	eax,dword ptr [edi + 20]
#ifdef TSC_PROFILING	
		call		i12tsc_after_
#endif
		ret


                ALIGN32

i13_S_L_:
#ifdef TSC_PROFILING	
		call		i12tsc_before_
#endif
		mov	ecx,esi                  ; get bit number
		fetchwopcode_inc_pos
		add	esi,2
		mov	eax,dword ptr [edi + 8]  ; get register pointer
		mov	ebx,dword ptr [eax]      ; get register content
		mov	ecx,dword ptr [_sr]
		and	ecx,0fffffffbh
		and	edx,1fh                  ; modulo 32
		btr	ebx,edx
		jc	i13sl1
		or	ecx,4
i13sl1:		mov	dword ptr [_sr],ecx
		mov	dword ptr [eax],ebx
		mov	eax,dword ptr [edi + 16]
#ifdef TSC_PROFILING	
		call		i12tsc_after_
#endif
		ret


                ALIGN32

i13_S_B_:
#ifdef TSC_PROFILING	
		call		i12tsc_before_
#endif
		mov	ecx,esi                   ; get bit number
		fetchwopcode_inc_pos
		add	esi,2
		mov	ebx,edx
		mov	eax,dword ptr [edi + 12]  ; get ea routine pointer
		mov	edx,dword ptr [edi + 8]   ; get earegister pointer
		call	eax
		mov	ecx,dword ptr [_sr]
		and	ecx,0fffffffbh
		and	ebx,7                     ; modulo 8
		btr	edx,ebx
		jc	i13sb1
		or	ecx,4
i13sb1:		mov	dword ptr [_sr],ecx
		mov	ebx,dword ptr [edi + 8]
		mov	eax,dword ptr [edi + 20]
		call	eax
		mov	eax,dword ptr [edi + 16]
#ifdef TSC_PROFILING	
		call		i12tsc_after_
#endif
		ret


;
; BSET.B Dn,<ea>
; Tableusage dynamic:
; 2 - eareg 3-earead 4-reg 5-cycle count 6-eawrite
; Tableusage static:
; 2 - eareg 3-earead 4-cycle count 5-eawrite
;


                ALIGN32

i15_D_L_:
#ifdef TSC_PROFILING	
		call		i12tsc_before_
#endif
	mov     eax,dword ptr [edi+8]   ; get ea register pointer
	mov     ecx,dword ptr [edi+16]  ; get register with bit number
	mov     ebx,dword ptr [eax]     ; get ea register content
	mov     edx,dword ptr [ecx]     ; get bit number
	mov     ecx,dword ptr _sr
	and     ecx,0fffffffbh
	and     edx,01fh                 ; modulo 32
	bts     ebx,edx
	jc      i15dl1
	or      ecx,4
i15dl1: mov     dword ptr _sr,ecx
	mov     dword ptr [eax],ebx     ; write ea register content
	mov     eax,dword ptr [edi+20]
#ifdef TSC_PROFILING	
		call		i12tsc_after_
#endif
	ret


                ALIGN32

i15_D_B_:
#ifdef TSC_PROFILING	
		call		i12tsc_before_
#endif
	mov     eax,dword ptr [edi+12]  ; get ea routine pointer
	mov     edx,dword ptr [edi+8]   ; get earegister pointer
	call    eax                     ; get ea-content
	mov     eax,dword ptr [edi+16]  ; get bit number register pointer
	mov     eax,dword ptr [eax]     ; get bit number
	mov     ecx,dword ptr _sr
	and     ecx,0fffffffbh
	and     eax,07h                 ; modulo 8
	bts     edx,eax
	jc      i15db1
	or      ecx,4
i15db1: mov     dword ptr _sr,ecx
	mov     ebx,dword ptr [edi+8]
	mov     eax,dword ptr [edi+24]
	call    eax
	mov     eax,dword ptr [edi+20]
#ifdef TSC_PROFILING	
		call		i12tsc_after_
#endif
	ret


                ALIGN32

i15_S_L_:
#ifdef TSC_PROFILING	
		call		i12tsc_before_
#endif
	mov     ecx,esi                 ; get bit number
        fetchwopcode_inc_pos
	add     esi,2
	mov     eax,dword ptr [edi+8]   ; get register pointer
	mov     ebx,dword ptr [eax]     ; get register content
	mov     ecx,dword ptr _sr
	and     ecx,0fffffffbh
	and     edx,01fh                 ; modulo 32
	bts     ebx,edx
	jc      i15sl1
	or      ecx,4
i15sl1: mov     dword ptr _sr,ecx
	mov     dword ptr [eax],ebx
	mov     eax,dword ptr [edi+16]
#ifdef TSC_PROFILING	
		call		i12tsc_after_
#endif
	ret


                ALIGN32

i15_S_B_:
#ifdef TSC_PROFILING	
		call		i12tsc_before_
#endif
	mov     ecx,esi                 ; get bit number
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]  ; get ea routine pointer
	mov     edx,dword ptr [edi+8]   ; get earegister pointer
	call    eax
	mov     ecx,dword ptr _sr
	and     ecx,0fffffffbh
	and     ebx,07h                 ; modulo 8
	bts     edx,ebx
	jc      i15sb1
	or      ecx,4
i15sb1: mov     dword ptr _sr,ecx
	mov     ebx,dword ptr [edi+8]
	mov     eax,dword ptr [edi+20]
	call    eax
	mov     eax,dword ptr [edi+16]
#ifdef TSC_PROFILING	
		call		i12tsc_after_
#endif
	ret


;
; BTST.B Dn,<ea>
; Tableusage dynamic:
; 2 - eareg 3-earead 4-reg 5-cycle count 
; Tableusage static:
; 2 - eareg 3-earead 4-cycle count 
;


                ALIGN32

i17_D_L_:
#ifdef TSC_PROFILING	
		call		i12tsc_before_
#endif
	mov     eax,dword ptr [edi+8]   ; get ea register pointer
	mov     ecx,dword ptr [edi+16]  ; get register with bit number
	mov     ebx,dword ptr [eax]     ; get ea register content
	mov     edx,dword ptr [ecx]     ; get bit number
	mov     ecx,dword ptr _sr
	and     ecx,0fffffffbh
	and     edx,01fh                 ; modulo 32
	bt      ebx,edx
	jc      i17dl1
	or      ecx,4
i17dl1: mov     dword ptr _sr,ecx
	mov     eax,dword ptr [edi+20]
#ifdef TSC_PROFILING	
		call		i12tsc_after_
#endif
	ret


                ALIGN32

i17_D_B_:
#ifdef TSC_PROFILING	
		call		i12tsc_before_
#endif
	mov     eax,dword ptr [edi+12]  ; get ea routine pointer
	mov     edx,dword ptr [edi+8]   ; get earegister pointer
	call    eax                     ; get ea-content
	mov     eax,dword ptr [edi+16]  ; get bit number register pointer
	mov     eax,dword ptr [eax]     ; get bit number
	mov     ecx,dword ptr _sr
	and     ecx,0fffffffbh
	and     eax,07h                 ; modulo 8
	bt      edx,eax
	jc      i17db1
	or      ecx,4
i17db1: mov     dword ptr _sr,ecx
	mov     eax,dword ptr [edi+20]
#ifdef TSC_PROFILING	
		call		i12tsc_after_
#endif
	ret


                ALIGN32

i17_S_L_:
#ifdef TSC_PROFILING	
		call		i12tsc_before_
#endif
	mov     ecx,esi                 ; get bit number
        fetchwopcode_inc_pos
	add     esi,2
	mov     eax,dword ptr [edi+8]   ; get register pointer
	mov     ebx,dword ptr [eax]     ; get register content
	mov     ecx,dword ptr _sr
	and     ecx,0fffffffbh
	and     edx,01fh                 ; modulo 32
	bt      ebx,edx
	jc      i17sl1
	or      ecx,4
i17sl1: mov     dword ptr _sr,ecx
	mov     eax,dword ptr [edi+16]
#ifdef TSC_PROFILING	
		call		i12tsc_after_
#endif
	ret


                ALIGN32

i17_S_B_:
#ifdef TSC_PROFILING	
		call		i12tsc_before_
#endif
	mov     ecx,esi                 ; get bit number
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]  ; get ea routine pointer
	mov     edx,dword ptr [edi+8]   ; get earegister pointer
	call    eax
	mov     ecx,dword ptr _sr
	and     ecx,0fffffffbh
	and     ebx,07h                 ; modulo 8
	bt      edx,ebx
	jc      i17sb1
	or      ecx,4
i17sb1: mov     dword ptr _sr,ecx
	mov     eax,dword ptr [edi+16]
#ifdef TSC_PROFILING	
		call		i12tsc_after_
#endif
	ret

       
;
; CHK.W <ea>,Dn
; 2 - eareg 3-earead 4-reg 5-cycle count
; NOTE:	Long version in 68030.asm
; Word:	012346
; Long:	XX2346
;


		ALIGN32

public i18_
i18_:		mov	eax, dword ptr [edi + 12]
		mov	edx, dword ptr [edi + 8]
		call	eax
		mov	ebx, dword ptr [edi + 16]
		mov	eax, dword ptr [ebx]
		and	dword ptr [_sr], 0fffffffbh
		test	ax, ax
		js	i18trapset
		cmp	ax, dx
		ja	i18trap
		mov	eax, dword ptr [edi + 20]
		ret
i18TrapSet:	or	dword ptr [_sr],4
i18Trap:	mov	ebx, 18h		; vector at $18 (nr. 6)
		mov	eax, 34
		add	eax, dword ptr [edi + 20]
		jmp	prepare_exception_


;
; CLR.? <ea>
; 2-eareg 3-eawrite 4-cyclecount
;


                ALIGN32

i19_:		xor	edx,edx
		mov	eax,dword ptr [edi+12]
		mov	ebx,dword ptr [edi+8]
		call	eax
		mov	eax,dword ptr [_sr]
		and	eax,0fffffff0h
		or	eax,4
		mov	dword ptr [_sr],eax
		mov	eax,dword ptr [edi + 16]
		ret

;
; CMP.X <ea>,Dn 
; Flag: All, X unaffected
;


                ALIGN32

i20_B_:
        mov     eax,dword ptr [edi+12]
        mov     edx,dword ptr [edi+8] 
        call    eax                   
        mov     ebx,dword ptr [edi+16]
        mov     eax,dword ptr [edi+20]
        mov     ecx,dword ptr [ebx]   
        cmp     cl,dl                 
        pushfd                        
        pop     ecx                   
        and     ecx,0fffh             
        mov     ebx,dword ptr [_statustab+4*ecx]
        mov     ecx,dword ptr _sr       
        and     ecx,0fffffff0h          
        and     ebx,0fh                 
        or      ecx,ebx                 
        mov     dword ptr _sr,ecx       
        ret                             


                ALIGN32

i20_W_:
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	mov     ebx,dword ptr [edi+16]
	mov     eax,dword ptr [edi+20]
	mov     ecx,dword ptr [ebx]
        cmp     cx,dx
	pushfd
	pop     ecx
	and     ecx,0fffh
	mov     ebx,dword ptr [_statustab+4*ecx]
	mov     ecx,dword ptr _sr
	and     ecx,0fffffff0h
	and     ebx,0fh
	or      ecx,ebx
	mov     dword ptr _sr,ecx
	ret


                ALIGN32

i20_L_:
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	mov     ebx,dword ptr [edi+16]
	mov     eax,dword ptr [edi+20]
	mov     ecx,dword ptr [ebx]
	cmp     ecx,edx
	pushfd
	pop     ecx
	and     ecx,0fffh
	mov     ebx,dword ptr [_statustab+4*ecx]
	mov     ecx,dword ptr _sr
	and     ecx,0fffffff0h
	and     ebx,0fh
	or      ecx,ebx
	mov     dword ptr _sr,ecx
	ret


;
; CMPA.W/L <ea>,An 
; Flag: All, X unaffected
;


                ALIGN32

i21_W_:
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	mov     ebx,dword ptr [edi+16]
	mov     eax,dword ptr [edi+20]
	movsx   edx,dx
	mov     ecx,dword ptr [ebx]
	cmp     ecx,edx
	pushfd
	pop     ecx
	and     ecx,0fffh
	mov     ebx,dword ptr [_statustab+4*ecx]
	mov     ecx,dword ptr _sr
	and     ecx,0fffffff0h
	and     ebx,0fh
	or      ecx,ebx
	mov     dword ptr _sr,ecx
	ret


                ALIGN32

i21_L_:
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	mov     ebx,dword ptr [edi+16]
	mov     eax,dword ptr [edi+20]
	mov     ecx,dword ptr [ebx]
	cmp     ecx,edx
	pushfd
	pop     ecx
	and     ecx,0fffh
	mov     ebx,dword ptr [_statustab+4*ecx]
	mov     ecx,dword ptr _sr
	and     ecx,0fffffff0h
	and     ebx,0fh
	or      ecx,ebx
	mov     dword ptr _sr,ecx
	ret


;
; CMPI.X #,<ea>
; Flag: NZCV, X unaffected
;


                ALIGN32

i22_B_:
        mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	mov     eax,dword ptr [edi+16]
	cmp     dl,bl
	pushfd
	pop     ecx
	and     ecx,0fffh
	mov     ecx,dword ptr [_statustab+4*ecx]
	mov     ebx,dword ptr _sr
	and     ebx,0fffffff0h
	and     ecx,0fh
	or      ebx,ecx
	mov     dword ptr _sr,ebx
	ret


                ALIGN32

i22_W_:
        mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	mov     eax,dword ptr [edi+16]
	cmp     dx,bx
	pushfd
	pop     ecx
	and     ecx,0fffh
	mov     ecx,dword ptr [_statustab+4*ecx]
	mov     ebx,dword ptr _sr
	and     ebx,0fffffff0h
	and     ecx,0fh
	or      ebx,ecx
	mov     dword ptr _sr,ebx
	ret


                ALIGN32

i22_L_:
        mov     ecx,esi
        fetchlopcode_inc_pos
	add     esi,4
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	mov     eax,dword ptr [edi+16]
	cmp     edx,ebx
	pushfd
	pop     ecx
	and     ecx,0fffh
	mov     ecx,dword ptr [_statustab+4*ecx]
	mov     ebx,dword ptr _sr
	and     ebx,0fffffff0h
	and     ecx,0fh
	or      ebx,ecx
	mov     dword ptr _sr,ebx
	ret


;
; CMPM
; Tableusage 0- rut 1- disrut 2-soureg 3-destreg
; Flag: All, X unaffected
;


                ALIGN32

i23_b_:
        mov     eax,dword ptr [edi+8]
	mov     ecx,dword ptr [eax]
        fetchb
	inc     ecx
        cmp     eax,dword ptr [_a7pointer]
        jne     i23_b_j
        inc     ecx
i23_B_j:
	mov     dword ptr [eax],ecx
	mov     ebx,edx                         ; source in ebx
	mov     eax,dword ptr [edi+12]            
	mov     ecx,dword ptr [eax]
        fetchb
	inc     ecx
        cmp     eax,dword ptr [_a7pointer]
        jne     i23_b_i
        inc     ecx
i23_B_i:
	mov     dword ptr [eax],ecx             ; Dest in edx
	cmp     dl,bl
	pushfd
	pop     eax
	and     eax,0fffh
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	and     ebx,0fh
	or      eax,ebx
	mov     dword ptr _sr,eax
	mov     eax,12
	ret


                ALIGN32

i23_W_:
        mov     eax,dword ptr [edi+8]
	mov     ecx,dword ptr [eax]
        fetchw
	add     ecx,2
	mov     dword ptr [eax],ecx
	mov     ebx,edx                         ; source in ebx
	mov     eax,dword ptr [edi+12]            
	mov     ecx,dword ptr [eax]
        fetchw
	add     ecx,2
	mov     dword ptr [eax],ecx             ; Dest in edx
	cmp     dx,bx
	pushfd
	pop     eax
	and     eax,0fffh
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	and     ebx,0fh
	or      eax,ebx
	mov     dword ptr _sr,eax
	mov     eax,12
	ret


                ALIGN32

i23_l_:
        mov     eax,dword ptr [edi+8]
	mov     ecx,dword ptr [eax]
        fetchl
	add     ecx,4
	mov     dword ptr [eax],ecx
	mov     ebx,edx                         ; source in ebx
	mov     eax,dword ptr [edi+12]            
	mov     ecx,dword ptr [eax]
        fetchl
	add     ecx,4
	mov     dword ptr [eax],ecx             ; Dest in edx
	cmp     edx,ebx
	pushfd
	pop     eax
	and     eax,0fffh
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	and     ebx,0fh
	or      eax,ebx
	mov     dword ptr _sr,eax
	mov     eax,20
	ret


;
; DBcc
; Tableusage 0- rout 1- disrout 2-register*4+d 3-handle routine
; Flags: None
;


                ALIGN32

i24_:
        mov     eax,dword ptr [edi+12]
	call    eax
        test    dl,dl
	jnz     i24ferdig
	mov     ebx,dword ptr [edi+8]
	mov     edx,dword ptr [ebx]
	dec     dx
	mov     dword ptr [ebx],edx
        cmp     dx,-1
        je      i24out
	mov     ecx,esi
        fetchwopcode_inc_pos
	movsx   edx,dx
	add     esi,edx
#ifdef PREFETCH
        mov     edx,esi
        call    prefetch_fill_
#endif
	mov     eax,10
	ret
i24out: mov     eax,14
#ifdef PREFETCH
        mov     ecx,esi
        fetchwopcode_inc_pos
#endif
	add     esi,2
	ret
i24ferdig:
	mov     eax,12
#ifdef PREFETCH
        mov     ecx,esi
        fetchwopcode_inc_pos
#endif
	add     esi,2
	ret


;
; DIVS.W <ea>,Dx
; 2-reg 3-ea read routine 4-dreg*4+d
; Flags: X unaffected, C = 0, NZV
; Cycle time varies, set to 70
;


                ALIGN32

i25_:
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	movsx   ecx,dx
	or      ecx,ecx
	jz      i25divzero
	mov     ebx,dword ptr [edi+16]
	mov     eax,dword ptr [ebx]
	xor     edx,edx
	or      eax,eax
	jns     i25ns
	dec     edx
i25ns:  idiv    ecx
	mov     ecx,dword ptr _sr
	and     ecx,0fffffff0h
	cmp     eax,32768                       ; Sjekk resultat overflow
	jle     i25noov1
	or      ecx,1                           ; Overflow
	jmp     i25fin
i25noov1:
	cmp     eax,-32767                      ;overflow
	jge     i25noov2
	or      ecx,1
	jmp     i25fin
i25noov2:
	or      eax,eax
	jnz     i25noz
	or      ecx,4
	jmp     i25finish
i25noz: jns     i25finish
	or      ecx,8
i25finish:
	and     eax,0000ffffh
	shl     edx,16
	and     edx,0ffff0000h
	or      eax,edx
	mov     dword ptr [ebx],eax
i25fin: mov     dword ptr _sr,ecx
        mov     eax,70
	ret
i25divzero:
	mov     ebx,14h
	mov     eax,200
        jmp     prepare_exception_

;
; DIVU.W <ea>,Dx
; 2-reg 3-ea read routine 4-dreg*4+d
; Flags: X unaffected, C = 0, NZV
;


                ALIGN32

i26_:
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	movzx   ecx,dx
	or      ecx,ecx
	jz      i26divzero
	mov     ebx,dword ptr [edi+16]
	mov     eax,dword ptr [ebx]
	xor     edx,edx
	idiv    ecx
	mov     ecx,dword ptr _sr
	and     ecx,0fffffff0h
	cmp     eax,65536                       ; Sjekk resultat overflow
	jb      i26noov1
	or      ecx,1                           ; Overflow
	jmp     i26fin
i26noov1:
	or      eax,eax
	jnz     i26noz
	or      ecx,4
	jmp     i26finish
i26noz: jns     i26finish
	or      ecx,8
i26finish:
	and     eax,0000ffffh
	shl     edx,16
	and     edx,0ffff0000h
	or      eax,edx
	mov     dword ptr [ebx],eax
i26fin: mov     dword ptr _sr,ecx
        mov     eax,70 
	ret
i26divzero:
	mov     ebx,14h
	mov     eax,182
        jmp     prepare_exception_


;
; EOR.X Dn,<ea>
; Flag: X unaffected, V = C = 0, NZ
;


                ALIGN32

i27_B_:
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	mov     ebx,dword ptr [edi+16]
	mov     ebx,dword ptr [ebx]
	xor     dl,bl
	pushfd
	pop     eax
	and     eax,07feh
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
        and     ebx,0fh
	or      eax,ebx
	mov     ecx,dword ptr [edi+24]
	mov     dword ptr _sr,eax
	mov     ebx,dword ptr [edi+8]
	call    ecx
	mov     eax,dword ptr [edi+20]
	ret


                ALIGN32

i27_W_:
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	mov     ebx,dword ptr [edi+16]
	mov     ebx,dword ptr [ebx]
	xor     dx,bx
	pushfd
	pop     eax
	and     eax,07feh
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
        and     ebx,0fh
	or      eax,ebx
	mov     ecx,dword ptr [edi+24]
	mov     dword ptr _sr,eax
	mov     ebx,dword ptr [edi+8]
	call    ecx
	mov     eax,dword ptr [edi+20]
	ret


                ALIGN32

i27_L_:
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	mov     ebx,dword ptr [edi+16]
	mov     ebx,dword ptr [ebx]
	xor     edx,ebx
	pushfd
	pop     eax
	and     eax,07feh
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
        and     ebx,0fh
	or      eax,ebx
	mov     ecx,dword ptr [edi+24]
	mov     dword ptr _sr,eax
	mov     ebx,dword ptr [edi+8]
	call    ecx
	mov     eax,dword ptr [edi+20]
	ret

;
; EORI.X #,<ea>
; Flag: X unaffected, V = C = 0, NZ
;


                ALIGN32

i28_B_:
        mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	xor     dl,bl
	pushfd
	pop     eax
	and     eax,07feh
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
        and     ebx,0fh
	or      eax,ebx
	mov     ecx,dword ptr [edi+20]
	mov     dword ptr _sr,eax
	mov     ebx,dword ptr [edi+8]
	call    ecx
	mov     eax,dword ptr [edi+16]
	ret


                ALIGN32

i28_B_CCR_:
	mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     eax,dword ptr _sr
	xor     al,dl
	mov     dword ptr _sr,eax
	mov     eax,20
	ret


                ALIGN32

i28_W_SR_:
        test    byte ptr [_sr+1],020h
        jz      privilegie_violation
	mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     eax,dword ptr _sr
	xor     eax,edx
	mov     edx,eax
	call    updateSR
	mov     eax,20
	ret


                ALIGN32

i28_W_:
        mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	xor     dx,bx
	pushfd
	pop     eax
	and     eax,07feh
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
        and     ebx,0fh
	or      eax,ebx
	mov     ecx,dword ptr [edi+20]
	mov     dword ptr _sr,eax
	mov     ebx,dword ptr [edi+8]
	call    ecx
	mov     eax,dword ptr [edi+16]
	ret


                ALIGN32

i28_L_:
        mov     ecx,esi
        fetchlopcode_inc_pos
	add     esi,4
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	xor     edx,ebx
	pushfd
	pop     eax
	and     eax,07feh
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
        and     ebx,0fh
	or      eax,ebx
	mov     ecx,dword ptr [edi+20]
	mov     dword ptr _sr,eax
	mov     ebx,dword ptr [edi+8]
	call    ecx
	mov     eax,dword ptr [edi+16]
	ret


;
; Instruction EXG.L 
; Tableusage 0 - routine  1 - disrout  2-reg1 3-reg2 
; Flag: NONE
;


                ALIGN32

i29_:		mov	eax,dword ptr [edi+8]
		mov	ebx,dword ptr [edi+12]
		mov	ecx,dword ptr [eax]
		mov	edx,dword ptr [ebx]
		mov	dword ptr [eax],edx
		mov	dword ptr [ebx],ecx
		mov	eax,6
		ret

;
; Instruction EXT.L 
; Tableusage 0 - routine  1 - reg1  
; Flag: X unaffected, V = C = 0, NZ
;


		ALIGN32

public i30_W_
i30_W_:		mov	ecx, dword ptr [edi + 4]
		mov	eax, 4
		mov	edx, dword ptr [_sr]
		and	edx, 0fffffff0h
		mov	ebx, dword ptr [ecx]
		movsx	bx,bl
		mov	dword ptr [ecx], ebx
		test	bx, bx
		jz	i30wz
		jns	i30wns
		or	edx, 8
		jmp	i30wns
i30wz:		or	edx, 4
i30wns:		mov	dword ptr [_sr], edx
		ret


		ALIGN32

public i30_L_
i30_L_:		mov	ecx, dword ptr [edi + 4]
		mov	eax, 4
		mov	edx, dword ptr [_sr]
		and	edx, 0fffffff0h
		mov	ebx, dword ptr [ecx]
		movsx	ebx, bx
		mov	dword ptr [ecx], ebx
		test	ebx, ebx
		jz	i30lz
		jns	i30lns
		or	edx, 8
		jmp	i30lns
i30lz:		or	edx, 4
i30lns:		mov	dword ptr [_sr], edx
		ret


;
; Instruction JMP <ea>
; Tableusage 0 - routine  1 - disrout  2 - eareg 3- eacalcrout 4- cycle time
; Flag: NONE
;


                ALIGN32

public  i31_
i31_:           mov     eax,dword ptr [edi+12]
                mov     edx,dword ptr [edi+8]
                call    eax
                mov     esi,edx
                PC_TO_PTR esi
#ifdef PREFETCH
                call    prefetch_fill_
#endif
                mov     eax,dword ptr [edi+16]
                ret


;
; Instruction JSR <ea>
; Tableusage 0 - routine  1 - disrout  2 - eareg 3- eacalcrout 4- cycle time
; Flag: NONE
;


                ALIGN32

public i32_
i32_:
noio2:          mov     eax,dword ptr [edi+12]          ; get new pc
                mov     edx,dword ptr [edi+8]
                call    eax
                xchg    esi,edx

                ; The order is crucial, PTR_TO_PC sets a new
                ; base-pointer.

                PTR_TO_PC edx
                PC_TO_PTR esi
                mov     ecx,dword ptr [_a+28]
                sub     ecx,4
                mov     dword ptr [_a+28],ecx
                writel
#ifdef PREFETCH
                mov     edx,esi
                call    prefetch_fill_
#endif
                mov     eax,dword ptr [edi+16]
                ret


;
; Instruction LEA <ea>
; Tableusage 0 - routine  1 - disrout  2 - eareg 3- eacalcrout 4-areg 5-cycletime
; Flag: NONE
;


                ALIGN32

i33_:
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	mov     ecx,dword ptr [edi+16]
        mov     dword ptr [ecx],edx             
	mov     eax,dword ptr [edi+20]
	ret

;
; Instruction LINK An,#
; Tableusage 0 - routine  1 - disrout  2 - Register
; Flag: NONE
;


                ALIGN32

i34_:
        mov     ebx,dword ptr [edi+8]
	mov     edx,dword ptr [ebx]
	mov     ecx,dword ptr [_a+28]
	sub     ecx,4
	mov     dword ptr [ebx],ecx        ; Load An with updated SP
        writel
	mov     ebx,ecx
	mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	movsx   edx,dx
	add     ebx,edx
	mov     dword ptr [_a+28],ebx           ; add disp to SP
	mov     eax,16
	ret


;
; LSX.X
; Tableusage:(imm) 0-rout 1-disrout 2-shcount 3-dreg 4-cyclecount
; Tableusage:(reg) 0-rout 1-disrout 2-shcountreg 3-dreg 4-cyclecount
; Tableusage:(mem) 0-rout 1-disrout 2-eareg 3-earead 4-eawrite 5-cyclecount
; Flag: ALL, V = 0
;


                ALIGN32

i35_zerocountb: test    al,al
                pushfd
                pop     ecx                     ; Only NZ, X is unaffected
                and     ecx,0c0h
                shr     ecx,4
                mov     ch,byte ptr [_sr]
                and     ch,10h
                or      ch,cl
                mov     byte ptr [_sr],ch
                mov     eax,4
                ret


                ALIGN32

i35_zerocountw: test    ax,ax
                pushfd
                pop     ecx                     ; Only NZ, X is unaffected
                and     ecx,0c0h
                shr     ecx,4
                mov     ch,byte ptr [_sr]
                and     ch,10h
                or      ch,cl
                mov     byte ptr [_sr],ch
                mov     eax,4
                ret


                ALIGN32

i35_zerocountl: test    eax,eax
                pushfd
                pop     ecx                     ; Only NZ, X is unaffected
                and     ecx,0c0h
                shr     ecx,4
                mov     ch,byte ptr [_sr]
                and     ch,10h
                or      ch,cl
                mov     byte ptr [_sr],ch
                mov     eax,4
                ret


                ALIGN32

i35_RI_I_B_:    mov     ecx,dword ptr [edi+8]           ; get shcount
                mov     ebx,dword ptr [edi+12]          ; get dreg ptr
                mov     eax,dword ptr [ebx]             ; get dreg content
                shr     al,cl
                pushfd
                pop     ecx
                and     ecx,07ffh                       ; Overflow always 0
                mov     dword ptr [ebx],eax
                mov     ecx,dword ptr [_statustab+4*ecx]
                mov     byte ptr [_sr],cl
                mov     eax,dword ptr [edi+16]
                ret


                ALIGN32

i35_RI_I_W_:    mov     ecx,dword ptr [edi+8]           ; get shcount
                mov     ebx,dword ptr [edi+12]          ; get dreg ptr
                mov     eax,dword ptr [ebx]             ; get dreg content
                shr     ax,cl
                pushfd  
                pop     ecx
                and     ecx,07ffh                       ; Overflow always 0
                mov     dword ptr [ebx],eax
                mov     ecx,dword ptr [_statustab+4*ecx]
                mov     byte ptr [_sr],cl
                mov     eax,dword ptr [edi+16]
                ret


                ALIGN32

i35_RI_I_L_:    mov     ecx,dword ptr [edi+8]           ; get shcount
                mov     ebx,dword ptr [edi+12]          ; get dreg ptr
                mov     eax,dword ptr [ebx]             ; get dreg content
                shr     eax,cl
                pushfd
                pop     ecx
                and     ecx,07ffh                       ; Overflow always 0
                mov     dword ptr [ebx],eax
                mov     ecx,dword ptr [_statustab+4*ecx]
                mov     byte ptr [_sr],cl
                mov     eax,dword ptr [edi+16]
                ret


                ALIGN32

i35_RI_R_B_:    mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
                mov     ebx,dword ptr [edi+12]          ; get dreg ptr
                mov     ecx,dword ptr [ecx]             ; get shcount reg content
                mov     eax,dword ptr [ebx]             ; get dreg content
                and     ecx,3fh                         ; modulo 64
                jz      i35_zerocountb
                cmp     ecx,32
                jb      i35rirbsok
                mov     ecx,31
i35rirbsok:     shr     al,cl
                pushfd
                mov     dword ptr [ebx],eax
                mov     edx,ecx
                add     edx,edx                         ; Calculate cyclecount
                pop     ecx
                and     ecx,07ffh                       ; Overflow always 0
                mov     eax,dword ptr [_statustab+4*ecx]
                mov     byte ptr [_sr],al
                mov     eax,dword ptr [edi+16]
                add     eax,edx
                ret


                ALIGN32

i35_RI_R_W_:    mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
                mov     ebx,dword ptr [edi+12]          ; get dreg ptr
                mov     ecx,dword ptr [ecx]             ; get shcount reg content
                mov     eax,dword ptr [ebx]             ; get dreg content
                and     ecx,3fh                         ; modulo 64
                jz      i35_zerocountw
                cmp     ecx,32
                jb      i35rirwsok
                mov     ecx,31
i35rirwsok:     shr     ax,cl
                pushfd
                mov     dword ptr [ebx],eax
                mov     edx,ecx
                add     edx,edx                         ; Calculate cyclecount
                pop     ecx
                and     ecx,07ffh                       ; Overflow always 0
                mov     eax,dword ptr [_statustab+4*ecx]
                mov     byte ptr _sr,al
                mov     eax,dword ptr [edi+16]
                add     eax,edx
                ret


                ALIGN32

i35_RI_R_L_:    mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
                mov     ebx,dword ptr [edi+12]          ; get dreg ptr
                mov     ecx,dword ptr [ecx]             ; get shcount reg content
                mov     eax,dword ptr [ebx]             ; get dreg content
                and     ecx,3fh                         ; modulo 64
                jz      i35_zerocountl
                cmp     ecx,32
                jb      i35rirlok
                je      i35rircount32
                xor     eax,eax
                jmp     i35rirlnok
i35rircount32:  mov     edx,eax
                test    edx,edx
                js      i35rircount32c
                xor     eax,eax
                jmp     i35rirlnok
i35rircount32c: xor     eax,eax
                stc
                jmp     i35rirlnok
i35rirlok:      shr     eax,cl
i35rirlnok:     pushfd
                mov     dword ptr [ebx],eax
                mov     edx,ecx
                add     edx,edx                         ; Calculate cyclecount
                pop     ecx
                and     ecx,07ffh                       ; Overflow always 0
                mov     eax,dword ptr [_statustab+4*ecx]
                mov     byte ptr [_sr],al
                mov     eax,dword ptr [edi+16]
                add     eax,edx
                ret


                ALIGN32

i35_LE_I_B_: 	mov     ebx,dword ptr [edi+12]          ; get dreg ptr
                mov     ecx,dword ptr [edi+8]           ; get shcount
                mov     eax,dword ptr [ebx]             ; get dreg content
                shl     al,cl
                pushfd
                pop     ecx
                and     ecx,07ffh                       ; Overflow always 0
                mov     dword ptr [ebx],eax
                mov     eax,dword ptr [edi+16]
                mov     ebx,dword ptr [_statustab+4*ecx]
                mov     byte ptr [_sr],bl
                ret


                ALIGN32

i35_LE_I_W_:    mov     ebx,dword ptr [edi+12]          ; get dreg ptr
                mov     ecx,dword ptr [edi+8]           ; get shcount
                mov     eax,dword ptr [ebx]             ; get dreg content
                shl     ax,cl
                pushfd
                pop     ecx
                and     ecx,07ffh                       ; Overflow always 0
                mov     dword ptr [ebx],eax
                mov     eax,dword ptr [edi+16]
                mov     ebx,dword ptr [_statustab+4*ecx]
                mov     byte ptr [_sr],bl
                ret


                ALIGN32

i35_LE_I_L_:    mov     ebx,dword ptr [edi+12]          ; get dreg ptr
                mov     ecx,dword ptr [edi+8]           ; get shcount
                mov     eax,dword ptr [ebx]             ; get dreg content
                shl     eax,cl
                pushfd
                pop     ecx
                and     ecx,07ffh                       ; Overflow always 0
                mov     dword ptr [ebx],eax
                mov     eax,dword ptr [edi+16]
                mov     ebx,dword ptr [_statustab+4*ecx]
                mov     byte ptr [_sr],bl
                ret


                ALIGN32

i35_LE_R_B_:    mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
                mov     ebx,dword ptr [edi+12]          ; get dreg ptr
                mov     ecx,dword ptr [ecx]             ; get shcount reg content
                mov     eax,dword ptr [ebx]             ; get dreg content
                and     ecx,3fh                         ; modulo 64
                jz      i35_zerocountb
                cmp     ecx,32
                jb      i35lerbsok
                mov     ecx,31
i35lerbsok:     shl     al,cl
                pushfd
                mov     dword ptr [ebx],eax
                mov     edx,ecx
                add     edx,edx                         ; Calculate cyclecount
                pop     ecx
                and     ecx,07ffh                       ; Overflow always 0
                mov     eax,dword ptr [_statustab+4*ecx]
                mov     byte ptr [_sr],al
                mov     eax,dword ptr [edi+16]
                add     eax,edx
                ret


                ALIGN32

i35_LE_R_W_:    mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
                mov     ebx,dword ptr [edi+12]          ; get dreg ptr
                mov     ecx,dword ptr [ecx]             ; get shcount reg content
                mov     eax,dword ptr [ebx]             ; get dreg content
                and     ecx,3fh                         ; modulo 64
                jz      i35_zerocountw
                cmp     ecx,32
                jb      i35lerwsok
                mov     ecx,31
i35lerwsok:     shl     ax,cl
                pushfd
                mov     dword ptr [ebx],eax
                mov     edx,ecx
                add     edx,edx                         ; Calculate cyclecount
                pop     ecx
                and     ecx,07ffh                       ; Overflow always 0
                mov     eax,dword ptr [_statustab+4*ecx]
                mov     byte ptr [_sr],al
                mov     eax,dword ptr [edi+16]
                add     eax,edx
                ret


                ALIGN32

i35_LE_R_L_:    mov     ecx,dword ptr [edi+8]           ; get shcount reg ptr
                mov     ebx,dword ptr [edi+12]          ; get dreg ptr
                mov     ecx,dword ptr [ecx]             ; get shcount reg content
                mov     eax,dword ptr [ebx]             ; get dreg content
                and     ecx,3fh                         ; modulo 64
                jz      i35_zerocountl

                cmp     ecx,32
                jb      i35lerlok
                je      i35lercount32
                xor     eax,eax
                jmp     i35lerlnok
i35lercount32:  mov     edx,eax
                test    dl,1
                jnz     i35lercount32c
                xor     eax,eax
                jmp     i35lerlnok
i35lercount32c: xor     eax,eax
                stc
                jmp     i35lerlnok
i35lerlok:      shl     eax,cl
i35lerlnok:     pushfd
                mov     dword ptr [ebx],eax
                mov     edx,ecx
                add     edx,edx                         ; Calculate cyclecount
                pop     ecx
                and     ecx,07ffh                       ; Overflow always 0
                mov     eax,dword ptr [_statustab+4*ecx]
                mov     byte ptr [_sr],al
                mov     eax,dword ptr [edi+16]
                add     eax,edx
                ret


                ALIGN32

i35_RI_M_W_:    mov     ebx,dword ptr [edi+8]           ; get ea reg ptr
                mov     edx,ebx
                mov     eax,dword ptr [edi+12]          ; get ea read rout
                call    eax
                shr     dx,1
                pushfd
                pop     ecx
                and     ecx,07ffh                       ; Overflow always 0
                mov     eax,dword ptr [edi+16]          ; get dest rout ptr.
                mov     ecx,dword ptr [_statustab+4*ecx]
                mov     byte ptr [_sr],cl
                call    eax     
                mov     eax,dword ptr [edi+20]
                ret


                ALIGN32

i35_LE_M_W_:    mov     ebx,dword ptr [edi+8]           ; get ea reg ptr
                mov     edx,ebx
                mov     eax,dword ptr [edi+12]          ; get ea read rout
                call    eax
                shl     dx,1
                pushfd
                pop     ecx
                and     ecx,07ffh                       ; Overflow always 0
                mov     eax,dword ptr [edi+16]          ; get dest rout ptr.
                mov     ecx,dword ptr [_statustab+4*ecx]
                mov     byte ptr [_sr],cl
                call    eax     
                mov     eax,dword ptr [edi+20]
                ret


;
; Instruction 37   MOVE.X <ea>,<ea>
; Table usage: 2 - get src ea  3 - src reg  4 - set dst ea  5 - cycles
;              6 - dst reg
; Flags: NZ, V=C=0, X unaffected
;


                ALIGN32

public i37_b_
i37_b_:
#ifdef TSC_PROFILING
		call	i37tsc_before_
#endif
	        mov     ecx,dword ptr [edi+8]   
                mov     ebx,dword ptr _sr        
                mov     edx,dword ptr [edi+12]    
                and     ebx,0fffffff0h           
                call    ecx                      
                mov     ebp,dword ptr [edi+16]   
                or      dl,dl                    
                pushfd                           
                pop     ecx                      
                and     ecx,07feh                
                mov     eax,dword ptr [edi+20]   
                or      ebx,dword ptr [_statustab+4*ecx]
                mov     dword ptr _sr,ebx     
                mov     ebx,dword ptr [edi+24]
#ifdef TSC_PROFILING
		call	ebp
		call	i37tsc_after_
		ret
#endif
                jmp     ebp      


                ALIGN32

public i37_w_
i37_w_:
#ifdef TSC_PROFILING
		call	i37tsc_before_
#endif
	        mov     ecx,dword ptr [edi+8]    
                mov     ebx,dword ptr _sr         
                mov     edx,dword ptr [edi+12]     
                and     ebx,0fffffff0h            
                call    ecx                       
                mov     ebp,dword ptr [edi+16]    
                and     edx,0ffffh
                or      dx,dx                     
                pushfd                            
                pop     ecx                       
                and     ecx,07feh                 
                mov     eax,dword ptr [edi+20]    
                or      ebx,dword ptr [_statustab+4*ecx]
                mov     dword ptr _sr,ebx        
                mov     ebx,dword ptr [edi+24]   
#ifdef TSC_PROFILING
		call	ebp
		call	i37tsc_after_
		ret
#endif
                jmp     ebp                      


                ALIGN32

public i37_l_
i37_l_:
#ifdef TSC_PROFILING
		call	i37tsc_before_
#endif
	        mov     ecx,dword ptr [edi+8]
                mov     ebx,dword ptr [_sr]     
                mov     edx,dword ptr [edi+12] 
                and     ebx,0fffffff0h        
                call    ecx                   
                mov     ebp,dword ptr [edi+16]
                or      edx,edx               
                pushfd                        
                pop     ecx                   
                and     ecx,07feh             
                mov     eax,dword ptr [edi+20]
                or      ebx,dword ptr [_statustab+4*ecx]
                mov     dword ptr [_sr],ebx      
                mov     ebx,dword ptr [edi+24] 
#ifdef TSC_PROFILING
		call	ebp
		call	i37tsc_after_
		ret
#endif
                jmp     ebp                    


;
; MOVE to CCR
; 2-_sreg 3-les 4-cycle time
;


                ALIGN32

i38_:
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	mov     byte ptr _sr,dl
	mov     eax,dword ptr [edi+16]
	ret

;
; MOVE to SR
; 2-_sreg 3-read 4-cycle time
; Privileged instruction, cannot be executed by user state programs
;


                ALIGN32

i39_:
        test    byte ptr _sr+1,020h
        jz      privilegie_violation
	mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	call    updateSR
	mov     eax,dword ptr [edi+16]
	ret


;
; MOVE from SR
; 2-_dreg 3-destwrite 4-cycle time
;


		ALIGN32

i40_:		cmp	dword ptr [_config_cpu_type], 0
		jz	i40ok
		test	byte ptr [_sr + 1], 020h
		jz	privilegie_violation
i40ok:		mov	eax, dword ptr [edi + 12]
		mov	ebx, dword ptr [edi + 8]
		mov	edx, dword ptr [_sr]
		call	eax
		mov	eax, dword ptr [edi + 16]
		ret


;
; MOVE USP
; 2-_Areg
; Privileged instruction, cannot be executed by user state programs
;

; to Ax


                ALIGN32

i41_1_:
        test    byte ptr _sr+1,020h      ; Are we in supervisormode??
        jz      privilegie_violation
	mov     eax,4
	mov     edx,dword ptr _usp      
	mov     ecx,dword ptr [edi+8]
	mov     dword ptr [ecx],edx
	ret

; from Ax


                ALIGN32

i41_2_:
        test    byte ptr _sr+1,020h       ; Are we in supervisormode??
        jz      privilegie_violation
        mov     ebx,dword ptr [edi+8]
	mov     eax,4
	mov     edx,dword ptr [ebx]     
	mov     dword ptr _usp,edx
	ret


;
; MOVEA
; 2-_sreg 3-Srcread  4-Areg 5-cycle time
; Flag: NONE
;


                ALIGN32

i42_W_:
		mov     eax,dword ptr [edi+12]
		mov     edx,dword ptr [edi+8]
		call    eax
		movsx   edx,dx
		mov     ebx,dword ptr [edi+16]
		mov     eax,dword ptr [edi+20]
		mov     dword ptr [ebx],edx
		ret


                ALIGN32

i42_L_:
		mov     eax,dword ptr [edi+12]
		mov     edx,dword ptr [edi+8] 
		call    eax                   
		mov     ebx,dword ptr [edi+16]
		mov     eax,dword ptr [edi+20]
		mov     dword ptr [ebx],edx
		ret
	
;
; MOVEM
; 2-reg 3-eacalc  4-cycle time
; Flag: NONE
;

; Predecrement, to memory
; Order: d0-d7,a0-a7   a7 first


                ALIGN32

i43_W_PREM_:
		mov     ecx,esi                   ; get register mask word
                fetchwopcode_inc_pos
		add     esi,2
		mov     ebx,edx                   ; Register mask in ebx
		xor     ebp,ebp			  ; count cycles in ebp
		mov     eax,offset _aend          ; pointer to A7
i43wpm2:	sub     eax,4                     ; Point to 1 register less
		shr     ebx,1
		jnc     i43wpm1                   ; Skip this register
		mov     edx,[eax]                 ; get register content
		mov     ecx,[edi+8]		  ; register to predecrement
		sub     dword ptr [ecx],2         ; Decrement register
		mov     ecx,dword ptr [ecx]       ; get ea
		add     ebp,4                     ; 4 cycles each register
		writew                            ; store word
i43wpm1:	cmp     eax,offset _d
		jne     i43wpm2
		lea     eax,8[ebp]
		ret

; Predecrement, to memory
; Order: d0-d7,a0-a7   a7 first


                ALIGN32

i43_L_PREM_:
	mov     ecx,esi                         ; get register mask word
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx                         ; Register mask in ebx
	xor     ebp,ebp                         ; count cycles in ebp
	mov     eax,offset _aend                ; pointer to A7
i43lpm2:sub     eax,4
	shr     ebx,1
	jnc     i43lpm1                         ; Skip this register
	mov     edx,dword ptr [eax]             ; get register content
	mov     ecx,dword ptr [edi+8]           ; register to predecrement
	sub     dword ptr [ecx],4               ; Decrement register
	mov     ecx,dword ptr [ecx]             ; get ea
	add     ebp,8                           ; 4 cycles for each register
        writel                                  ; store word
i43lpm1:cmp     eax,offset _d
	jne     i43lpm2
	lea     eax,8[ebp]
	ret

; Postincrement, to registers
; Order: a7-a0,d7-d0   d0 first


                ALIGN32

i43_W_POSTR_:
	mov     ecx,esi                         ; get register mask word
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx                         ; Register mask in ebx
	xor     ebp,ebp                         ; count cycles in ebp
	mov     eax,offset _d                   ; pointer to A7
i43wpr2:shr     ebx,1
	jnc     i43wpr1                         ; Skip this register
	mov     edx,dword ptr [edi+8]           ; register to postincrement
	add     ebp,4                           ; 4 cycles for each register
	mov     ecx,dword ptr [edx]             ; get ea
	add     dword ptr [edx],2               ; increment register
        fetchw                                  ; get memory content
	movsx   edx,dx
	mov     dword ptr [eax],edx             ; store to register
i43wpr1:add     eax,4                           ; Point to 1 register more
	cmp     eax,offset _aend
	jne     i43wpr2
	lea     eax,8[ebp]
	ret

; Postincrement, to registers
; Order: a7-a0,d7-d0   d0 first


                ALIGN32

i43_L_POSTR_:
	mov     ecx,esi                         ; get register mask word
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx                         ; Register mask in ebx
	xor     ebp,ebp                         ; count cycles in ebp
	mov     eax,offset _d                   ; pointer to A7
i43lpr2:shr     ebx,1
	jnc     i43lpr1                         ; Skip this register
	mov     edx,dword ptr [edi+8]           ; register to postincrement
	add     ebp,8                           ; 4 cycles for each register
	mov     ecx,dword ptr [edx]             ; get ea
	add     dword ptr [edx],4               ; increment register
        fetchl                            ; get memory content
	mov     dword ptr [eax],edx             ; store to register
i43lpr1:add     eax,4                           ; Point to 1 register more
	cmp     eax,offset _aend
	jne     i43lpr2
	lea     eax,8[ebp]
	ret

; Control, to registers
; Order: a7-a0,d7-d0   d0 first


                ALIGN32

i43_W_CONR_:
	mov     ecx,esi                         ; get register mask word
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx                         ; Register mask in ebx
	mov     edx,dword ptr [edi+8]
	mov     ecx,dword ptr [edi+12]          ; calculate first ea
	call    ecx
	mov     ecx,edx
	xor     ebp,ebp                         ; count cycles in ebp
	mov     eax,offset _d                   ; pointer to A7
i43wcr2:shr     ebx,1
	jnc     i43wcr1                         ; Skip this register
	add     ebp,4                           ; 4 cycles for each register
        fetchw                            ; get memory content
	add     ecx,2                           ; increment ea 
	movsx   edx,dx
	mov     dword ptr [eax],edx             ; store to register
i43wcr1:add     eax,4                           ; Point to 1 register more
	cmp     eax,offset _aend
	jne     i43wcr2
	mov     eax,dword ptr [edi+16]
	add     eax,ebp
	ret

; Control, to registers
; Order: a7-a0,d7-d0   d0 first


                ALIGN32

i43_L_CONR_:
	mov     ecx,esi                         ; get register mask word
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx                         ; Register mask in ebx
	mov     edx,dword ptr [edi+8]
	mov     ecx,dword ptr [edi+12]          ; calculate first ea
	call    ecx
	mov     ecx,edx
	xor     ebp,ebp                         ; count cycles in ebp
	mov     eax,offset _d                   ; pointer to A7
i43lcr2:shr     ebx,1
	jnc     i43lcr1                         ; Skip this register
        fetchl                            ; get memory content
	add     ebp,8                           ; 8 cycles for each register
	add     ecx,4                           ; increment ea 
	mov     dword ptr [eax],edx             ; store to register
i43lcr1:add     eax,4                           ; Point to 1 register more
	cmp     eax,offset _aend
	jne     i43lcr2
	mov     eax,dword ptr [edi+16]
	add     eax,ebp
	ret

; Control, to memory
; Order: a7-a0,d7-d0   d0 first


                ALIGN32

i43_W_CONM_:
	mov     ecx,esi                         ; get register mask word
        fetchwopcode_inc_pos
	add     esi,2
        push    edx
	mov     edx,dword ptr [edi+8]
	mov     ecx,dword ptr [edi+12]          ; calculate first ea
	call    ecx
        mov     ecx,edx                         ; ecx is ea
	xor     ebp,ebp                         ; count cycles in ebp
        mov     eax,offset _d                   ; pointer to d0
        pop     ebx
i43wcm2:shr     ebx,1
	jnc     i43wcm1                         ; Skip this register
	add     ebp,4                           ; 4 cycles for each register
	mov     edx,dword ptr [eax]
        writew                            ; get memory content
	add     ecx,2                           ; increment ea 
i43wcm1:add     eax,4                           ; Point to 1 register more
	cmp     eax,offset _aend
	jne     i43wcm2
	mov     eax,dword ptr [edi+16]
	add     eax,ebp
	ret

; Control, to memory
; Order: a7-a0,d7-d0   d0 first


                ALIGN32

i43_L_CONM_:
	mov     ecx,esi                         ; get register mask word
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx                         ; Register mask in ebx
	mov     edx,dword ptr [edi+8]
	mov     ecx,dword ptr [edi+12]          ; calculate first ea
	call    ecx
	mov     ecx,edx
	xor     ebp,ebp                         ; count cycles in ebp
        mov     eax,offset _d                   ; pointer to d0
i43lcm2:shr     ebx,1
	jnc     i43lcm1                         ; Skip this register
	add     ebp,8                           ; 4 cycles for each register
	mov     edx,dword ptr [eax]
        writel                            ; store memory content
	add     ecx,4                           ; increment ea 
i43lcm1:add     eax,4                           ; Point to 1 register more
	cmp     eax,offset _aend
	jne     i43lcm2
	mov     eax,dword ptr [edi+16]
	add     eax,ebp
	ret

;
; MOVEP
; Table:  2- areg 3-dreg
;

; word, mem to reg


                ALIGN32

i44_W_1_:
        mov     eax,dword ptr [edi+8]   ; Get areg
        mov     eax,dword ptr [eax]
        mov     ecx,esi
        fetchwopcode_inc_pos                    ; Get disp
        movsx   edx,dx                  ; Sign extend
        add     eax,edx                 ; Add
        mov     ecx,eax
        fetchb                    ; Get first byte
        mov     bh,dl
        add     eax,2
        mov     ecx,eax
        fetchb                    ; get second byte
        mov     bl,dl
        mov     eax,dword ptr [edi+12]  ; Get data reg
        mov     word ptr [eax],bx       ; Store word
        add     esi,2
        mov     eax,16
        ret

; Long, mem to reg


                ALIGN32

i44_L_1_:
        mov     eax,dword ptr [edi+8]   ; Get areg
        mov     eax,dword ptr [eax]
        mov     ecx,esi
        fetchwopcode_inc_pos                    ; Get disp
        movsx   edx,dx                  ; Sign extend
        add     eax,edx                 ; Add
        mov     ecx,eax
        fetchb                    ; Get first byte
        mov     bh,dl
        add     eax,2
        mov     ecx,eax
        fetchb                    ; get second byte
        mov     bl,dl
        shl     ebx,16
        add     eax,2
        mov     ecx,eax
        fetchb                    ; get third byte
        mov     bh,dl
        add     eax,2
        mov     ecx,eax
        fetchb                    ; get fourth byte
        mov     bl,dl
        mov     eax,dword ptr [edi+12]  ; Get data reg
        mov     dword ptr [eax],ebx      ; Store word
        add     esi,2
        mov     eax,20
        ret

; Word, reg to mem


                ALIGN32

i44_W_2_:
        mov     eax,dword ptr [edi+8]   ; Get areg
        mov     eax,dword ptr [eax]
        mov     ecx,esi
        fetchwopcode_inc_pos                    ; Get disp
        movsx   edx,dx                  ; Sign extend
        add     eax,edx                 ; Add
        mov     ebx,dword ptr [edi+12]  ; Get data reg
        mov     ebx,dword ptr [ebx]     ; get reg contents
        rol     bx,8
        mov     dl,bl
        mov     ecx,eax
        writeb                    ; Write first byte
        rol     bx,8
        mov     dl,bl
        add     eax,2
        mov     ecx,eax
        writeb                    ; Write second byte
        add     esi,2
        mov     eax,16
        ret

; Long, reg to mem

                ALIGN32

i44_L_2_:
        mov     eax,dword ptr [edi+8]   ; Get areg
        mov     eax,dword ptr [eax]
        mov     ecx,esi
        fetchwopcode_inc_pos                    ; Get disp
        movsx   edx,dx                  ; Sign extend
        add     eax,edx                 ; Add
        mov     ebx,dword ptr [edi+12]  ; Get data reg
        mov     ebx,dword ptr [ebx]     ; get reg contents
        rol     ebx,8
        mov     dl,bl
        mov     ecx,eax
        writeb                    ; Write first byte
        rol     ebx,8
        mov     dl,bl
        add     eax,2
        mov     ecx,eax
        writeb                    ; Write second byte
        rol     ebx,8
        mov     dl,bl
        add     eax,2
        mov     ecx,eax
        writeb                    ; Write third byte
        rol     ebx,8
        mov     dl,bl
        add     eax,2
        mov     ecx,eax
        writeb                    ; Write fourth byte
        add     esi,2
        mov     eax,20
        ret


;
; MOVEQ.L #,Dx
; 2-Dreg 3-32 bit immediate  4-flag byte
; Flag: NZ, X unaffected, V=C=0
;


                ALIGN32

public i45_
i45_:           mov     ebx,dword ptr [edi+8]
                mov     ecx,dword ptr [_sr]
                mov     eax,dword ptr [edi+12]
                mov     dword ptr [ebx],eax
                mov     ebx,dword ptr [edi+16]
                and     ecx,0fffffff0h
                or      ecx,ebx
                mov     eax,4
                mov     dword ptr [_sr],ecx
                ret


                ALIGN32

public i45ai_
i45ai_:         mov     edx,edi
                and     edx,0f80000h
                cmp     edx,0f80000h
                jne     i00_
                mov     ebx,dword ptr [edi+8]
                mov     ecx,dword ptr [_sr]
                mov     eax,dword ptr [edi+12]
                mov     dword ptr [ebx],eax
                mov     ebx,dword ptr [edi+16]
                and     ecx,0fffffff0h
                or      ecx,ebx
                mov     eax,4
                mov     dword ptr [_sr],ecx
                ret


;
; MULS.W <ea>,Dx
; 2-reg 3-ea read rout 4-dreg*4+d
; Flag: NZ, X unaffected, V=C=0
;


                ALIGN32

i46_:
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	movsx   ecx,dx
        mov     ebp,edx
	mov     ebx,dword ptr [edi+16]
	movsx   eax,word ptr [ebx]
	imul    eax,ecx
	mov     dword ptr [ebx],eax
	mov     ecx,dword ptr _sr
	and     ecx,0fffffff0h
	or      eax,eax
	jnz     i46noz
	or      ecx,4
	jmp     i46finish
i46noz: jns     i46finish
	or      ecx,8
i46finish:
	mov     dword ptr _sr,ecx
        mov     ebx,ebp
        mov     cl,bh
        and     ebx,0ffh
        and     ecx,0ffh
        mov     eax,40
        add     al,byte ptr _mulstab[ebx]
        add     al,byte ptr _mulstab[ecx]
	ret


;
; MULU.W <ea>,Dx
; 2-reg 3-ea read rout 4-dreg*4+d
; Flag: NZ, X unaffected, V=C=0
;


                ALIGN32

i47_:
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	movzx   ecx,dx
        mov     ebp,edx
	mov     ebx,dword ptr [edi+16]
	mov     eax,dword ptr [ebx]
	movzx   eax,ax
	xor     edx,edx
i47ns:  imul    ecx
	mov     ecx,dword ptr _sr
	and     ecx,0fffffff0h
	or      eax,eax
	jnz     i47noz
	or      ecx,4
	jmp     i47finish
i47noz: jns     i47finish
	or      ecx,8
i47finish:
	mov     dword ptr [ebx],eax
	mov     dword ptr _sr,ecx
        mov     ebx,ebp
        mov     cl,bh
        and     ebx,0ffh
        and     ecx,0ffh
        mov     eax,40
        add     al,byte ptr _mulutab[ebx]
        add     al,byte ptr _mulutab[ecx]
	ret


;
; Instruction NBCD <ea>
; Tableusage 0 - routine  1 - disrout  2 - eareg 3- earead 4- eawrite 5-cycletime
;


                ALIGN32

i48_b_:
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]           ; get operand
	mov     ebp,edx
	call    eax
	movzx   edx,dl
	xor     eax,eax
	mov     ah,byte ptr [_bcd2hex+edx]      ; convert 2 hex
	mov     al,100
	sub     al,ah
	mov     ah,byte ptr _sr
	test    ah,010h
	jz      i48_bnx
	dec     al
i48_bnx:and     ah,0eeh  ; mask  1110 1110
	or      al,al
	jz      i48_bz
	and     ah,0eah
i48_bz: cmp     al,100
	je      i48_bnc
	or      ah,11h
	jmp     i48_bc
i48_bnc:xor     al,al
i48_bc: mov     byte ptr _sr,ah
        and     eax,0ffh
	mov     dl,byte ptr [_hex2bcd+eax]
	mov     eax,dword ptr [edi+16]
	mov     ebx,ebp
	call    eax
	mov     eax,dword ptr [edi+20]
	ret


;
; Instruction NEG <ea>
; Tableusage 0 - routine  1 - disrout  2 - eareg 3- earead 4- eawrite 5-cycletime
; Flag: All, X=C
;


                ALIGN32

i49_b_:
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	neg     dl
	pushfd
	pop     eax
	and     eax,0fffh                   
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     byte ptr _sr,bl
	mov     eax,dword ptr [edi+16]
	mov     ebx,dword ptr [edi+8]
	call    eax
	mov     eax,dword ptr [edi+20]
	ret


                ALIGN32

i49_w_:
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	neg     dx
	pushfd
	pop     eax
	and     eax,0fffh
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     byte ptr _sr,bl             
	mov     eax,dword ptr [edi+16]
	mov     ebx,dword ptr [edi+8]
	call    eax
	mov     eax,dword ptr [edi+20]
	ret


                ALIGN32

i49_l_:
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	neg     edx
	pushfd
	pop     eax
	and     eax,0fffh                   
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     byte ptr _sr,bl             
	mov     eax,dword ptr [edi+16]
	mov     ebx,dword ptr [edi+8]
	call    eax
	mov     eax,dword ptr [edi+20]
	ret


;
; Instruction NEGX <ea>
; Tableusage 0 - routine  1 - disrout  2 - eareg 3- earead 4- eawrite 5-cycletime
; Flag: All, Z unchanged if result is non-zero
;


                ALIGN32

public i50_b_
i50_b_:         mov     eax,dword ptr [edi+12]
                mov     edx,dword ptr [edi+8]
                mov     ebp,edx
                call    eax
                mov     eax,dword ptr _sr
                test    al,10h
                jz      i50_b1
                inc     dl
i50_b1:         neg     dl
                pushfd
                pop     eax
                and     eax,0fbfh                   
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ah,byte ptr [_sr]
                and     ah,4                            ; Preserve Z
                test    dl,dl                           ; Clear if nonzero
                jz      i50bnz
                xor     ah,ah
i50bnz:         or      al,ah
                mov     byte ptr _sr,al              
                mov     eax,dword ptr [edi+16]
                mov     ebx,ebp
                call    eax
                mov     eax,dword ptr [edi+20]
                ret


                ALIGN32
                
public i50_w_
i50_w_:         mov     eax,dword ptr [edi+12]
                mov     edx,dword ptr [edi+8]
                mov     ebp,edx
                call    eax
                mov     eax,dword ptr _sr
                test    al,10h
                jz      i50_w1
                inc     dx
i50_w1:         neg     dx
                pushfd
                pop     eax
                and     eax,0fbfh                   
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ah,byte ptr [_sr]
                and     ah,4                            ; Preserve Z
                test    dx,dx                           ; Clear if nonzero
                jz      i50wnz
                xor     ah,ah
i50wnz:         or      al,ah
                mov     byte ptr _sr,al
                mov     eax,dword ptr [edi+16]
                mov     ebx,ebp
                call    eax
                mov     eax,dword ptr [edi+20]
                ret


                ALIGN32

public i50_l_
i50_l_:         mov     eax,dword ptr [edi+12]
                mov     edx,dword ptr [edi+8]
                mov     ebp,edx
                call    eax
                mov     eax,dword ptr _sr
                test    al,10h
                jz      i50_l1
                inc     edx
i50_l1:         neg     edx
                pushfd
                pop     eax
                and     eax,0fbfh                   
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ah,byte ptr [_sr]
                and     ah,4                            ; Preserve Z
                test    edx,edx                         ; Clear if nonzero
                jz      i50lnz
                xor     ah,ah
i50lnz:         or      al,ah
                mov     byte ptr _sr,al           
                mov     eax,dword ptr [edi+16]
                mov     ebx,ebp
                call    eax
                mov     eax,dword ptr [edi+20]
                ret


;
; NOP
; Flag: NONE
;


                ALIGN32

public i51_
i51_:           mov     eax,4
                ret


;
; Instruction NOT <ea>
; Tableusage 0 - routine  1 - disrout  2 - eareg 3- earead 4- eawrite 5-cycletime
; Flag: NZ, V=C=0, X unaffected
;


                ALIGN32

i52_b_:
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	mov     ebp,edx
	call    eax
	not     dl
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      dl,dl
	js      i52_bn
	jnz     i52_bnz
	or      eax,4
	jmp     i52_bnz
i52_bn: or      eax,8
i52_bnz:mov     dword ptr _sr,eax 
	mov     eax,dword ptr [edi+16]
	mov     ebx,ebp
	call    eax
	mov     eax,dword ptr [edi+20]
	ret


                ALIGN32

i52_w_:
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	mov     ebp,edx
	call    eax
	not     dx
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      dx,dx
	js      i52_wn
	jnz     i52_wnz
	or      eax,4
	jmp     i52_wnz
i52_wn: or      eax,8
i52_wnz:mov     dword ptr _sr,eax
	mov     eax,dword ptr [edi+16]
	mov     ebx,ebp
	call    eax
	mov     eax,dword ptr [edi+20]
	ret


                ALIGN32

i52_l_:
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	mov     ebp,edx
	call    eax
	not     edx
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      edx,edx
	js      i52_ln
	jnz     i52_lnz
	or      eax,4
	jmp     i52_lnz
i52_ln: or      eax,8
i52_lnz:mov     dword ptr _sr,eax
	mov     eax,dword ptr [edi+16]
	mov     ebx,ebp
	call    eax
	mov     eax,dword ptr [edi+20]
	ret


;
; OR.X <ea>,Dn / OR.X Dn,<ea>
; Flagg: X unaffected, N Z, V = C = 0
;


                ALIGN32

i53_B_1_:
	mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
        call    eax
	mov     ebx,dword ptr [edi+16]
        mov     ecx,dword ptr [ebx]
	or      cl,dl
	pushfd
	pop     eax
	and     eax,07feh
	mov     dword ptr [ebx],ecx
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     dword ptr _sr,eax
	mov     eax,dword ptr [edi+20]
	ret


                ALIGN32

i53_W_1_:
	mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
        call    eax
	mov     ebx,dword ptr [edi+16]
        mov     ecx,dword ptr [ebx]
	or      cx,dx
	pushfd
	pop     eax
	and     eax,07feh
	mov     dword ptr [ebx],ecx
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     dword ptr _sr,eax
	mov     eax,dword ptr [edi+20]
	ret


                ALIGN32

i53_L_1_:
	mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
        call    eax
	mov     ebx,dword ptr [edi+16]
        mov     ecx,dword ptr [ebx]
	or      ecx,edx
	pushfd
	pop     eax
	and     eax,07feh
	mov     dword ptr [ebx],ecx
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     dword ptr _sr,eax
	mov     eax,dword ptr [edi+20]
	ret


                ALIGN32

i53_B_2_:
	mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
        call    eax
	mov     ebx,dword ptr [edi+16]
        mov     dh,byte ptr [ebx]
	or	dl,dh
	pushfd
	pop     eax
	and     eax,07feh
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     ecx,dword ptr [edi+24]
	mov     dword ptr _sr,eax
	mov     ebx,dword ptr [edi+8]
	call    ecx
	mov     eax,dword ptr [edi+20]
	ret


                ALIGN32

i53_W_2_:
	mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
        call    eax
	mov     ebx,dword ptr [edi+16]
        mov     ecx,dword ptr [ebx]
	or      dx,cx
	pushfd
	pop     eax
	and     eax,07feh
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     ecx,dword ptr [edi+24]
	mov     dword ptr _sr,eax
	mov     ebx,dword ptr [edi+8]
	call    ecx
	mov     eax,dword ptr [edi+20]
	ret


                ALIGN32

i53_L_2_:
	mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
        call    eax
	mov     ebx,dword ptr [edi+16]
        mov     ecx,dword ptr [ebx]
	or      edx,ecx
	pushfd
	pop     eax
	and     eax,07feh
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     ecx,dword ptr [edi+24]
	mov     dword ptr _sr,eax
	mov     ebx,dword ptr [edi+8]
	call    ecx
	mov     eax,dword ptr [edi+20]
	ret


;
; ORI.X #,<ea>
; Flagg: X unaffected, N Z, V = C = 0
;


                ALIGN32

i54_B_:
        mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
        call    eax
	or      dl,bl
	pushfd
	pop     eax
	and     eax,07feh
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     ecx,dword ptr [edi+20]
	mov     dword ptr _sr,eax
	mov     ebx,dword ptr [edi+8]
	call    ecx
	mov     eax,dword ptr [edi+16]
	ret


                ALIGN32

i54_W_:
        mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
        call    eax
	or      dx,bx
	pushfd
	pop     eax
	and     eax,07feh
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     ecx,dword ptr [edi+20]
	mov     dword ptr _sr,eax
	mov     ebx,dword ptr [edi+8]
	call    ecx
	mov     eax,dword ptr [edi+16]
	ret


                ALIGN32

i54_L_:
        mov     ecx,esi
        fetchlopcode_inc_pos
	add     esi,4
	mov     ebx,edx
	mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
        call    eax
	or      edx,ebx
	pushfd
	pop     eax
	and     eax,07feh
	mov     ebx,dword ptr [_statustab+4*eax]
	mov     eax,dword ptr _sr
	and     eax,0fffffff0h
	or      eax,ebx
	mov     ecx,dword ptr [edi+20]
	mov     dword ptr _sr,eax
	mov     ebx,dword ptr [edi+8]
	call    ecx
	mov     eax,dword ptr [edi+16]
	ret


                ALIGN32

i54_B_CCR_:
	mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     eax,dword ptr _sr
	or      al,dl
	mov     dword ptr _sr,eax
	mov     eax,20
	ret


                ALIGN32

i54_W_SR_:
        test    byte ptr _sr+1,020h
        jz      privilegie_violation
	mov     ecx,esi
        fetchwopcode_inc_pos
	add     esi,2
	mov     eax,dword ptr _sr
	or      eax,edx
	mov     edx,eax
	call    updateSR
	mov     eax,20
	ret

;
; Instruction PEA <ea>
; Tableusage 0 - routine  1 - disrout  2 - eareg 3- eacalcrout 4- cycle time
;


                ALIGN32

i55_:
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	mov     ecx,dword ptr [_a+28]
	sub     ecx,4
	mov     dword ptr [_a+28],ecx
        writel
	mov     eax,dword ptr [edi+16]
	ret


;
; RESET (Probably wrong)
;


                ALIGN32

i56_:
        mov     ecx,0f80004h
        fetchl
        mov     esi,edx
        PC_TO_PTR esi
#ifdef PREFETCH
        call    prefetch_fill_
#endif
	pushad
	call	memoryEmemCardsReset_
	popad
	
	mov     eax,132
	ret


;
; ROX.X
; Tableusage:(imm) 0-rout 1-disrout 2-shcount 3-dreg 4-cyclecount
; Tableusage:(reg) 0-rout 1-disrout 2-shcountreg 3-dreg 4-cyclecount
; Tableusage:(mem) 0-rout 1-disrout 2-eareg 3-earead 4-eawrite 5-cyclecount
;

; Immediate rotates do not have the problems with count > 31, or zero
; rotates.


                ALIGN32

i57_RI_I_B_:    mov     ecx,dword ptr [edi+8]           ; get shcount
                mov     ebx,dword ptr [edi+12]          ; get dreg ptr
                mov     eax,dword ptr [ebx]             ; get dreg content
                mov     ch,byte ptr [_sr]
                and     ch,10h
                ror     al,cl
                jnc     i57ribnocs
                or      ch,1
i57ribnocs:     test    al,al
                jz      i57rib1
                jns     i57rib2
                or      ch,8                            ; set N flag
                jmp     i57rib2
i57rib1:        or      ch,4                            ; set Z flag
i57rib2:        mov     byte ptr [_sr],ch               ; Store flags
                mov     byte ptr [ebx],al
                mov     eax,dword ptr [edi+16]
                ret


                ALIGN32

i57_RI_I_W_:    mov     ecx,dword ptr [edi+8]           ; get shcount
                mov     ebx,dword ptr [edi+12]          ; get dreg ptr
                mov     eax,dword ptr [ebx]             ; get dreg content
                mov     ch,byte ptr _sr
                and     ch,10h
                ror     ax,cl
                jnc     i57riwnocs
                or      ch,1
i57riwnocs:     test    ax,ax
                jz      i57riw1
                jns     i57riw2
                or      ch,8                            ; set N flag
                jmp     i57riw2
i57riw1:        or      ch,4                            ; set Z flag
i57riw2:        mov     byte ptr [_sr],ch               ; Store flags
                mov     word ptr [ebx],ax
                mov     eax,dword ptr [edi+16]
                ret


                ALIGN32

i57_RI_I_L_:    mov     ecx,dword ptr [edi+8]           ; get shcount
                mov     ebx,dword ptr [edi+12]          ; get dreg ptr
                mov     eax,dword ptr [ebx]             ; get dreg content
                mov     ch,byte ptr [_sr]
                and     ch,10h
                ror     eax,cl
                jnc     i57rilnocs
                or      ch,1
i57rilnocs:     test    eax,eax
                jz      i57ril1
                jns     i57ril2
                or      ch,8                            ; set N flag
                jmp     i57ril2
i57ril1:        or      ch,4                            ; set Z flag
i57ril2:        mov     byte ptr [_sr],ch               ; Store flags
                mov     dword ptr [ebx],eax
                mov     eax,dword ptr [edi+16]
                ret


                ALIGN32

i57_LE_I_B_:    mov     ecx,dword ptr [edi+8]           ; get shcount
                mov     ebx,dword ptr [edi+12]          ; get dreg ptr
                mov     eax,dword ptr [ebx]             ; get dreg content
                mov     ch,byte ptr [_sr]
                and     ch,10h
                rol     al,cl
                jnc     i57libnocs
                or      ch,1
i57libnocs:     test    al,al
                jz      i57lib1
                jns     i57lib2
                or      ch,8                            ; set N flag
                jmp     i57lib2
i57lib1:        or      ch,4                            ; set Z flag
i57lib2:        mov     byte ptr [_sr],ch               ; Store flags
                mov     byte ptr [ebx],al
                mov     eax,dword ptr [edi+16]
                ret


                ALIGN32

i57_LE_I_W_:    mov     ecx,dword ptr [edi+8]           ; get shcount
                mov     ebx,dword ptr [edi+12]          ; get dreg ptr
                mov     eax,dword ptr [ebx]             ; get dreg content
                mov     ch,byte ptr [_sr]
                and     ch,10h
                rol     ax,cl
                jnc     i57liwnocs
                or      ch,1
i57liwnocs:     test    ax,ax
                jz      i57liw1
                jns     i57liw2
                or      ch,8                            ; set N flag
                jmp     i57liw2
i57liw1:        or      ch,4                            ; set Z flag
i57liw2:        mov     byte ptr [_sr],ch               ; Store flags
                mov     word ptr [ebx],ax
                mov     eax,dword ptr [edi+16]
                ret


                ALIGN32

i57_LE_I_L_:    mov     ecx,dword ptr [edi+8]           ; get shcount
                mov     ebx,dword ptr [edi+12]          ; get dreg ptr
                mov     eax,dword ptr [ebx]             ; get dreg content
                mov     ch,byte ptr [_sr]
                and     ch,10h
                rol     eax,cl
                jnc     i57lilnocs
                or      ch,1
i57lilnocs:     test    eax,eax
                jz      i57lil1
                jns     i57lil2
                or      ch,8                            ; set N flag
                jmp     i57lil2
i57lil1:        or      ch,4                            ; set Z flag
i57lil2:        mov     byte ptr [_sr],ch               ; Store flags
                mov     dword ptr [ebx],eax
                mov     eax,dword ptr [edi+16]
                ret


                ALIGN32


i57_RI_R_B_:    mov     ecx,dword ptr [edi+8]   ; get shcount reg ptr
                mov     ebx,dword ptr [edi+12]  ; get dreg ptr
                mov     ecx,dword ptr [ecx]     ; get shcount reg content
                mov     eax,dword ptr [ebx]     ; get dreg content
                and     ecx,3fh                 ; modulo 64
                jz      i57rrbzero
                push    ecx
                mov     ch,byte ptr [_sr]
                and     ch,010h
i57rrb7:        cmp     cl,20h                  ; Run several passes of 31
                jb      i57rrbok                ; until count < 32
                mov     dl,cl                   
                mov     cl,31                   ; rotate 31 
                sub     dl,cl
                ror     al,cl
                mov     cl,dl
                jmp     i57rrb7
i57rrbok:       ror     al,cl
                jnc     i57rrbnocs
                or      ch,1
i57rrbnocs:     pop     ebp
                add     ebp,ebp
                add     ebp,dword ptr [edi+16]
                test    al,al
                jz      i57rrb1
                jns     i57rrb2
                or      ch,8                    ; set N flag
                jmp     i57rrb2
i57rrb1:        or      ch,4                    ; set Z flag
i57rrb2:        mov     byte ptr [_sr],ch       ; Store flags
                mov     byte ptr [ebx],al
                mov     eax,ebp
                ret

i57rrbzero:     mov     cl,byte ptr [_sr]       ; rotate zero positions
                and     cl,010h                 ; al is data
                test    al,al
                jz      i57rrbzero2
                jns     i57rrbzero3
                or      cl,8                    ; set N flag
                jmp     i57rrbzero3
i57rrbzero2:    or      cl,4                    ; set Z flag
i57rrbzero3:    mov     byte ptr [_sr],cl       ; Store flags
                mov     eax,dword ptr [edi + 16]
                ret


                ALIGN32


i57_RI_R_W_:    mov     ecx,dword ptr [edi+8]   ; get shcount reg ptr
                mov     ebx,dword ptr [edi+12]  ; get dreg ptr
                mov     ecx,dword ptr [ecx]     ; get shcount reg content
                mov     eax,dword ptr [ebx]     ; get dreg content
                and     ecx,3fh                 ; modulo 64
                jz      i57rrwzero
                push    ecx
                mov     ch,byte ptr [_sr]
                and     ch,10h
i57rrw7:        cmp     cl,20h                  ; Run several passes of 31
                jb      i57rrwok                ; until count < 32
                mov     dl,cl                   
                mov     cl,31                   ; rotate 31 
                sub     dl,cl
                ror     ax,cl
                mov     cl,dl
                jmp     i57rrw7
i57rrwok:       ror     ax,cl
                jnc     i57rrwnocs
                or      ch,1
i57rrwnocs:     pop     ebp
                add     ebp,ebp
                add     ebp,dword ptr [edi+16]
                test    ax,ax
                jz      i57rrw1
                jns     i57rrw2
                or      ch,8                    ; set N flag
                jmp     i57rrw2
i57rrw1:        or      ch,4                    ; set Z flag
i57rrw2:        mov     byte ptr [_sr],ch       ; Store flags
                mov     word ptr [ebx],ax
                mov     eax,ebp
                ret

i57rrwzero:     mov     cl,byte ptr [_sr]       ; rotate zero positions
                and     cl,010h                 ; ax is data
                test    ax,ax
                jz      i57rrwzero2
                jns     i57rrwzero3
                or      cl,8                    ; set N flag
                jmp     i57rrwzero3
i57rrwzero2:    or      cl,4                    ; set Z flag
i57rrwzero3:    mov     byte ptr [_sr],cl       ; Store flags
                mov     eax,dword ptr [edi + 16]
                ret


                ALIGN32


i57_RI_R_L_:    mov     ecx,dword ptr [edi+8]   ; get shcount reg ptr
                mov     ebx,dword ptr [edi+12]  ; get dreg ptr
                mov     ecx,dword ptr [ecx]     ; get shcount reg content
                mov     eax,dword ptr [ebx]     ; get dreg content
                and     ecx,3fh                 ; modulo 64
                jz      i57rrlzero
                push    ecx
                mov     ch,byte ptr [_sr]
                and     ch,10h
i57rrl7:        cmp     cl,20h                  ; Run several passes of 31
                jb      i57rrlok                ; until count < 32
                mov     dl,cl                   
                mov     cl,31                   ; rotate 31 
                sub     dl,cl
                ror     eax,cl
                mov     cl,dl                   ; Update rotate count
                jmp     i57rrl7
i57rrlok:       ror     eax,cl
                jnc     i57rrlnocs
                or      ch,1
i57rrlnocs:     pop     ebp
                add     ebp,ebp
                add     ebp,dword ptr [edi+16]
                test    eax,eax
                jz      i57rrl1
                jns     i57rrl2
                or      ch,8                    ; set N flag
                jmp     i57rrl2
i57rrl1:        or      ch,4                    ; set Z flag
i57rrl2:        mov     byte ptr [_sr],ch       ; Store flags
                mov     dword ptr [ebx],eax
                mov     eax,ebp
                ret

i57rrlzero:     mov     cl,byte ptr [_sr]       ; rotate zero positions
                and     cl,010h                 ; eax is data
                test    eax,eax
                jz      i57rrlzero2
                jns     i57rrlzero3
                or      cl,8                    ; set N flag
                jmp     i57rrlzero3
i57rrlzero2:    or      cl,4                    ; set Z flag
i57rrlzero3:    mov     byte ptr [_sr],cl       ; Store flags
                mov     eax,dword ptr [edi + 16]
                ret


                ALIGN32


i57_LE_R_B_:    mov     ecx,dword ptr [edi+8]   ; get shcount reg ptr
                mov     ebx,dword ptr [edi+12]  ; get dreg ptr
                mov     ecx,dword ptr [ecx]     ; get shcount reg content
                mov     eax,dword ptr [ebx]     ; get dreg content
                and     ecx,3fh                 ; modulo 64
                jz      i57lrbzero
                push    ecx
                mov     ch,byte ptr [_sr]
                and     ch,10h
i57lrb7:        cmp     cl,20h                  ; Run several passes of 31
                jb      i57lrbok                ; until count < 32
                mov     dl,cl                   
                mov     cl,31                   ; rotate 31 
                sub     dl,cl
                rol     al,cl
                mov     cl,dl                   ; Update rotate count
                jmp     i57lrb7
i57lrbok:       rol     al,cl
                jnc     i57lrbnocs
                or      ch,1
i57lrbnocs:     pop     ebp
                add     ebp,ebp
                add     ebp,dword ptr [edi+16]
                test    al,al
                jz      i57lrb1
                jns     i57lrb2
                or      ch,8                    ; set N flag
                jmp     i57lrb2
i57lrb1:        or      ch,4                    ; set Z flag
i57lrb2:        mov     byte ptr [_sr],ch       ; Store flags
                mov     byte ptr [ebx],al
                mov     eax,ebp
                ret

i57lrbzero:     mov     cl,byte ptr [_sr]       ; rotate zero positions
                and     cl,010h                 ; al is data
                test    al,al
                jz      i57lrbzero2
                jns     i57lrbzero3
                or      cl,8                    ; set N flag
                jmp     i57lrbzero3
i57lrbzero2:    or      cl,4                    ; set Z flag
i57lrbzero3:    mov     byte ptr [_sr],cl       ; Store flags
                mov     eax,dword ptr [edi + 16]
                ret


                ALIGN32

; Rotate extend Dx to the left with shiftcount in Dy-register

i57_LE_R_W_:    mov     ecx,dword ptr [edi+8]   ; get shcount reg ptr
                mov     ebx,dword ptr [edi+12]  ; get dreg ptr
                mov     ecx,dword ptr [ecx]     ; get shcount reg content
                mov     eax,dword ptr [ebx]     ; get dreg content
                and     ecx,3fh                 ; modulo 64
                jz      i57lrwzero
                push    ecx
                mov     ch,byte ptr [_sr]
                and     ch,10h
i57lrw7:        cmp     cl,20h                  ; Run several passes of 31
                jb      i57lrwok                ; until count < 32
                mov     dl,cl                   
                mov     cl,31                   ; rotate 31 
                sub     dl,cl
                rol     ax,cl
                mov     cl,dl                   ; Update rotate count
                jmp     i57lrw7
i57lrwok:       rol     ax,cl
                jnc     i57lrwnocs
                or      ch,1
i57lrwnocs:     pop     ebp
                add     ebp,ebp
                add     ebp,dword ptr [edi+16]
                test    ax,ax
                jz      i57lrw1
                jns     i57lrw2
                or      ch,8                    ; set N flag
                jmp     i57lrw2
i57lrw1:        or      ch,4                    ; set Z flag
i57lrw2:        mov     byte ptr [_sr],ch       ; Store flags
                mov     word ptr [ebx],ax
                mov     eax,ebp
                ret

i57lrwzero:     mov     cl,byte ptr [_sr]       ; rotate zero positions
                and     cl,010h                 ; ax is data
                test    ax,ax
                jz      i57lrwzero2
                jns     i57lrwzero3
                or      cl,8                    ; set N flag
                jmp     i57lrwzero3
i57lrwzero2:    or      cl,4                    ; set Z flag
i57lrwzero3:    mov     byte ptr [_sr],cl       ; Store flags
                mov     eax,dword ptr [edi + 16]
                ret


                ALIGN32

; Rotate extend Dx to the left with shiftcount in Dy-register

i57_LE_R_L_:    mov     ecx,dword ptr [edi+8]   ; get shcount reg ptr
                mov     ebx,dword ptr [edi+12]  ; get dreg ptr
                mov     ecx,dword ptr [ecx]     ; get shcount reg content
                mov     eax,dword ptr [ebx]     ; get dreg content
                and     ecx,3fh                 ; modulo 64
                jz      i57lrlzero
                push    ecx
                mov     ch,byte ptr [_sr]
                and     ch,10h
i57lrl7:        cmp     cl,20h                  ; Run several passes of 31
                jb      i57lrlok                ; until count < 32
                mov     dl,cl                   
                mov     cl,31                   ; rotate 31 
                sub     dl,cl
                rol     eax,cl
                mov     cl,dl                   ; Update rotate count
                jmp     i57lrl7
i57lrlok:       rol     eax,cl
                jnc     i57lrlnocs
                or      ch,1
i57lrlnocs:     pop     ebp
                add     ebp,ebp
                add     ebp,dword ptr [edi+16]
                test    eax,eax
                jz      i57lrl1
                jns     i57lrl2
                or      ch,8                    ; set N flag
                jmp     i57lrl2
i57lrl1:        or      ch,4                    ; set Z flag
i57lrl2:        mov     byte ptr [_sr],ch       ; Store flags
                mov     dword ptr [ebx],eax
                mov     eax,ebp
                ret

i57lrlzero:     mov     cl,byte ptr [_sr]       ; rotate zero positions
                and     cl,010h                 ; eax is data
                test    eax,eax
                jz      i57lrlzero2
                jns     i57lrlzero3
                or      cl,8                    ; set N flag
                jmp     i57lrlzero3
i57lrlzero2:    or      cl,4                    ; set Z flag
i57lrlzero3:    mov     byte ptr [_sr],cl       ; Store flags
                mov     eax,dword ptr [edi + 16]
                ret


                ALIGN32

; Rotate extend memory word 1 to the right

i57_RI_M_W_:    mov     ebx,dword ptr [edi+8]           ; get ea reg ptr
                mov     edx,ebx
                mov     eax,dword ptr [edi+12]          ; get ea read rout
                call    eax
                mov     al,byte ptr [_sr]
                and     al,010h
                ror     dx,1
                jnc     i57rmwnocs
                or      al,1
i57rmwnocs:     test    dx,dx
                jz      i57rmw1
                jns     i57rmw2
                or      al,8                            ; set N flag
                jmp     i57rmw2
i57rmw1:        or      al,4                            ; set Z flag
i57rmw2:        mov     byte ptr [_sr],al               ; Store flags
                mov     eax,dword ptr [edi+16]
                call    eax     
                mov     eax,dword ptr [edi+20]
                ret


                ALIGN32

; Rotate extend memory word 1 to the left.

i57_LE_M_W_:    mov     ebx,dword ptr [edi+8]              ; get ea reg ptr
                mov     edx,ebx
                mov     eax,dword ptr [edi+12]             ; get ea read rout
                call    eax
                mov     al,byte ptr [_sr]
                and     al,10h
                rol     dx,1
                jnc     i57lmwnocs
                or      al,1                               ; Clear C and X
i57lmwnocs:     test    dx,dx
                jz      i57lmw1
                jns     i57lmw2
                or      al,8                               ; set N flag
                jmp     i57lmw2
i57lmw1:        or      al,4                               ; set Z flag
i57lmw2:        mov     byte ptr [_sr],al                  ; Store flags
                mov     eax,dword ptr [edi+16]
                call    eax     
                mov     eax,dword ptr [edi+20]
                ret


;
; ROXX.X
; Tableusage:(imm) 0-rout 1-disrout 2-shcount 3-dreg 4-cyclecount
; Tableusage:(reg) 0-rout 1-disrout 2-shcountreg 3-dreg 4-cyclecount
; Tableusage:(mem) 0-rout 1-disrout 2-eareg 3-earead 4-eawrite 5-cyclecount
;

; Immediate rotates do not have the problems with count > 31, or zero
; rotates.


                ALIGN32

i59_RI_I_B_:    mov     ecx,dword ptr [edi+8]           ; get shcount
                mov     ebx,dword ptr [edi+12]          ; get dreg ptr
                mov     eax,dword ptr [ebx]             ; get dreg content
                mov     ch,byte ptr [_sr]
                test    ch,10h
                jz      i59rib3
                stc
i59rib3:        rcr     al,cl
                jc      i59ribcs
                xor     ch,ch
                jmp     i59ribnocs
i59ribcs:       mov     ch,11h
i59ribnocs:     test    al,al
                jz      i59rib1
                jns     i59rib2
                or      ch,8                            ; set N flag
                jmp     i59rib2
i59rib1:        or      ch,4                            ; set Z flag
i59rib2:        mov     byte ptr [_sr],ch               ; Store flags
                mov     byte ptr [ebx],al
                mov     eax,dword ptr [edi+16]
                ret


                ALIGN32

i59_RI_I_W_:    mov     ecx,dword ptr [edi+8]           ; get shcount
                mov     ebx,dword ptr [edi+12]          ; get dreg ptr
                mov     eax,dword ptr [ebx]             ; get dreg content
                mov     ch,byte ptr _sr
                test    ch,10h
                jz      i59riw3
                stc
i59riw3:        rcr     ax,cl
                jc      i59riwcs
                xor     ch,ch
                jmp     i59riwnocs
i59riwcs:       mov     ch,11h
i59riwnocs:     test    ax,ax
                jz      i59riw1
                jns     i59riw2
                or      ch,8                            ; set N flag
                jmp     i59riw2
i59riw1:        or      ch,4                            ; set Z flag
i59riw2:        mov     byte ptr [_sr],ch               ; Store flags
                mov     word ptr [ebx],ax
                mov     eax,dword ptr [edi+16]
                ret


                ALIGN32

i59_RI_I_L_:    mov     ecx,dword ptr [edi+8]           ; get shcount
                mov     ebx,dword ptr [edi+12]          ; get dreg ptr
                mov     eax,dword ptr [ebx]             ; get dreg content
                mov     ch,byte ptr [_sr]
                test    ch,10h
                jz      i59ril3
                stc
i59ril3:        rcr     eax,cl
                jc      i59rilcs
                xor     ch,ch
                jmp     i59rilnocs
i59rilcs: 	mov     ch,11h
i59rilnocs:     test    eax,eax
                jz      i59ril1
                jns     i59ril2
                or      ch,8                            ; set N flag
                jmp     i59ril2
i59ril1:        or      ch,4                            ; set Z flag
i59ril2:        mov     byte ptr [_sr],ch               ; Store flags
                mov     dword ptr [ebx],eax
                mov     eax,dword ptr [edi+16]
                ret


                ALIGN32

i59_LE_I_B_:    mov     ecx,dword ptr [edi+8]           ; get shcount
                mov     ebx,dword ptr [edi+12]          ; get dreg ptr
                mov     eax,dword ptr [ebx]             ; get dreg content
                mov     ch,byte ptr [_sr]
                test    ch,10h
                jz      i59lib3
                stc
i59lib3:        rcl     al,cl
                jc      i59libcs
                xor     ch,ch
                jmp     i59libnocs
i59libcs:	mov     ch,11h
i59libnocs:     test    al,al
                jz      i59lib1
                jns     i59lib2
                or      ch,8                            ; set N flag
                jmp     i59lib2
i59lib1:        or      ch,4                            ; set Z flag
i59lib2:        mov     byte ptr [_sr],ch               ; Store flags
                mov     byte ptr [ebx],al
                mov     eax,dword ptr [edi+16]
                ret


                ALIGN32

i59_LE_I_W_:    mov     ecx,dword ptr [edi+8]           ; get shcount
                mov     ebx,dword ptr [edi+12]          ; get dreg ptr
                mov     eax,dword ptr [ebx]             ; get dreg content
                mov     ch,byte ptr [_sr]
                test    ch,10h
                jz      i59liw3
                stc
i59liw3:        rcl     ax,cl
                jc      i59liwcs
                xor     ch,ch
                jmp     i59liwnocs
i59liwcs:       mov     ch,11h
i59liwnocs:     test    ax,ax
                jz      i59liw1
                jns     i59liw2
                or      ch,8                            ; set N flag
                jmp     i59liw2
i59liw1:        or      ch,4                            ; set Z flag
i59liw2:        mov     byte ptr [_sr],ch               ; Store flags
                mov     word ptr [ebx],ax
                mov     eax,dword ptr [edi+16]
                ret


                ALIGN32

i59_LE_I_L_:    mov     ecx,dword ptr [edi+8]           ; get shcount
                mov     ebx,dword ptr [edi+12]          ; get dreg ptr
                mov     eax,dword ptr [ebx]             ; get dreg content
                mov     ch,byte ptr [_sr]
                test    ch,10h
                jz      i59lil3
                stc
i59lil3:        rcl     eax,cl
                jc      i59lilcs
                xor     ch,ch
                jmp     i59lilnocs
i59lilcs: 	mov     ch,11h
i59lilnocs:     test    eax,eax
                jz      i59lil1
                jns     i59lil2
                or      ch,8                            ; set N flag
                jmp     i59lil2
i59lil1:        or      ch,4                            ; set Z flag
i59lil2:        mov     byte ptr [_sr],ch               ; Store flags
                mov     dword ptr [ebx],eax
                mov     eax,dword ptr [edi+16]
                ret


                ALIGN32

; Rotate extend Dx to the left with shiftcount in Dy-register

i59_RI_R_B_:    mov     ecx,dword ptr [edi+8]   ; get shcount reg ptr
                mov     ebx,dword ptr [edi+12]  ; get dreg ptr
                mov     ecx,dword ptr [ecx]     ; get shcount reg content
                mov     eax,dword ptr [ebx]     ; get dreg content
                and     ecx,3fh                 ; modulo 64
                jz      i59rrbzero
                push    ecx
                mov     ch,byte ptr [_sr]
i59rrb7:        cmp     cl,20h                  ; Run several passes of 31                  
                jb      i59rrbok                ; until count < 32
                mov     dl,cl                   
                mov     cl,31                   ; rotate 31 
                sub     dl,cl
                test    ch,10h
                jz      i59rrbext
                stc
i59rrbext:      rcr     al,cl
                jc      i59rrb6                 
                xor     ch,ch                   ; Clear XC
                mov     cl,dl                   ; Update rotate count
                jmp     i59rrb7
i59rrb6:        mov     ch,11h                  ; Set XC
                mov     cl,dl                   ; Update rotate count
                jmp     i59rrb7
i59rrbok:       test    ch,10h                  ; The final rotate pass
                jz      i59rrb3
                stc
i59rrb3:        rcr     al,cl
                jc      i59rrbcs
                xor     ch,ch
                jmp     i59rrbnocs
i59rrbcs:       mov     ch,11h
i59rrbnocs:     pop     ebp
                add     ebp,ebp
                add     ebp,dword ptr [edi+16]
                test    al,al
                jz      i59rrb1
                jns     i59rrb2
                or      ch,8                    ; set N flag
                jmp     i59rrb2
i59rrb1:        or      ch,4                    ; set Z flag
i59rrb2:        mov     byte ptr [_sr],ch       ; Store flags
                mov     byte ptr [ebx],al
                mov     eax,ebp
                ret

i59rrbzero:     mov     cl,byte ptr [_sr]       ; rotate zero positions
                and     cl,010h                 ; al is data
                jz      i59rrbzero1
                or      cl,1                    ; Set C to X
i59rrbzero1:    test    al,al
                jz      i59rrbzero2
                jns     i59rrbzero3
                or      cl,8                    ; set N flag
                jmp     i59rrbzero3
i59rrbzero2:    or      cl,4                    ; set Z flag
i59rrbzero3:    mov     byte ptr [_sr],cl       ; Store flags
                mov     eax,dword ptr [edi + 16]
                ret


                ALIGN32

; Rotate extend Dx to the left with shiftcount in Dy-register

i59_RI_R_W_:    mov     ecx,dword ptr [edi+8]   ; get shcount reg ptr
                mov     ebx,dword ptr [edi+12]  ; get dreg ptr
                mov     ecx,dword ptr [ecx]     ; get shcount reg content
                mov     eax,dword ptr [ebx]     ; get dreg content
                and     ecx,3fh                 ; modulo 64
                jz      i59rrwzero
                push    ecx
                mov     ch,byte ptr [_sr]
i59rrw7:        cmp     cl,20h                  ; Run several passes of 31                  
                jb      i59rrwok                ; until count < 32
                mov     dl,cl                   
                mov     cl,31                   ; rotate 31 
                sub     dl,cl
                test    ch,10h
                jz      i59rrwext
                stc
i59rrwext:      rcr     ax,cl
                jc      i59rrw6                 
                xor     ch,ch                   ; Clear XC
                mov     cl,dl                   ; Update rotate count
                jmp     i59rrw7
i59rrw6:        mov     ch,11h                  ; Set XC
                mov     cl,dl                   ; Update rotate count
                jmp     i59rrw7
i59rrwok:       test    ch,10h                  ; The final rotate pass
                jz      i59rrw3
                stc
i59rrw3:        rcr     ax,cl
                jc      i59rrwcs
                xor     ch,ch
                jmp     i59rrwnocs
i59rrwcs:       mov     ch,11h
i59rrwnocs:     pop     ebp
                add     ebp,ebp
                add     ebp,dword ptr [edi+16]
                test    ax,ax
                jz      i59rrw1
                jns     i59rrw2
                or      ch,8                    ; set N flag
                jmp     i59rrw2
i59rrw1:        or      ch,4                    ; set Z flag
i59rrw2:        mov     byte ptr [_sr],ch       ; Store flags
                mov     word ptr [ebx],ax
                mov     eax,ebp
                ret

i59rrwzero:     mov     cl,byte ptr [_sr]       ; rotate zero positions
                and     cl,010h                 ; ax is data
                jz      i59rrwzero1
                or      cl,1                    ; Set C to X
i59rrwzero1:    test    ax,ax
                jz      i59rrwzero2
                jns     i59rrwzero3
                or      cl,8                    ; set N flag
                jmp     i59rrwzero3
i59rrwzero2:    or      cl,4                    ; set Z flag
i59rrwzero3:    mov     byte ptr [_sr],cl       ; Store flags
                mov     eax,dword ptr [edi + 16]
                ret


                ALIGN32

; Rotate extend Dx to the left with shiftcount in Dy-register

i59_RI_R_L_:    mov     ecx,dword ptr [edi+8]   ; get shcount reg ptr
                mov     ebx,dword ptr [edi+12]  ; get dreg ptr
                mov     ecx,dword ptr [ecx]     ; get shcount reg content
                mov     eax,dword ptr [ebx]     ; get dreg content
                and     ecx,3fh                 ; modulo 64
                jz      i59rrlzero
                push    ecx
                mov     ch,byte ptr [_sr]
i59rrl7:        cmp     cl,20h                  ; Run several passes of 31                  
                jb      i59rrlok                ; until count < 32
                mov     dl,cl                   
                mov     cl,31                   ; rotate 31 
                sub     dl,cl
                test    ch,10h
                jz      i59rrlext
                stc
i59rrlext:      rcr     eax,cl
                jc      i59rrl6                 
                xor     ch,ch                   ; Clear XC
                mov     cl,dl                   ; Update rotate count
                jmp     i59rrl7
i59rrl6:        mov     ch,11h                  ; Set XC
                mov     cl,dl                   ; Update rotate count
                jmp     i59rrl7
i59rrlok:       test    ch,10h                  ; The final rotate pass
                jz      i59rrl3
                stc
i59rrl3:        rcr     eax,cl
                jc      i59rrlcs
                xor     ch,ch
                jmp     i59rrlnocs
i59rrlcs:       mov     ch,11h
i59rrlnocs:     pop     ebp
                add     ebp,ebp
                add     ebp,dword ptr [edi+16]
                test    eax,eax
                jz      i59rrl1
                jns     i59rrl2
                or      ch,8                    ; set N flag
                jmp     i59rrl2
i59rrl1:        or      ch,4                    ; set Z flag
i59rrl2:        mov     byte ptr [_sr],ch       ; Store flags
                mov     dword ptr [ebx],eax
                mov     eax,ebp
                ret

i59rrlzero:     mov     cl,byte ptr [_sr]       ; rotate zero positions
                and     cl,010h                 ; eax is data
                jz      i59rrlzero1
                or      cl,1                    ; Set C to X
i59rrlzero1:    test    eax,eax
                jz      i59rrlzero2
                jns     i59rrlzero3
                or      cl,8                    ; set N flag
                jmp     i59rrlzero3
i59rrlzero2:    or      cl,4                    ; set Z flag
i59rrlzero3:    mov     byte ptr [_sr],cl       ; Store flags
                mov     eax,dword ptr [edi + 16]
                ret


                ALIGN32

; Rotate extend Dx to the left with shiftcount in Dy-register

i59_LE_R_B_:    mov     ecx,dword ptr [edi+8]   ; get shcount reg ptr
                mov     ebx,dword ptr [edi+12]  ; get dreg ptr
                mov     ecx,dword ptr [ecx]     ; get shcount reg content
                mov     eax,dword ptr [ebx]     ; get dreg content
                and     ecx,3fh                 ; modulo 64
                jz      i59lrbzero
                push    ecx
                mov     ch,byte ptr [_sr]
i59lrb7:        cmp     cl,20h                  ; Run several passes of 31                  
                jb      i59lrbok                ; until count < 32
                mov     dl,cl                   
                mov     cl,31                   ; rotate 31 
                sub     dl,cl
                test    ch,10h
                jz      i59lrbext
                stc
i59lrbext:      rcl     al,cl
                jc      i59lrb6                 
                xor     ch,ch                   ; Clear XC
                mov     cl,dl                   ; Update rotate count
                jmp     i59lrb7
i59lrb6:        mov     ch,11h                  ; Set XC
                mov     cl,dl                   ; Update rotate count
                jmp     i59lrb7
i59lrbok:       test    ch,10h                  ; The final rotate pass
                jz      i59lrb3
                stc
i59lrb3:        rcl     al,cl
                jc      i59lrbcs
                xor     ch,ch
                jmp     i59lrbnocs
i59lrbcs:       mov     ch,11h
i59lrbnocs:     pop     ebp
                add     ebp,ebp
                add     ebp,dword ptr [edi+16]
                test    al,al
                jz      i59lrb1
                jns     i59lrb2
                or      ch,8                    ; set N flag
                jmp     i59lrb2
i59lrb1:        or      ch,4                    ; set Z flag
i59lrb2:        mov     byte ptr [_sr],ch       ; Store flags
                mov     byte ptr [ebx],al
                mov     eax,ebp
                ret

i59lrbzero:     mov     cl,byte ptr [_sr]       ; rotate zero positions
                and     cl,010h                 ; al is data
                jz      i59lrbzero1
                or      cl,1                    ; Set C to X
i59lrbzero1:    test    al,al
                jz      i59lrbzero2
                jns     i59lrbzero3
                or      cl,8                    ; set N flag
                jmp     i59lrbzero3
i59lrbzero2:    or      cl,4                    ; set Z flag
i59lrbzero3:    mov     byte ptr [_sr],cl       ; Store flags
                mov     eax,dword ptr [edi + 16]
                ret


                ALIGN32

; Rotate extend Dx to the left with shiftcount in Dy-register

i59_LE_R_W_:    mov     ecx,dword ptr [edi+8]   ; get shcount reg ptr
                mov     ebx,dword ptr [edi+12]  ; get dreg ptr
                mov     ecx,dword ptr [ecx]     ; get shcount reg content
                mov     eax,dword ptr [ebx]     ; get dreg content
                and     ecx,3fh                 ; modulo 64
                jz      i59lrwzero
                push    ecx
                mov     ch,byte ptr [_sr]
i59lrw7:        cmp     cl,20h                  ; Run several passes of 31                  
                jb      i59lrwok                ; until count < 32
                mov     dl,cl                   
                mov     cl,31                   ; rotate 31 
                sub     dl,cl
                test    ch,10h
                jz      i59lrwext
                stc
i59lrwext:      rcl     ax,cl
                jc      i59lrw6                 
                xor     ch,ch                   ; Clear XC
                mov     cl,dl                   ; Update rotate count
                jmp     i59lrw7
i59lrw6:        mov     ch,11h                  ; Set XC
                mov     cl,dl                   ; Update rotate count
                jmp     i59lrw7
i59lrwok:       test    ch,10h                  ; The final rotate pass
                jz      i59lrw3
                stc
i59lrw3:        rcl     ax,cl
                jc      i59lrwcs
                xor     ch,ch
                jmp     i59lrwnocs
i59lrwcs:       mov     ch,11h
i59lrwnocs:     pop     ebp
                add     ebp,ebp
                add     ebp,dword ptr [edi+16]
                test    ax,ax
                jz      i59lrw1
                jns     i59lrw2
                or      ch,8                    ; set N flag
                jmp     i59lrw2
i59lrw1:        or      ch,4                    ; set Z flag
i59lrw2:        mov     byte ptr [_sr],ch       ; Store flags
                mov     word ptr [ebx],ax
                mov     eax,ebp
                ret

i59lrwzero:     mov     cl,byte ptr [_sr]       ; rotate zero positions
                and     cl,010h                 ; ax is data
                jz      i59lrwzero1
                or      cl,1                    ; Set C to X
i59lrwzero1:    test    ax,ax
                jz      i59lrwzero2
                jns     i59lrwzero3
                or      cl,8                    ; set N flag
                jmp     i59lrwzero3
i59lrwzero2:    or      cl,4                    ; set Z flag
i59lrwzero3:    mov     byte ptr [_sr],cl       ; Store flags
                mov     eax,dword ptr [edi + 16]
                ret


                ALIGN32

; Rotate extend Dx to the left with shiftcount in Dy-register

i59_LE_R_L_:    mov     ecx,dword ptr [edi+8]   ; get shcount reg ptr
                mov     ebx,dword ptr [edi+12]  ; get dreg ptr
                mov     ecx,dword ptr [ecx]     ; get shcount reg content
                mov     eax,dword ptr [ebx]     ; get dreg content
                and     ecx,3fh                 ; modulo 64
                jz      i59lrlzero
                push    ecx
                mov     ch,byte ptr [_sr]
i59lrl7:        cmp     cl,20h                  ; Run several passes of 31                  
                jb      i59lrlok                ; until count < 32
                mov     dl,cl                   
                mov     cl,31                   ; rotate 31 
                sub     dl,cl
                test    ch,10h
                jz      i59lrlext
                stc
i59lrlext:      rcl     eax,cl
                jc      i59lrl6                 
                xor     ch,ch                   ; Clear XC
                mov     cl,dl                   ; Update rotate count
                jmp     i59lrl7
i59lrl6:        mov     ch,11h                  ; Set XC
                mov     cl,dl                   ; Update rotate count
                jmp     i59lrl7
i59lrlok:       test    ch,10h                  ; The final rotate pass
                jz      i59lrl3
                stc
i59lrl3:        rcl     eax,cl
                jc      i59lrlcs
                xor     ch,ch
                jmp     i59lrlnocs
i59lrlcs:       mov     ch,11h
i59lrlnocs:     pop     ebp
                add     ebp,ebp
                add     ebp,dword ptr [edi+16]
                test    eax,eax
                jz      i59lrl1
                jns     i59lrl2
                or      ch,8                    ; set N flag
                jmp     i59lrl2
i59lrl1:        or      ch,4                    ; set Z flag
i59lrl2:        mov     byte ptr [_sr],ch       ; Store flags
                mov     dword ptr [ebx],eax
                mov     eax,ebp
                ret

i59lrlzero:     mov     cl,byte ptr [_sr]       ; rotate zero positions
                and     cl,010h                 ; eax is data
                jz      i59lrlzero1
                or      cl,1                    ; Set C to X
i59lrlzero1:    test    eax,eax
                jz      i59lrlzero2
                jns     i59lrlzero3
                or      cl,8                    ; set N flag
                jmp     i59lrlzero3
i59lrlzero2:    or      cl,4                    ; set Z flag
i59lrlzero3:    mov     byte ptr [_sr],cl       ; Store flags
                mov     eax,dword ptr [edi + 16]
                ret


                ALIGN32

; Rotate extend memory word 1 to the right

i59_RI_M_W_:    mov     ebx,dword ptr [edi+8]           ; get ea reg ptr
                mov     edx,ebx
                mov     eax,dword ptr [edi+12]          ; get ea read rout
                call    eax
                mov     al,byte ptr [_sr]
                test    al,10h                          ; test clears C
                jz      i59rmw3
                stc
i59rmw3:        rcr     dx,1
                jc      i59rmwcs
                xor     al,al
                jmp     i59rmwnocs
i59rmwcs:       mov     al,11h
i59rmwnocs:     test    dx,dx
                jz      i59rmw1
                jns     i59rmw2
                or      al,8                            ; set N flag
                jmp     i59rmw2
i59rmw1:        or      al,4                            ; set Z flag
i59rmw2:        mov     byte ptr [_sr],al               ; Store flags
                mov     eax,dword ptr [edi+16]
                call    eax     
                mov     eax,dword ptr [edi+20]
                ret


                ALIGN32

; Rotate extend memory word 1 to the left.

i59_LE_M_W_:    mov     ebx,dword ptr [edi+8]              ; get ea reg ptr
                mov     edx,ebx
                mov     eax,dword ptr [edi+12]             ; get ea read rout
                call    eax
                mov     al,byte ptr [_sr]
                test    al,10h                             ; test clears C
                jz      i59lmw3
                stc
i59lmw3:        rcl     dx,1
                jc      i59lmwcs
                xor     al,al                              ; Clear C and X
                jmp     i59lmwnocs
i59lmwcs:       mov     al,11h                             ; Set C and X
i59lmwnocs:     test    dx,dx
                jz      i59lmw1
                jns     i59lmw2
                or      al,8                               ; set N flag
                jmp     i59lmw2
i59lmw1:        or      al,4                               ; set Z flag
i59lmw2:        mov     byte ptr [_sr],al                  ; Store flags
                mov     eax,dword ptr [edi+16]
                call    eax     
                mov     eax,dword ptr [edi+20]
                ret


;
; Instruction 61 RTE
; Opcode*32+t i edi
; Flag: From stack
;
;
; step 1:	get SR from frame
; step 2:	get PC from frame
; step 3:	010++, get frame nr.
; step 4:	update stack ptr according to frame nr.
; step 5:	020++, not 060, if throwaway frame, commit SR, redo RTE
; step 6:	commit SR
;

                ALIGN32

public i61_
i61_:           test    byte ptr [_sr + 1], 020h
                jz      privilegie_violation
i61_redo:	mov	ecx, dword ptr [_a + 28]	; Get SR, step 1
		fetchw
		mov	ebp, edx
		mov	ecx, dword ptr [_a + 28]
		add	ecx, 2
		mov	dword ptr [_a + 28], ecx	; Get PC, step 2
		fetchl
		mov	ecx, dword ptr [_a + 28]
		add	ecx, 4
		mov	dword ptr [_a + 28], ecx
#ifdef PREFETCH
		call	prefetch_fill_
#endif
		mov	esi, edx
		PC_TO_PTR esi

		cmp	dword ptr [_config_cpu_type], 0	; step 3 
		je	i61_000
		mov	ecx, dword [_a + 28]		; Get Frame type
		fetchw
		add	ecx, 2
		shr	edx, 12
		and	edx, 0fh
		add	ecx, dword ptr [rte_stackinc + 4*edx]; step 4
		mov	dword ptr [_a + 28], ecx
		cmp	edx, 1				; step 5
		jne	i61_000
		cmp	dword ptr [_config_cpu_type], 2
		jb	i61_000
		cmp	dword ptr [_config_cpu_type], 6
		jae	i61_000
		mov	edx, ebp
		call	updatesr
		jmp	i61_redo
	
i61_000:	mov	edx, ebp			; step 6 
		call	updatesr
		mov	eax, 20
		ret

;
; Instruction 62 RTR
; Opcode*32+t i edi
; Flag: From stack
;


                ALIGN32

public i62_
i62_:           mov     ecx,dword ptr [_a+28]
                fetchw
                and     dl,01fh
                mov     byte ptr [_sr],dl
                add     ecx,2
                mov     dword ptr [_a+28],ecx
                fetchl
                mov     ecx,dword ptr [_a+28]
#ifdef PREFETCH
                call    prefetch_fill_
#endif
                mov     esi,edx
                PC_TO_PTR esi
                add     ecx,4
                mov     dword ptr [_a+28],ecx
                mov     eax,20
                ret


;
; Instruction 63 RTS
; Opcode*32+t i edi
; Flag: NONE
;


                ALIGN32

public i63_
i63_:           mov     ecx,dword ptr [_a+28]
                fetchl
#ifdef PREFETCH
                call    prefetch_fill_
#endif
                mov     esi,edx
                PC_TO_PTR esi
                add     ecx,4
                mov     dword ptr [_a+28],ecx
                mov     eax,16
                ret


;
; Instruction 64   SBCD.B Dy,Dx    SBCD.B -(Ay),-(Ax)
; Tableusage  2 - rx*4(dest)  3 - ry*4
; Opcode*32 i edi
;


                ALIGN32

i64_1_:		mov     ebx,dword ptr [8+edi]
		xor     eax,eax               
		mov     ecx,dword ptr [4+edi] 
		mov     dl,byte ptr [_sr]       
		mov     al,byte ptr [ebx]     
        	xor     ebx,ebx
        	mov     bl,byte ptr [_bcd2hex+eax]
		mov     al,byte ptr [ecx]         
		test    dl,10h                    
		jz      i64_1a                    
		inc     ebx                       
i64_1a: 	mov     al,byte ptr [_bcd2hex+eax]
		sub     eax,ebx                   
		and     dl,0eh                    
		test    eax,eax                   
		jns     i64_1b                    
		or      dl,11h                    
		add     eax,100                   
i64_1b: 	test    al,al                     
		jz      i64_1c                    
		and     dl,01bh                   
i64_1c: 	mov     byte ptr [_sr],dl           
        	and     eax,0ffh
        	mov     al,byte ptr [_hex2bcd+eax]
		mov     byte ptr [ecx],al         
		mov     eax,6 
		ret           


                ALIGN32

i64_2_:		mov     ebx,dword ptr [8+edi]
		mov     ecx,dword ptr [ebx]
		dec     ecx
        	cmp     ebx,dword ptr [_a7pointer]
        	jne     i64_2_j
        	dec     ecx
i64_2_j:	mov     dword ptr [ebx],ecx
		xor     edx,edx
        	fetchb
        	xor     ebx,ebx
		mov     bl,byte ptr [_bcd2hex+edx]
		mov     eax,dword ptr [4+edi]
		mov     ecx,dword ptr [eax]
		dec     ecx
        	cmp     eax,dword ptr [_a7pointer]
        	jne     i64_2_i
        	dec     ecx
i64_2_i:	mov     dword ptr [eax],ecx
		xor     edx,edx
        	fetchb
        	xor     eax,eax
		mov     al,byte ptr [_bcd2hex+edx]
		mov     dl,byte ptr [_sr]    
		test    dl,10h
		jz      i64_2a
		inc     ebx
i64_2a: 	sub     eax,ebx
		and     dl,0eh
		test    eax,eax        
		jns     i64_2b
		or      dl,11h         
		add     eax,100
i64_2b: 	test    eax,eax        
		jz      i64_2c
		and     dl,01bh        
i64_2c: 	mov     byte ptr [_sr],dl
        	and     eax,0ffh
        	mov     dl,byte ptr [_hex2bcd+eax]
        	writeb
		mov     eax,18
		ret


;
; Scc <ea>
; Tableusage 0- rout 1- disrout 2-register*4+d 3-ea write rout 4-handle routine
;            5- cycle count/false  6-cycle count/true
; Flag: NONE
;


                ALIGN32

i65_:		mov     eax,dword ptr [edi+16]
		call    eax
		mov     eax,dword ptr [edi+12]
		mov     ebx,dword ptr [edi+8]
        	test    dl,dl
		jz      i65false
		mov     dl,-1
		call    eax
		mov     eax,dword ptr [edi+24]
		ret
i65false:	call    eax
		mov     eax,dword ptr [edi+20]
		ret


;
; STOP #xxx.W
; Flag:  Set to immediate operand
;


                ALIGN32

i66_:           test    byte ptr [_sr + 1],020h
                jz      privilegie_violation
                mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                mov     dword ptr [_cpustopflag],1
                mov     dword ptr [_cpu_next],-1
                mov     ebx,edx
                call    updatesr
#ifdef DEBUGBUILD
; Log code from here
                mov     eax,dword ptr _loglast
                and     eax,EVENTMASK
                shl     eax,6
                cmp     dword ptr _logstop,1
                jne     i66no
                mov     dword ptr _logbuffer[eax],EVSTOP
                mov     ebx,dword ptr _frames
                mov     dword ptr _logbuffer+4[eax],ebx
                mov     ebx,dword ptr _ypos
                mov     dword ptr _logbuffer+8[eax],ebx
                mov     ebx,dword ptr _xpos
                mov     dword ptr _logbuffer+12[eax],ebx
                mov     ebx,dword ptr _pc
                PTR_TO_PC ebx
                mov     dword ptr _logbuffer+16[eax],ebx
                inc     dword ptr _loglast
                mov     ebx,dword ptr _loglast
                sub     ebx,dword ptr _logfirst
                cmp     ebx,EVENTCOUNT
                jne     i66no
                inc     dword ptr _logfirst
i66no:                               ; Exit point when logging isnt enabled
; Log code ended here
#endif
                test    dword ptr [_cpustopflag],1      ; Awful hack
                jz      i66ah
                mov     esp,dword ptr [_exceptionstack]
                jmp     return_from_stop_   ; Stop messes up my scheme
                                            ; This stub will clean up,
                                            ; and enter the bus-loop afterwrds.
i66ah:          mov     eax,16
                ret


;
; SUB.X <ea>,Dn / SUB.X Dn,<ea>
; Flag: ALL, X=C
;


                ALIGN32

i67_B_1_:       mov     eax,dword ptr [edi+12]
                mov     edx,dword ptr [edi+8] 
                call    eax                   
                mov     ebx,dword ptr [edi+16]
                mov     dh,byte ptr [ebx]     
                sub     dh,dl                 
                pushfd                        
                pop     eax                   
                and     eax,0fffh             
                mov     byte ptr [ebx],dh     
                mov     eax,dword ptr [_statustab+4*eax]
                mov     byte ptr [_sr],al          
                mov     eax,dword ptr [edi+20]   
                ret                              


                ALIGN32

i67_W_1_:       mov     eax,dword ptr [edi+12] 
                mov     edx,dword ptr [edi+8]  
                call    eax                    
                mov     ebx,dword ptr [edi+16] 
                mov     cx,word ptr [ebx]      
                sub     cx,dx                  
                pushfd                         
                pop     eax                    
                and     eax,0fffh              
                mov     word ptr [ebx],cx      
                mov     eax,dword ptr [_statustab+4*eax]
                mov     byte ptr [_sr],al       
                mov     eax,dword ptr [edi+20]
                ret

                ALIGN32

i67_L_1_:       mov     eax,dword ptr [edi+12]
                mov     edx,dword ptr [edi+8] 
                call    eax                   
                mov     ebx,dword ptr [edi+16]
                mov     ecx,dword ptr [ebx]   
                sub     ecx,edx               
                pushfd                        
                pop     eax                   
                and     eax,0fffh             
                mov     dword ptr [ebx],ecx   
                mov     eax,dword ptr [_statustab+4*eax]
                mov     byte ptr [_sr],al       
                mov     eax,dword ptr [edi+20]
                ret                           


                ALIGN32

i67_B_2_:       mov     eax,dword ptr [edi+12]
                mov     edx,dword ptr [edi+8] 
                call    eax                   
                mov     ebx,dword ptr [edi+16]
                mov     dh,byte ptr [ebx]     
                sub     dl,dh                 
                pushfd                        
                pop     eax                   
                and     eax,0fffh             
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ecx,dword ptr [edi+24]   
                mov     byte ptr [_sr],al          
                mov     ebx,dword ptr [edi+8]
                call    ecx                      
                mov     eax,dword ptr [edi+20]   
                ret                              


                ALIGN32

i67_W_2_:       mov     eax,dword ptr [edi+12]
                mov     edx,dword ptr [edi+8] 
                call    eax                   
                mov     ebx,dword ptr [edi+16]
                mov     cx,word ptr [ebx]     
                sub     dx,cx                 
                pushfd                        
                pop     eax                   
                and     eax,0fffh             
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ecx,dword ptr [edi+24]   
                mov     byte ptr [_sr],al          
                mov     ebx,dword ptr [edi+8]
                call    ecx                      
                mov     eax,dword ptr [edi+20]   
                ret                              
                                         

                ALIGN32

i67_L_2_:       mov     eax,dword ptr [edi+12]
                mov     edx,dword ptr [edi+8]
                call    eax
                mov     ebx,dword ptr [edi+16]
                mov     ecx,dword ptr [ebx]
                sub     edx,ecx
                pushfd 
                pop     eax 
                and     eax,0fffh
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ecx,dword ptr [edi+24]
                mov     byte ptr [_sr],al       
                mov     ebx,dword ptr [edi+8]
                call    ecx                    
                mov     eax,dword ptr [edi+20] 
                ret                            


;
; SUBA.W/L <ea>,An
; No flags.
;


		ALIGN32

public i68_W_
i68_W_:		mov	eax, dword ptr [edi + 8]
		mov	edx, dword ptr [edi + 4]
		call	eax
		mov	ebx, dword ptr [edi + 12]
		mov	ecx, dword ptr [ebx]
		movsx	edx, dx
		sub	ecx, edx
		mov	dword ptr [ebx], ecx
		mov	eax, dword ptr [edi + 16]
		ret


		ALIGN32

public i68_L_
i68_L_:		mov	eax, dword ptr [edi + 8]
		mov	edx, dword ptr [edi + 4]
		call	eax
		mov	ebx, dword ptr [edi + 12]
		mov	ecx, dword ptr [ebx]
		sub	ecx, edx
		mov	dword ptr [ebx], ecx
		mov	eax, dword ptr [edi + 16]
		ret


;
; SUBI.X #,<ea>
;  0-routineptr 1-disasm routine  2-eareg 3-ea read routine
;                4-cycle count    5-ea write routine               
; Flag: ALL, X=C
;


                ALIGN32

i69_B_:  	mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                mov     ebx,edx
                mov     eax,dword ptr [edi+12]   
                mov     edx,dword ptr [edi+8]    
                call    eax                      
                sub     dl,bl                    
                pushfd                           
                pop     eax                      
                and     eax,0fffh                
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ecx,dword ptr [edi+20]  
                mov     byte ptr [_sr],al         
                mov     ebx,dword ptr [edi+8]
                call    ecx                     
                mov     eax,dword ptr [edi+16]  
                ret                             


                ALIGN32

i69_W_:         mov     ecx,esi
                fetchwopcode_inc_pos
                add     esi,2
                mov     ebx,edx
                mov     eax,dword ptr [edi+12]  
                mov     edx,dword ptr [edi+8]   
                call    eax                     
                sub     dx,bx                   
                pushfd                          
                pop     eax                     
                and     eax,0fffh               
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ecx,dword ptr [edi+20]
                mov     byte ptr [_sr],al       
                mov     ebx,dword ptr [edi+8]
                call    ecx                   
                mov     eax,dword ptr [edi+16]
                ret                           


                ALIGN32

i69_L_:         mov     ecx,esi
                fetchlopcode_inc_pos
                add     esi,4
                mov     ebx,edx
                mov     eax,dword ptr [edi+12]   
                mov     edx,dword ptr [edi+8]    
                call    eax                      
                sub     edx,ebx                  
                pushfd                           
                pop     eax                      
                and     eax,0fffh                
                mov     eax,dword ptr [_statustab+4*eax]
                mov     ecx,dword ptr [edi+20]
                mov     byte ptr [_sr],al      
                mov     ebx,dword ptr [edi+8]
                call    ecx                   
                mov     eax,dword ptr [edi+16]
                ret


;
; SUBQ.X #,<ea>
; Flag: ALL, X=C
;


                ALIGN32

public i70_B_
i70_B_:		mov     eax,dword ptr [edi+12]
		mov     edx,dword ptr [edi+8] 
		call    eax                   
		mov     ebx,dword ptr [edi+24]
		sub     dl,bl                 
		pushfd                        
		pop     eax                   
		and     eax,0fffh             
		mov     ecx,dword ptr [edi+20]
		mov     eax,dword ptr [_statustab+4*eax]
		mov     byte ptr [_sr],al      
		mov     ebx,dword ptr [edi+8]
		call    ecx                   
		mov     eax,dword ptr [edi+16]
		ret                           


                ALIGN32

public i70_w_
i70_W_:		mov     eax,dword ptr [edi+12]
		mov     edx,dword ptr [edi+8] 
		call    eax                   
		mov     ebx,dword ptr [edi+24]
		sub     dx,bx                  
		pushfd                         
		pop     eax                    
		and     eax,0fffh              
		mov     eax,dword ptr [_statustab+4*eax]
		mov     ecx,dword ptr [edi+20]
		mov     byte ptr [_sr],al      
		mov     ebx,dword ptr [edi+8]
		call    ecx                   
		mov     eax,dword ptr [edi+16]
		ret                           


                ALIGN32

public i70_l_
i70_L_:		mov     eax,dword ptr [edi+12]
		mov     edx,dword ptr [edi+8] 
		call    eax                   
		mov     ebx,dword ptr [edi+24]
		sub     edx,ebx               
		pushfd                        
		pop     eax                   
		and     eax,0fffh             
		mov     eax,dword ptr [_statustab+4*eax]
		mov     ecx,dword ptr [edi+20]
		mov     byte ptr [_sr],al      
		mov     ebx,dword ptr [edi+8]
		call    ecx                   
		mov     eax,dword ptr [edi+16]
		ret                           


                ALIGN32

public i70_adr_
i70_ADR_:	mov     eax,dword ptr [edi+8]
		mov     edx,dword ptr [eax]
		mov     ebx,dword ptr [edi+24]
		sub     edx,ebx            
		mov     dword ptr [eax],edx
		mov     eax,dword ptr [edi+16]
		ret                           


;
; Instruction 71   SUBX.X Dy,Dx    SUBX.X -(Ay),-(Ax)
; Tableusage  2 - rx*4(dest)  3 - ry*4
; Flagg: ALL, Z unchanged if result non-zero
;


                ALIGN32

public i71_B_1_
i71_B_1_:       mov     ebx,dword ptr [12+edi]         
                mov     ecx,dword ptr [8+edi]          
                mov     al,byte ptr [ebx]          
                mov     bl,byte ptr [ecx]          
                mov     edx,dword ptr [_sr]
                test    dl,10h
                jz      i71b1nc
                stc     
i71b1nc:        sbb     bl,al
                pushfd                             
                pop     eax                        
                and     eax,0fbfh                  
                mov     byte ptr [ecx],bl          
                mov     eax,dword ptr [_statustab+4*eax]
                and     dl,4                            ; Preserve Z
                test    bl,bl                           ; Clear if nonzero
                jz      i71b1nz
                xor     dl,dl
i71b1nz:        or      dl,al
                mov     dword ptr [_sr],edx
                mov     eax,4
                ret


                ALIGN32

public i71_W_1_
i71_W_1_:       mov     ebx,dword ptr [12+edi]         
                mov     ecx,dword ptr [8+edi]          
                mov     eax,dword ptr [ebx]             
                mov     ebx,dword ptr [ecx]             
                mov     edx,dword ptr [_sr]
                test    dl,10h
                jz      i71w1nc
                stc     
i71w1nc:        sbb     bx,ax
                pushfd         
                pop     eax    
                and     eax,0fbfh
                mov     word ptr [ecx],bx
                mov     eax,dword ptr [_statustab+4*eax]
                and     dl,4                            ; Preserve Z
                test    bx,bx                           ; Clear if nonzero
                jz      i71w1nz
                xor     dl,dl
i71w1nz:        or      dl,al
                mov     dword ptr [_sr],edx
                mov     eax,4
                ret


                ALIGN32

public i71_L_1_
i71_L_1_:       mov     ebx,dword ptr [12+edi]
                mov     ecx,dword ptr [8+edi]
                mov     eax,dword ptr [ebx]
                mov     ebx,dword ptr [ecx]
                mov     edx,dword ptr [_sr]
                test    dl,10h
                jz      i71l1nc
                stc     
i71l1nc:        sbb     ebx,eax
                pushfd                         
                pop     eax                    
                and     eax,0fbfh              
                mov     dword ptr [ecx],ebx    
                mov     eax,dword ptr [_statustab+4*eax]
                and     dl,4                            ; Preserve Z
                test    ebx,ebx                         ; Clear if nonzero
                jz      i71l1nz
                xor     dl,dl
i71l1nz:        or      dl,al
                mov     dword ptr [_sr],edx
                mov     eax,8
                ret


                ALIGN32

public i71_B_2_
i71_B_2_:      	mov     ebx,dword ptr [12+edi]        ; Source
                mov     ecx,dword ptr [ebx]
                dec     ecx
                cmp     ebx,dword ptr [_a7pointer]
                jne     i71_B_2j
                dec     ecx
i71_B_2j:       mov     dword ptr [ebx],ecx
                fetchb
                mov     eax,dword ptr [8+edi]         ; Dest
                mov     ecx,dword ptr [eax]
                dec     ecx
                cmp     eax,dword ptr [_a7pointer]
                jne     i71_B_2i
                dec     ecx
i71_B_2i:       push    ecx
                mov     dword ptr [eax],ecx
                fetchb
                mov     ebx,edx
                mov     eax,dword ptr [_sr]
                test    al,10h
                jz      i71b2nc
                stc     
i71b2nc:        sbb     dl,bl
                pushfd                             
                pop     ecx                        
                and     ecx,0fbfh                  
                mov     ecx,dword ptr [_statustab+4*ecx]
                and     al,4                            ; Preserve Z
                test    dl,dl                           ; Clear if nonzero
                jz      i71b2nz
                xor     al,al
i71b2nz:        or      al,cl
                mov     dword ptr [_sr],eax            
                pop     ecx
                writeb
                mov     eax,18
                ret


                ALIGN32

public i71_W_2_
i71_W_2_:   	mov     ebx,dword ptr [12+edi]        ; Source
                mov     ecx,dword ptr [ebx]
                sub     ecx,2
                mov     dword ptr [ebx],ecx
                fetchw
                mov     ebx,edx
                mov     eax,dword ptr [8+edi]         ; Dest
                mov     ecx,dword ptr [eax]
                sub     ecx,2
                mov     dword ptr [eax],ecx
                push    ecx
                fetchw
                mov     eax,dword ptr [_sr]
                test    al,10h
                jz      i71w2nc
                stc     
i71w2nc:        sbb     dx,bx
                pushfd             
                pop     ecx        
                and     ecx,0fbfh  
                mov     ecx,dword ptr [_statustab+4*ecx]
                and     al,4                            ; Preserve Z
                test    dx,dx                           ; Clear if nonzero
                jz      i71w2nz
                xor     al,al
i71w2nz:        or      al,cl
                mov     dword ptr [_sr],eax         
                pop     ecx
                writew
                mov     eax,18
                ret


                ALIGN32

public i71_L_2_
i71_L_2_: 	mov     ebx,dword ptr [12+edi]        ; Source 
                mov     ecx,dword ptr [ebx]
                sub     ecx,4
                mov     dword ptr [ebx],ecx
                fetchl
                mov     ebx,edx
                mov     eax,dword ptr [8+edi]         ; Dest
                mov     ecx,dword ptr [eax]
                sub     ecx,4
                mov     dword ptr [eax],ecx
                push    ecx
                fetchl
                mov     eax,dword ptr [_sr]
                test    al,10h
                jz      i71l2nc
                stc     
i71l2nc:        sbb     edx,ebx
                pushfd                          
                pop     ecx                     
                and     ecx,0fbfh               
                mov     ecx,dword ptr [_statustab+4*ecx]
                and     al,4                            ; Preserve Z
                test    edx,edx                         ; Clear if nonzero
                jz      i71l2nz
                xor     al,al
i71l2nz:        or      al,cl
                mov     dword ptr [_sr],eax
                pop     ecx
                writel
                mov     eax,30
                ret


;
; Instruction SWAP.W <ea>
; Tableusage 0 - routine  1 - disrout  2 - reg 
; Flag: NZ, V=C=0, X unaffected
;


                ALIGN32

public i72_	
i72_:		mov     eax,dword ptr [edi+8]
		mov     ebx,dword ptr [eax]
		ror     ebx,16
		mov     dword ptr [eax],ebx
		test	ebx,ebx
		pushfd
		pop	ecx
		mov     eax,dword ptr [_sr]
		and	ecx,0c0h
		and	al,010h
		shr	ecx,4
		or	eax,ecx
		mov     dword ptr [_sr],eax
		mov     eax,4
		ret


;
; Instruction TAS.B <ea>
; Tableusage 0-routine  1-disrout  2-eareg  3-eale_srout 4-eawriterout 5-cycletime
; Flag: NZ, V=C=0, X unaffected
;


                ALIGN32

public i73_
i73_:		mov     edx,dword ptr [edi+8]
		mov     ecx,dword ptr [edi+12]
		call    ecx
		test    dl,dl
		pushfd
		pop	ecx
		mov     eax,dword ptr [_sr]
		and	ecx,0c0h
		and     al,010h
		shr	ecx,4
		or      dl,80h
		or	eax,ecx
		mov     dword ptr [_sr],eax
		mov     ecx,dword ptr [edi+16]
		mov     ebx,dword ptr [edi+8]
		call    ecx
		mov     eax,dword ptr [edi+20]
		ret


;
; Instruction TRAP #
; Tableusage 0 - routine  1 - disrout  2 - vector*4+80h
; Flag: none
;


                ALIGN32

public i74_
i74_:           mov     ebx,dword ptr [edi+8]
                mov     eax,38
                jmp     prepare_exception_


;
; Instruction TRAPV      jumps to routine specified at $00001c
; Tableusage 0 - routine  1 - disrout  
; Flag: none
;


                ALIGN32

public i75_
i75_:           test    byte ptr [_sr],2
                jz      i75notra
                mov     ebx,01ch
                mov     eax,34
                jmp     prepare_exception_
i75notra:       mov     eax,4
                ret


;
; TST.? <ea>
; tableusage 0 - routine  1 - disrout  2-eareg  3-ea_lesrout  4-cycle count
; Flag: NZ, V=C=0, X unaffected
;


                ALIGN32

public i76_B_
i76_B_:		mov     eax,dword ptr [edi+12]
		mov     edx,dword ptr [edi+8]
		call    eax
		test    dl,dl
		pushfd
		pop     eax
		mov     ecx,dword ptr [_sr]
		and     eax,0c0h
		and	cl,010h
		shr	eax,4
		or	ecx,eax
		mov     dword ptr [_sr],ecx
		mov     eax,dword ptr [edi+16]
		ret

		
                ALIGN32

public i76_W_
i76_W_:		mov     eax,dword ptr [edi+12]
		mov     edx,dword ptr [edi+8]
		call    eax
		test    dx,dx
		pushfd
		pop     eax
		mov     ecx,dword ptr [_sr]
		and     eax,0c0h
		and	cl,010h
		shr	eax,4
		or	ecx,eax
		mov     dword ptr [_sr],ecx
		mov     eax,dword ptr [edi+16]
		ret


                ALIGN32

public i76_L_
i76_L_:		mov     eax,dword ptr [edi+12]
		mov     edx,dword ptr [edi+8]
		call    eax
		test    edx,edx
		pushfd
		pop     eax
		mov     ecx,dword ptr [_sr]
		and     eax,0c0h
		and	cl,010h
		shr	eax,4
		or	ecx,eax
		mov     dword ptr [_sr],ecx
		mov     eax,dword ptr [edi+16]
		ret

	
	
;
; Instruction UNLK An
; tabellusage 0 - routine  1 - disrout  2 - Register
; Flag: none
;


                ALIGN32

public i77_
i77_:           mov     ebx,dword ptr [edi+8]
                mov     ecx,dword ptr [ebx]
                mov     edx,ecx
                add     edx,4
                mov     dword ptr [_a+28],edx
                fetchl
                mov     dword ptr [ebx],edx
                mov     eax,12
                ret

                ALIGN32


public i02tsc_before_
i02tsc_before_:
	
		TSC_BEFORE _i02tsc_tmp
		ret

		ALIGN32
	
public i02tsc_after_
i02tsc_after_:
		TSC_AFTER _i02tsc_tmp, _i02tsc, _i02tsc_times
		ret
	
public i12tsc_before_
i12tsc_before_:
	
		TSC_BEFORE _i12tsc_tmp
		ret

		ALIGN32
	
public i12tsc_after_
i12tsc_after_:
		TSC_AFTER _i12tsc_tmp, _i12tsc, _i12tsc_times
		ret
	
public i37tsc_before_
i37tsc_before_:
	
		TSC_BEFORE _i37tsc_tmp
		ret

		ALIGN32
	
public i37tsc_after_
i37tsc_after_:
		TSC_AFTER _i37tsc_tmp, _i37tsc, _i37tsc_times
		ret
	
                ALIGN32


public i37head_before_
i37head_before_:
	
		TSC_BEFORE _i37head_tmp
		ret

		ALIGN32
	
public i37head_after_
i37head_after_:
		TSC_AFTER _i37head_tmp, _i37head, _i37head_times
		ret
	

		ALIGN32
_TEXT ends

_DATA segment para public 'DATA'

include data\fellow.inc
include data\memory.inc

	

	
#ifdef DEBUGBUILD
include data\log.inc
#endif

include data\floppy.inc
include data\sound.inc
include data\68000.inc
include data\68030.inc
include data\bus.inc
include data\copper.inc
include data\blit.inc
include data\draw.inc
include data\rtarea.inc
			
extern _t:dword
extern _bus_blitter_delay:dword

public _i02tsc
public _i02tsc_times
_i02tsc:     dd      0,0
_i02tsc_tmp:  dd      0,0
_i02tsc_times:  dd      0

public _i12tsc
public _i12tsc_times
_i12tsc:     dd      0,0
_i12tsc_tmp:  dd      0,0
_i12tsc_times:  dd      0

public _i37tsc
public _i37tsc_times
_i37tsc:     dd      0,0
_i37tsc_tmp:  dd      0,0
_i37tsc_times:  dd      0

public _i37head
public _i37head_times
_i37head:     dd      0,0
_i37head_tmp:  dd      0,0
_i37head_times:  dd      0


upsrtraceset: db 0
cpu_cycles: dd 0

rte_stackinc:	dd	0, 0, 4, 4, 8, 0, 0, 52, 50, 10, 24, 84, 16, 18, 0, 0
_DATA ends

_BSS segment dword public 'DATA'
_BSS ends
end





